2012-05-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.3

	* ChangeLog: Update for patch release 5.32.3.

	* cc-defs.el (c-version): Increment to 5.32.3.

	* *.el, cc-mode.texi: Add 2012 to copyright notices.

2012-04-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix erroneous commit.

2012-04-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Adding a ) can hide the resulting (..) from searches.  Fix it.

	* cc-engine (c-append-lower-brace-pair-to-state-cache): Bound the
	backward search to the position of the existing (.

2012-04-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Ensure searching for keywords is case sensitive.

        * cc-cmds.el (c-electric-brace, c-electric-lt-gt)
	(c-electric-paren c-beginning-of-defun, c-end-of-defun)
	(c-defun-name, c-mark-function c-cpp-define-name)
	(c-comment-indent, c-scan-conditionals c-indent-defun)
	(c-context-line-break): bind case-fold-search to nil.

	* cc-mode.el (c-font-lock-fontify-region): bind case-fold-search
	to nil.

2012-04-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Make imenu work again for Objective C Mode.
	* cc-menus.el (cc-imenu-objc-generic-expression): Correct the
	*-index values, these having been disturbed by a previous change
	in 2011-08.

2012-04-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct two search limits in c-before-change-check_<>-operators.
	* cc-engine.el (c-before-change-check-<>-operators): Make the
	correction.

	* cc-mode.texi (c-offsets-alist): Correct a typo.

2012-03-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Further optimise the handling of large macros.

	* cc-engine.el (c-crosses-statement-barrier-p): Use a limit to a
	call of `c-literal-limits'.
	(c-determine-+ve-limit): New function.
	(c-at-macro-vsemi-p): Move `c-in-literal' to the bottom of an `and'.
	(c-guess-basic-syntax): In macros, restrict a search limit to
	2000.  In CASE 5B, restrict a search limit to 500.
	(c-just-after-func-arglist-p): Obviouly wrong `or' -> `and'.

	* cc-mode.el (c-neutralize-syntax-in-and-mark-CPP): Restrict
	macro bounds to +-500 from after-change's BEG END.

2012-03-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mark-defun): Leave a mark, and extend region when
	command is repeated.

2012-03-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Depessimize the handling of very large macros.

	* cc-engine.el (c-macro-cache, c-macro-cache-start-pos):
	(c-macro-cache-syntactic): New variables to implement a one
	element macro cache.
	(c-invalidate-macro-cache): New function.
	(c-beginning-of-macro, c-end-of-macro, c-syntactic-end-of-macro):
	Adapt to use the new cache.
	(c-state-safe-place): Use better the cache of safe positions.
	(c-state-semi-nonlit-pos-cache)
	(c-state-semi-nonlit-pos-cache-limit): New variables for...
	(c-state-semi-safe-place): New function.  Here, in a macro is
	"safe".
	(c-invalidate-state-cache-1): New stuff for
	c-state-semi-safe-place.
	(c-in-literal, c-literal-limits, c-determine-limit-get-base): Use
	c-state-semi-safe-place.

	* cc-langs.el (c-get-state-before-change-functions): Add
	c-invalidate-macro-cache to the C, C++, Obj entries.

2012-03-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Optimise macro handling with a 1 element cache of beginning and
	end.  Make the default of c-macro-names-with-semicolon nil.  See
	2012-03-02 for details.

2012-02-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Optimise c-state-safe-place.  See 2012-03-02 for details.

2012-02-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Create .hgignore.  Delete the two old .cvsignore's.

2012-02-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Modify the web pages for recent conversion to Mercurial.

	* hgaccess.php: New file.
	* anoncvs.php: Mark old CVS repository as obsolete, change to
	past tense.
	* index.php: Direct the adventurous to hg rather than cvs.
	* links.h: Add new links for hg pages.  Move cvs pages to new
	"obsolete" section.

2012-02-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Remove old CVSROOT directory.

2012-02-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix a loop in c-set-fl-decl-start.
	* cc-engine.el (c-set-fl-decl-start): Add a check that
	c-backward-syntactic-ws actually moves backwards.

2012-02-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix infinite loop with long macros.
	* cc-engine.el (c-state-safe-place): Handle macros properly.

2012-02-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix spurious recognition of c-in-knr-argdecl.

	* cc-engine.el (c-in-knr-argdecl): Check for '=' in a putative K&R
	region.

2012-02-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Test for keyword @implementation in a #pragma.  This used to
	loop.

2012-02-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-objc-directive): Prevent looping in
	"#pragma mark @implementation".

2012-01-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Eliminate sluggishness and hangs in fontification of "semicolon
	deserts".

	* cc-engine.el (c-state-nonlit-pos-interval): change value 10000
	-> 3000.
	(c-state-safe-place): Reformulate so it doesn't stack up an
	infinite number of wrong entries in c-state-nonlit-pos-cache.
	(c-determine-limit-get-base, c-determine-limit): New functions to
	determine backward search limits disregarding literals.
	(c-find-decl-spots): Amend commenting.
	(c-cheap-inside-bracelist-p): New function which detects "={".

	* cc-fonts.el (c-make-font-lock-BO-decl-search-function): Give a
	limit to a backward search.
	(c-font-lock-declarations): Fix an occurrence of point being
	undefined.  Check additionally for point being in a bracelist or
	near a macro invocation without a semicolon so as to avoid a
	fruitless time consuming search for a declarator.  Give a more
	precise search limit for declarators using the new
	c-determine-limit.

2012-01-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct a test to do with C-y:
	* cc-mode.el (c-after-change): Correct a singular-plural
	confusion.

2012-01-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix filling for when filladapt mode is enabled.

	* cc-cmds.el (c-fill-paragraph): In the invocation of
	c-mask-paragraph, pass in `fill-paragraph' rather than
	`fill-region-as-paragraph'.  (This is a reversion of a previous
	change.)
	* cc-mode.el (c-basic-common-init): Make
	fill-paragraph-handle-comment buffer local and set it to nil.

2012-01-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix Emacs bug #10463 - put `widen's around the critical spots.

	* cc-engine.el (c-in-literal, c-literal-limits): put a widen
	around each invocation of c-state-pp-to-literal.  Remove an unused
	let variable.

2012-01-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Optimise font locking in long enum definitions.

	* cc-fonts.el (c-font-lock-declarations): Add an extra arm to a
	cond form to handle enums.
	* cc-langs.el (c-enums-contain-decls): New lang variable.
	* cc-mode.el (c-font-lock-fontify-region): Correct a typo.

2011-12-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce a mechanism to widen the region used in context font
	locking.  Use this to protect declarations from losing their
	contexts.

	* cc-langs.el (c-before-font-lock-functions): replace
	c-set-fl-decl-start with c-change-set-fl-decl-start (Renaming).
	(c-before-context-fontification-functions): new defvar, a list of
	functions to be run just before context (etc.) font locking.

	* cc-mode.el (c-extend-font-lock-region-for-macros): new,
	functionality extracted from c-neutralize-syntax-in-and-mark-CPP.
	(c-in-after-change-fontification): new variable.
	(c-after-change): Set c-in-after-change-fontification.
	(c-set-fl-decl-start): Rejig its interface, so it can be called
	from both after-change and context fontifying.
	(c-change-set-fl-decl-start, c-context-set-fl-decl-start): new
	functions.
	(c-standard-font-lock-fontify-region-function): new variable.
	(c-font-lock-fontify-region): new function

2011-12-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix unstable fontification inside templates.

	* cc-langs.el (c-before-font-lock-functions): newly created from
	the singular version.  The (c c++ objc) entry now additionally has
	c-set-fl-decl-start.  The other languages (apart from AWK) have
	that as a single entry.

	* cc-fonts.el (c-font-lock-enclosing-decls): The functionality for
	"local" declarations has been extracted to c-set-fl-decl-start.

	* cc-mode.el: (c-common-init, c-after-change): Changes due to
	pluralisation of c-before-font-lock-functions.
	(c-set-fl-decl-start): New function, extraced from
	c-font-lock-enclosing-decls and enhanced.
	(top level): Only advise the font-lock change functions when
	font-lock-extend-after-change-region-function is not defined.

2011-12-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Convert some British English spellings to American English.

2011-12-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Large brace-block initialisation makes CC Mode slow: Fix.  Tidy up
	and accelerate c-in-literal, etc. by using the c-parse-state
	routines.  Limit backward searching in c-font-lock-enclosing.decl.

	* cc-engine.el (c-state-pp-to-literal): Return the pp-state and
	literal type in addition to the limits.
	(c-state-safe-place): New defun, extracted from
	c-state-literal-at.
	(c-state-literal-at): Use the above new defun.
	(c-slow-in-literal, c-fast-in-literal): Removed.
	(c-in-literal, c-literal-limits): Amended to use
	c-state-pp-to-literal.

	* cc-fonts.el (c-font-lock-enclosing-decls): Check for being in a
	literal.  Add a limit for backward searching.

	* cc-mode.el (awk-mode): Don't alias c-in-literal to
	c-slow-in-literal.

2011-12-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Add the switch statement to AWK Mode.

	cc-awk (awk-font-lock-keywords): Add "switch", "case", "default"
	to the keywords regexp.

	cc-langs (c-label-kwds): Let AWK take the same expression as the
	rest.
	(c-nonlabel-token-key): Allow string literals for AWK.  Refactor
	for the other modes.

2011-10-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix bug #9560, sporadic wrong indentation; improve instrumentation of
	c-parse-state.
	* cc-engine.el (c-append-lower-brace-pair-to-state-cache): correct faulty
	logical expression.

	(c-parse-state-state, c-record-parse-state-state)
	c-replay-parse-state-state): New defvar/defuns.
	(c-debug-parse-state): Use new functions.

2011-10-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.2

	* ChangeLog: Update for patch release 5.32.2.

	* cc-defs.el (c-version): Increment to 5.32.2

2011-10-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Enhance cc-bytecomp-ignore-obsolete to cope with the missing
	function `byte-compile-obsolete' in Emacs >= 24.

	* cc-bytecomp.el (top-level): Add variable cc-bytecomp-push-vars.
	Set this and similar variables to nil each time the file is
	loaded.
	(cc-bytecomp-setup-environment, cc-bytecomp-restore-environment):
	Add clauses to setup and restore "pushed" variables.
	(cc-bytecomp-push): New macro to "push" a variable onto an
	internal stack.
	(cc-bytecomp-ignore-obsolete): Add a superfluous check to suppress
	a compiler warning
	(cc-bytecomp-ignore-obsolete): In Emacs >= 24, use
	byte-compile-not-obsolete-funcs to mark a function as obsolete.

2011-10-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fontify Java @annotations with c-preprocessor-face-name instead of
	c-annotation-face.  Protect against a one line change
	misfontifying an annotation as a variable declaration.  Fix a
	"minor" bug.

	(c-annotation-face): Remove
	(c-basic-matchers-before): Move the stanza for Java @annotations
	here from c-basic-matchers-after.  Replace c-annotation-face by
	c-preprocessor face name.
	(c-font-lock-enclosing-decls): Check that
	c-opt-block-decls-with-vars-key is non-nil before using it.

	annotations-1.face: recalculate this file.

2011-09-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (top level): Add a test for the existence of
	delete-dups.
	* cc-fix.el (top level): (defun delete-dups) when necessary.

2011-09-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/index.php, admin/release.php: Update version to 5.32.1

2011-09-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* ChangeLog: Update for patch release 5.32.1.

	* cc-defs.el (c-version): Increment to 5.32.1

2011-09-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.1

	* cc-defs (c-version): Increment to 5.32.1

2011-09-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features): add-local-hook-test: Put a
	save-excursion round the buffer manipulation.  Error detected by
	XEmacs byte compiler.

2011-09-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el: Reapply the change up to revision 5.232.

2011-09-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-menus.el: Reapply the change up to revision 5.87.

2011-09-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* All .el files: Correct the copyright and license statements for
	release 5.32.

	* cc-defs.el (c-next-single-property-change)
	(c-search-backward-char-property): For XEmacs, only use
	next/previous-single-char-property-change in versions >=
	2005-01-25

2011-09-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Restore to the state of Release_5_32.

2011-08-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el: Fix - typing on a C++ inher-intro or inher-cont
	line should preserve the fontification of the inherited class
	names.  Analogously for namespace names and Java import, extends,
	etc.

	* cc-fonts.el (c-make-font-lock-BO-decl-search-function): New
	function.
	(c-basic-matchers-after - "Fontify the clauses after various
	keywords"): Extract the three keyword lists for the 3 erroneous
	constructs from the list of four, and use the new function above
	in place of an old one.

2011-08-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-menus.el (cc-imenu-c++-generic-expression): Make it handle
	function pointer parameters properly.

2011-08-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Update the "recent changes" pointer to 5.32.

2011-08-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.32

	Use `make-local-hook' only when it's needed.

	* cc-defs.el (c-emacs-features): Add 'add-hook-local into c-emacs-features
	when make-local-hook is required.

	* cc-mode.el (c-basic-common-init, c-font-lock-init): Test c-emacs-features
	for 'add-hook-local.

	* cc-styles.el (c-make-styles-buffer-local): Test c-emacs-features for
	'add-hook-local.


	* cc-defs.el (c-search-forward-char-property):  Streamline by using
	c-next-single-property-change.

	* cc-engine.el:  Correct typos.

2011-08-20  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Resolve invalid use of a regexp in regexp-opt.

	* cc-fonts.el (c-complex-decl-matchers): Add in special detection for a
	java annotation.

	* cc-engine.el (c-forward-decl-or-cast-1): Add in special detection for a
	java annotation.

	* cc-langs.el (c-prefix-spec-kwds-re): Remove the special handling for
	java.
	(c-modifier-kwds): Remove the regexp "@[A-za-z0-9]+".

	* cc-fonts.el: Tidy up font locking of a long CPP construct.

	* cc-fonts.el (c-guess-font-lock-context): eliminate this somewhat pompous
	defun.
	(c-font-lock-complex-decl-prepare): replace a call to the above with
	inline code.


	Fontify CPP expressions correctly when starting in the middle of such a
	construct.  Mainly for when jit-lock etc. starts a chunk here.

	* cc-fonts.el (c-font-lock-context): new buffer local variable.
	(c-make-font-lock-search-form): new function, extracted from
	c-make-font-lock-search-function.
	(c-make-font-lock-search-function): Use the above function.
	(c-make-font-lock-context-search-function): New function.
	(c-cpp-matchers): Enhance the preprocessor expression case with the above
	function
	(c-font-lock-complex-decl-prepare):  Test for being in a CPP form which
	takes an expression.

	* cc-langs.el (c-cpp-expr-intro-re): New lang-variable.

2011-08-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-lt-gt): Remove an unused dynamic variable.


	Reduce the number of compilation warnings:

	* cc-awk.el (c-awk-get-NL-prop-cur-line): Replace `delete-backward-char' by
	`delete-char'.

	* cc-cmds.el (c-electric-lt-gt, c-beginning-of-defun): Remove unused
	dynamic variables.

	* cc-engine.el (top level): Add a cc-bytecomp-defun and a
	cc-bytecomp-defvar.
	(c-ssb-lit-begin, c-forward-<>-arglist-recur):
	(c-just-after-func-arglist-p, c-looking-at-decl-block):
	(c-append-to-state-cache): Remove unused dynamic variables.

	* cc-fonts.el (c-font-lock-enum-tail): Remove an unused dynamic variable.

	* cc-guess.el (top level): Add three cc-bytecomp-defvars.

	* cc-menus.el (cc-imenu-objc-function): Remove an unused dynamic variable.

	* cc-mode.el (top level): Add three cc-bytecomp-defvars.

	* tests/macro-27.cc, tests/macro-27.face, tests/macro-27.res:
	Test "macros with semicolons".

2011-08-15  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Adapt recent changes to work with XEmacs.

	* cc-cmds.el (c-where-wrt-brace-construct): Replace a looking-at with
	a call to c-looking-at-non-alphnumspace, because XEmacs doesn't have
	\s!.
	(c-defun-name): Adapt a regexp not to use \_>.

	* cc-defs.el (c-next-single-property-change): new macro.
	(c-<-as-paren-syntax, c->-as-paren-syntax: Adapt for use as a simple
	value (as well as for category properties).
	(c-put-property-fun, c-put-char-property): wrap in eval-and-compile.
	(c-use-category): new compile-time constant.
	(c-search-forward-char-property):
	(c-clear-char-property-with-value-function):
	(c-clear-char-property-with-value-function, c-mark-<-as-paren):
	(c-mark->-as-paren, c-unmark-<->-as-paren): small changes.
	(c-sc-scan-lists-no-category+1+1, c-sc-scan-lists-no-category+1-1):
	(c-sc-scan-lists-no-category-1-1, c-sc-scan-lists-no-category-1-1):
	(c-sc-scan-lists, c-sc-parse-partial-sexp-no-category):
	(c-sc-parse-partial-sexp): new macrofications of scan-lists and
	parse-partial-sexp, for use in c-parse-state.
	(c-looking-at-non-alphnumspace): new macro.
	(c-emacs-features): Introduce new component category-properties.

	* cc-engine.el (several defuns): Replace next-single-property-change by
	c-next-single-property-change.
	(c-state-cache-non-literal-place): Correct, to avoid the inside of
	macros.
	(c-state-balance-parens-backwards):
	(c-append-lower-brace-pair-to-state-cache, c-state-push-any-brace-pair):
	(c-append-to-state-cache, c-remove-stale-state-cache):
	(c-remove-stale-state-cache-backwards): Replace scan-lists by
	c-sc-scan-lists and parse-partial-sexp by c-sc-parse-partial-sexp.
	(c-invalidate-state-cache, c-parse-state): small changes.
	(c-find-decl-spots): Enhance initialisation of cfd-prop-match to take
	account of a possible c-decl-end c-type property on the last token before
	the region.
	(c-clear-<-pair-props, c-clear->-pair-props): use c-unmark-<->-as-paren.
	(c-before-change-check-<>-operators): Search for syntax-table rather than
	category property.

	* cc-fonts.el (c-skip-comments-and-strings): Use
	c-next-char-propery-change.
	(c-cpp-matchers): Use c-unmark-<->-as-paren.
	(c-font-lock-invalid-string): Use characterp rather than integerp in
	XEmacs, since characters are not integers.

	* cc-mode.el (c-neutralize-syntax-in-and-mark-CPP): Test for category
	properties (i.e. GNU Emacs) before deleting them.
	(c-before-change): replace next-single-property-change by
	c-next-single-property-change.
	(c-after-change): Make an Emacs dependent category property related
	correction dependent on the existence of category properties.

2011-07-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/bitfield-2.c, tests/bitfield-2.face, tests/bitfield-2.res:
	bitfield-2.c: New file to test awkward fontification of bitfields.


	Fontify bitfield declarations properly.

	* cc-langs.el (c-has-bitfields): New lang variable.
	(c-symbol-chars): Now exported as a lang variable.
	(c-not-primitive-type-keywords): New lang variable.

	* cc-fonts.el (c-font-lock-declarations): Jump over the QT keyword "more"
	to prevent "more slots: ...." being spuriously parsed as a bitfield
	declaraion.

	* cc-engine.el (c-beginning-of-statement-1): Refactor and enhance to handle
	bitfield declarations.
	(c-punctuation-in): New function.
	(c-forward-decl-or-cast-1): Enhance CASE 3 to handle bitfield
	declarations properly.

2011-07-22  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Prevent cc-langs.elc being loaded at run time.

	* cc-mode.el: Remove two autoload forms which loaded cc-langs.

	* cc-langs.el (c-make-init-lang-vars-fun): Don't emit "(require 'cc-langs)".
	Quote a form so it will evaluate at (cc-mode's) compilation time.

2011-07-21  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Fontify declarators properly when, e.g., a jit-lock chunk begins inside a
	declaration.

	* cc-langs.el (c-symbol-chars): Correct a typo.

	* cc-fonts.el (c-font-lock-enclosing-decls): New function.
	(c-complex-decl-matchers): Insert reference to
	c-font-lock-enclosing-decls.

	* cc-engine.el (c-backward-single-comment, c-backward-comments): Bind
	open-paren-in-column-0-is-defun-start to nil around calls to
	(forward-comment -1).

2011-07-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-styles.el, Makefile, cc-guess.el, cc-langs.el, cc-mode.el:

	* cc-guess.el: Update this and Make it an integral part of CC Mode.

	* cc-langs.el (c-mode-menu): Added "Style..." submenu.

	* cc-styles.el (cc-choose-style-for-mode): New function derived from
	`c-basic-common-init'.

	* cc-mode.el (top-level): Require cc-guess.  (c-basic-common-init): Use
	`cc-choose-style-for-mode'.

	* cc-mode.texi (Guessing the Style): New page.  (Styles): Add a short
	introduction to above.

	Makefile: Change the position of cc-guess.el.

2011-06-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, tests/templates-19.cc:
	cc-engine (c-guess-continued-construct): Correct the handling of
	template-args-cont, particularly for when font lock is disabled.  Name
	this case as "CASE G".

	templates-19.c: Reindent.

2011-06-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	1: Whilst checking for declarators, disable
	knr checking to speed up for normal files.  2: Refactor, replacing a
	sequence of nested if forms by a cond form.

2011-03-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax):
	Move CASE 19 to a different place, correctly to
	process template-args-cont lines.

2011-02-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-continued-construct): In three places, replace
	`lim' with 'containing-sexp'.

	* cc-engine.el (c-guess-continued-construct):
	In three places, replace `paren-state'
	with 'containing-sexp'.


	Fix an infinite loop which happens when a template construct straddles a
	jit-lock boundary.

	* cc-engine.el (c-forward-<>-arglist-recur): recast nested `if's as a
	`cond' form.

	* cc-fonts.el (c-font-lock-declarations): Remove a harmful narrowing to
	region being fontified.

2011-02-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-state-literal-at):
	Prevent positions in macros finding their way into
	c-state-nonlit-pos-cache.  Strengthen the comments.
	(c-state-dump): New commented out diagnostic routine.

	* cc-cmds.el: Eliminate some infinite loops:
	(c-forward-over-illiterls): On encountering a bare '#' step forward over
	it.
	(c-end-of-statement): Set macro-end correctly at the end of a loop.

2010-12-28  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-continued-construct):
	used 'paren-state' instead of 'lim' to fix byte-compile warnings.

2010-12-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-type):
	Before scanning a template arglist, check that the
	current language supports this.

2010-10-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Fix an off-by-1 error.

2010-10-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	Cache the result of the call to
	c-beginning-of-decl-1 inside the internal lambda.  This is for speed.
	(c-font-lock-enum-tail): New function which fontifies the tail of an enum.
	(c-basic-matchers-after): Insert a call to the above new function.

2010-10-24  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el: Patch to fix templates-19.cc test

2010-10-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-before-change, c-after-change):
	Move the setting of c-new-BEG and
	c-new-END from c-before-change to c-after-change.

2010-10-08  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Together with the previous patch, enhance fontification of declarators to
	take account of the presence/absence of "typedef".

	* cc-engine.el (c-forward-type): New &optional param "brace-block-too".
	(c-forward-decl-or-cast-1): cdr of return value now indicates the
	presence of either or both of a "struct"-like keyword and "typedef".

	* cc-fonts.el (c-complex-decl-matchers): Remove the heuristic fontification
	of declarators which follow a "}".

	* cc-langs.el (c-typedef-kwds c-typedef-key): New lang variable for
	"typedef".
	(c-typedef-decl-key): New lang varaible built from c-typedef-decl-kwds.

	* cc-mode.el (c-advise-fl-for-region): Don't restrict to AWK Mode any more.

2010-10-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	Fontify declarators according to the
	presence/absence of "typedef".

	* tests/class-21.face, tests/decls-33.c, tests/decls-33.face, tests/decls-8.cc, tests/decls-8.face, tests/templates-4.face, tests/typedef-1.face:
	CC Mode now correctly fontifies declarators according to the
	presence/absence of "typedef".  Adapt the test files accordingly.

2010-09-20  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el: Moved case 19 out of case 7

2010-09-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-<>-arglist-recur): Fix an infinite recursion.

	* cc-engine.el (c-forward-<>-arglist-recur): Correct the indentation.

2010-08-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph, c-fill-paragraph):
	Fix for the case that a C style
	comment has its delimiters alone on their respective lines.

2010-08-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-mode.el, cc-mode.texi, cc-vars.el:
	Eliminate some warning messages when Emacs 23 is used to compile them.

2010-07-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Fix auto-fill bug.

2010-07-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/000tests.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res, cc-engine.el, cc-fix.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el, cc-mode.texi, cc-vars.el, cc-defs.el:
	Integrate java-0-1 branch: Enhance Java Mode to handle Java 5.0 (Tiger)
	and Java 6 (Mustang).  Contributed by Nathanial Flath.

2010-07-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el, cc-fix.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el, cc-mode.texi, cc-vars.el, tests/000tests.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res:
	Integrate java-0-1 branch: Enhance Java Mode to handle Java 5.0 (Tiger)
	and Java 6 (Mustang).  Contributed by Nathanial Flath.

2010-07-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/comments-6.c, cc-mode.el:
	Enhance `c-file-style' in file/directory local variables.

	* cc-mode.el (c-count-cfss): New function.
	(c-before-hack-hook): Call `c-set-style' differently according to whether
	c-file-style was set in file or directory local variables.

	tests/comments-6.c.  Enter Emacs-24 as a version in which to ignore this
	test.

2010-07-13  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Fixed chaotic braces in 'Java Symbols'.

2010-06-30  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Added more detail on new syntactic constructs

2010-06-20  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Fix an indentation bug with templates.

	* cc-mode.el (c-common-init): Initialise c-new-BEG/END.
	(c-neutralize-syntax-in-and-mark-CPP): c-new-BEG/END: Take account of
	existing values.

	* cc-engine.el (c-clear-<-pair-props-if-match-after)
	(c-clear->-pair-props-if-match-before): now return t when they've cleared
	properties, nil otherwise.
	(c-before-change-check-<>-operators): Set c-new-beg/end correctly by
	taking account of the existing value.

	* cc-defs.el (c-clear-char-property-with-value-function): Fix this
	to clear the property rather than overwriting it with nil.

	* cc-mode.el (c-before-hack-hook):
	When the mode is set in file local variables, set it
	first.

2010-05-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el, cc-mode.texi, cc-vars.el, cc-cmds.el:
	Amend the handling of c-beginning/end-of-defun in nested declaration
	scopes.

	* cc-vars.el (c-defun-tactic): Move here from cc-langs.el.  Change it to a
	defcustom.

	* cc-mode.texi (Movement Commands): Document `c-defun-tactic'.  Document
	the new handling of nested scopes for movement by defuns.

	* cc-langs.el (c-defun-tactic): Move this variable to cc-vars.el.
	(c-nonlabel-token-2-key): New variable for change in cc-engine.el.

	* cc-engine.el (c-beginning-of-statement-1): Prevent "class foo : bar"
	being spuriously recognized as a label.

	* cc-cmds.el (c-narrow-to-most-enclosing-decl-block): Add parameter
	`inclusive' (to include enclosing braces in the region).
	(c-widen-to-enclosing-decl-scope): New function.
	(c-while-widening-to-decl-block): New macro.
	(c-beginning-of-defun, c-end-of-defun): Change algorithm to keep going
	outward for defun boundaries, and correspondingly change symbol
	`respect-enclosure' to `go-outward'.
	(c-declaration-limits): Change algorithm to report only the "innermost"
	defun's boundaries.

2010-05-25  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Added descriptions of annotation-top-cont and annotation-var-cont into the manual.

2010-05-22  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-mode.el:
	Moved annotation highlighting from java-mode to c-basic-matchers-after.

2010-05-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state-get-strategy): Replace parameter `here' with
	`here-' and `here-+', which sandwich any pertinent CPP construct.

	(c-remove-stale-state-cache-backwards): Fix a bug which happens when
	doing (c-parse-state) in a CPP construct: Exclude any "new" CPP construct
	from taking part in the scanning.

2010-05-21  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el, tests/generics-1.face, cc-engine.el:
	Fixed problem where Java Generics were not always fontified.

2010-05-19  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el, tests/generics-1.face, tests/generics-1.java, cc-engine.el:
	Fixed unit tests for template expressions and declarations.  Still a few broken ones in the new unit tests for Java generics.

2010-05-18  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, cc-engine.el:
	Fixed the bugs in annotation highlighting; annotation unit tests are now passing.

	Also reindented c-forward-<>-arglist-recur and made a few changes that fixed some bugs in generic handline, but those unit tests are not entirely passing.

2010-05-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/annotations-1.face:
	file annotations-1.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/annotations-1.java:
	file annotations-1.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/annotations-1.res:
	file annotations-1.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/enum-6.face:
	file enum-6.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/enum-6.java:
	file enum-6.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/enum-6.res:
	file enum-6.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/foreach.face:
	file foreach.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/foreach.java:
	file foreach.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/foreach.res:
	file foreach.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/generics-1.face:
	file generics-1.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/generics-1.java:
	file generics-1.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/java-varargs.face:
	file java-varargs.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/java-varargs.java:
	file java-varargs.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/java-varargs.res:
	file java-varargs.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

2010-05-17  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el, cc-vars.el, tests/000tests.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res:
	Added unit tests for new Java 1.5 constructs, as well as a few bug and formatting fixes.

	Most of the issues brought up by Alan's CR have been fixed, with the
	exception of annotations being font-locked in java-mode.
	Additionally, most of the broken tests were fixed, at the cost of the
	a few of the new unit tests not passing.

	* tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res:
	New file.

2010-04-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-extend-region-for-CPP):
	Fix an off-by-one error (EO-macro position).

2010-04-28  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el:
	Improved c-forward-annotation to handle annotations with arglists properly.

	* cc-vars.el, cc-engine.el:
	Added two syntactic contexts to support annotations in java.

	The first, annotation-top-cont, represents a topmost continuation where the only items preceding the current line are annotations.  An example is:
	@Test
	_ public void testFoo() {}

	The second is annotation-var-cont, representing a statement continuation where the only preceding items are annotations, such as:
	class Test {
	    public static void main() {
	    @SuppressWarnings
	    _int i;
	    }
	}

2010-04-27  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el: Fixed indentation.

	* cc-engine.el:
	Added support for for:each loops and fixed a few bugs this uncovered in generic highlighting.

2010-04-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-awk.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fix.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-styles.el, cc-vars.el:
	Replace leading spaces by <TAB> characters throughout the source.

	* cc-awk.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fix.el, cc-fonts.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el:
	Replace leading spaces by <TAB>s, synched with java-0-1-merge-3.

	* cc-awk.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fix.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el:
	Replace leading spaces by <TAB> characters throughout source.

	* cc-mode.texi, cc-mode.el, cc-engine.el:
	Merge from Branch_5_31, tag java-0-1-merge-2.

2010-04-24  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el:
	Added correct fontification for Java generics and varargs.

2010-03-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (Other Indentation):
	State that functions on c-special-indent-hook are
	called with no parameters and with point on the current line.

2010-03-23  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-mode.el, cc-vars.el:
	Renamed java-annotation-face to c-annotation-face and moved it to cc-fonts.el

2010-03-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: *** empty log message ***

	* cc-engine.el (c-remove-stale-state-cache): Fix an off-by-one error.

2010-03-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: *** empty log message ***

	* cc-mode.el:
	Guard against the Emacs core spuriously calling before-change-functions
	twice in succession.
	(c-just-done-before-change): New flag
	(c-before-change): Test and set the new flag before executing anything.
	(c-after-change): Clear the flag.

2010-03-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el, cc-mode.el, tests/inher-5.res, tests/inher-6.res, tests/templates-16.res, tests/templates-5.res, tests/templates-7.res, tests/templates-8.res, cc-cmds.el, cc-defs.el, cc-engine.el:
	Merge from BRANCH_5_31, tag java-0-1-merge-1.

2010-03-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: *** empty log message ***

	* cc-engine.el (c-remove-stale-state-cache):
	Correct the previous patch.

	* cc-engine.el: *** empty log message ***

	* cc-engine.el (c-remove-stale-state-cache):
	Take account of when `good-pos' is in the same
	macro as `here'.

	* cc-engine.el, cc-mode.el: *** empty log message ***



	* cc-mode.el (c-common-init): In the funcall, replace the erroneous `beg',
	`end' with (point-min), (point-max).
	(c-after-change): After (e.g.) C-y, remove the 'syntax-table text props
	that Emacs has converted from 'category text props.

	* cc-engine.el (c-clear-<-pair-props, c-clear->-pair-props): Clear the
	'category text property, not the 'syntax-table one.

2010-02-19  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el, cc-mode.el, cc-vars.el:
	Removed trailing whitespace from cc-vars and cc-engine, and fixed typo (xJava -> Java)

2010-02-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-mode.el: *** empty log message ***



	* cc-mode.el (c-common-init): Use c-get-state-before-change-functions in
	place of c-get-state-before-change-function.  Update some comments about
	this.

	* cc-engine.el: Update some comments about
	c-get-state-before-change-function.

	* cc-cmds.el, cc-defs.el, cc-engine.el, cc-langs.el, cc-mode.el:

	*** empty log message ***


	Change strategy for marking < and > as template delimiters: mark them
	strictly in matching pairs.

	* cc-mode.el (c-before-change): Use c-get-state-before-change-functions.

	* cc-langs.el (c-no-parens-syntax-table): New syntax table, used for
	searching syntactically for matching <s and >s.
	(c-get-state-before-change-functions): New language variable (note the
	plural) which supersedes c-get-state-before-change-function.

	* cc-engine.el (c-clear-<-pair-props, c-clear->-pair-props)
	(c-clear-<>-pair-props, c-clear-<-pair-props-if-match-after)
	(c-clear->-pair-props-if-match-before)
	(c-before-change-check-<>-operators): new functions.
	(c-after-change-check-<>-operators): Use macro c-unmark-<->-as-paren.

	* cc-defs.el (c-search-backward-char-property): New macro.

	* cc-cmds.el (c-electric-lt-gt): Do not set text properties on < and > any
	more.  (These will be handled by font locking.)

2010-01-25  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-vars.el: Highlighting for Java annotation usage

2010-01-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: *** empty log message ***

	* cc-engine.el:
	Fix a situation where deletion of a cpp construct throws an error.
	(c-invalidate-state-cache): Before invoking
	c-with-all-but-one-cpps-commented-out, check that the special cpp
	construct is still in the buffer.
	(c-parse-state): Record the special cpp with markers, not numbers.

	* cc-defs.el: *** empty log message ***

	* cc-defs.el:
	typing '#' in an empty C buffer throws "args out of range".
	(c-set-cpp-delimiters, c-clear-cpp-delimiters): Check for EOB playing the
	role of delimiter.

2010-01-19  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el: Highlight annotations as types

	* cc-mode.el, cc-langs.el: highlighting of @interface in java-mode

2010-01-06  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-menus.el:
	Fixed issue with cc-imenu-java-generic-expression not handling array arguments properly

2009-12-31  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el:
	Fix for enum indentation in Java.  Aligns all enum options on the same column.

	* cc-langs.el: Added proper highlighting for java enums

2009-12-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/templates-19.cc, tests/templates-19.res:
	Test template use in statements when the templates span line breaks.

	* tests/inher-5.res, tests/inher-6.res, tests/templates-16.res, tests/templates-5.res, tests/templates-7.res, tests/templates-8.res:
	Amend for the second anchor point just added to template-args-cont.


	Handle templates continued over line breaks in statements.  Refactor
	c-syntactic-skip-backward.  Make text property `category' rear
	non-sticky.

	* cc-mode.el (c-basic-common-init): make text property `category' rear
	non-sticky.

	* cc-engine.el (c-ssb-lit-begin): New defsubst, extracted from ....
	(c-syntactic-skip-backward): Refactor, extracting the above.
	(c-guess-basic-syntax CASEs 5D.3, 5L): Add extra anchor point;
	(c-guess-basic-syntax CASE 19): New CASE to handle template
	construct continued over line boundary.
	(c-guess-basic-syntax CASE 7): don't trigger on '<'.

2009-12-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Enhance `c-parse-state' to run efficiently in "brace desserts".
	 cc-mode.el (c-basic-common-init): Call c-state-cache-init.
	(c-neutralize-syntax-in-and-mark-CPP):  Renamed from
	c-extend-and-neutralize-syntax-in-CPP.  Mark each CPP construct by
	placing `category' properties value 'c-cpp-delimiter at its
	boundaries.

	* cc-langs.el (c-before-font-lock-function):
	c-extend-and-neutralize-syntax-in-CPP has been renamed
	c-neutralize-syntax-in-and-mark-CPP.

	* cc-fonts.el (c-cpp-matchers): Mark template brackets with
	`category' properties now, not `syntax-table' ones.

	* cc-engine.el (c-syntactic-end-of-macro): A new enhanced (but
	slower) version of c-end-of-macro that won't land inside a literal
	or on another awkward character.
	(c-state-cache-too-far, c-state-cache-start)
	(c-state-nonlit-pos-interval, c-state-nonlit-pos-cache)
	(c-state-nonlit-pos-cache-limit, c-state-point-min)
	(c-state-point-min-lit-type, c-state-point-min-lit-start)
	(c-state-min-scan-pos, c-state-brace-pair-desert)
	(c-state-old-cpp-beg, c-state-old-cpp-end): New constants and
	buffer local variables.
	(c-state-literal-at, c-state-lit-beg)
	(c-state-cache-non-literal-place, c-state-get-min-scan-pos)
	(c-state-mark-point-min-literal, c-state-cache-top-lparen)
	(c-state-cache-top-paren, c-state-cache-after-top-paren)
	(c-get-cache-scan-pos, c-get-fallback-scan-pos)
	(c-state-balance-parens-backwards, c-parse-state-get-strategy)
	(c-renarrow-state-cache)
	(c-append-lower-brace-pair-to-state-cache)
	(c-state-push-any-brace-pair, c-append-to-state-cache)
	(c-remove-stale-state-cache)
	(c-remove-stale-state-cache-backwards, c-state-cache-init)
	(c-invalidate-state-cache-1, c-parse-state-1)
	(c-invalidate-state-cache): New defuns/defmacros/defsubsts.
	(c-parse-state): Enhanced and refactored.
	(c-debug-parse-state): Amended to deal with all the new
	variables.

	* cc-defs.el (c-<-as-paren-syntax, c-mark-<-as-paren)
	(c->-as-paren-syntax, c-mark->-as-paren, c-unmark-<->-as-paren):
	modify to use category text properties rather than syntax-table
	ones.
	(c-suppress-<->-as-parens, c-restore-<->-as-parens): new defsubsts
	to switch off/on the syntactic paren property of C++ template
	delimiters using the category property.
	(c-with-<->-as-parens-suppressed): Macro to invoke code with
	template delims suppressed.
	(c-cpp-delimiter, c-set-cpp-delimiters, c-clear-cpp-delimiters):
	New constant/macros which apply category properties to the start
	and end of preprocessor constructs.
	(c-comment-out-cpps, c-uncomment-out-cpps): defsubsts which
	"comment out" the syntactic value of characters in preprocessor
	constructs.
	(c-with-cpps-commented-out)
	(c-with-all-but-one-cpps-commented-out): Macros to invoke code
	with characters in all or all but one preprocessor constructs
	"commented out".

2009-11-23  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-menus.el:
	Updating cc-imenu-java-generic-expression in order to match Java1.6 methods with generics and annotations.

2009-09-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-nonlabel-token-key): Allow quoted character constants (as
	case labels).

	* cc-engine.el (c-beginning-of-statement-1): Correct buggy bracketing.

2009-09-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-scan-conditionals):
	A new function like c-forward-conditionals, but it
	doesn't move point and doesn't set the mark.
	(c-up-conditional, c-up-conditional-with-else, c-down-conditional)
	(c-down-conditional-with-else, c-backward-conditional)
	(c-forward-conditional): Refactor to use c-scan-conditionals.

	* cc-bytecomp.el (cc-bytecomp-ignore-obsolete):
	In Emacs 23, byte-compile-warnings isn't
	always a list any more.  Use new function byte-compile-disable-warning
	here.

2009-08-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/release.php:
	Update and clarify the current status of the 5.31.n releases.

	* cc-defs.el (c-version):
	increment the version number to 5.31.8.prerelease.

2009-07-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-mode.texi:
	Whilst initialising a mode, make any explicit setting of a variable take
	precedence over one done via c-file-style/c-file-offsets.

	* cc-mode.el (c-before-hack-hook, c-postprocess-file-styles): give
	c-set-style a DONT-OVERRIDE parameter of t in each function.

	* cc-mode.texi (Config Basics, File Styles): Amend documentation.

2009-06-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph):
	Remove a spurious correction between the visible
	width of TABs and their number of bytes, so that point is undisturbed
	after typing a space, when there are tabs just before "*/".

2009-06-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce "font lock contexts", to enable (in particular) jit-lock to fontify
	correctly when starting in the middle of a construct.  Implement this for CPP
	expressions.

	* cc-langs.el (c-cpp-expr-intro-re): New variable.

	* cc-fonts.el (c-guess-font-lock-context): New function.
	(c-font-lock-context): New buffer local variable.
	(c-make-font-lock-search-form): New function, extracted from
	c-make-font-lock-search-function.
	(c-make-font-lock-search-function): Use the above function.
	(c-make-font-lock-context-search-function): New function.
	(c-cpp-matchers): Enhance the preprocessor expression case as above.
	(c-font-lock-complex-decl-prepare): Call c-guess-font-lock-context.

2009-05-21  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-langs.el (c-before-font-lock-function): Change the name of an entry
	to c-extend-and-neutralize-syntax-in-CPP.

	* cc-mode.el (c-basic-common-init): Set
	font-lock-extend-after-change-region-function to
	c-extend-after-change-region for Emacs 22 and later.
	(c-before-hack-hook): Correct "hack-local-variables-alist" to
	"file-local-variables-alist".
	(c-extend-and-neutralize-syntax-in-CPP): Renamed from
	c-neutralize-syntax-in-CPP; it now extends the font lock region by
	setting c-new-BEG and c-new-END.
	(c-font-lock-init): Remove initialization of obsolete variable
	font-lock-lines-before.
	(c-extend-after-change-region): New function.
	(c-advise-fl-for-region): Generated code now extends f-l region for any
	CC Mode, not just AWK Mode.

	* cc-fonts.el, cc-engine.el:
	Undo the last change, which was ill thought out, apart from the macro
	c-search-forward-char-property and some enhancements to comments.

2009-05-18  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-fonts.el (c-font-lock-invalid-cpp-string-matcher): New function.

	(c-basic-matchers-before): New clause to fontify invalid strings in a CPP
	construct.

	* cc-engine.el: Update some commenting.

	* cc-defs.el (c-search-forward-char-property): new macro.

2009-04-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Enhancements for Objective-C:

	* cc-vars.el: (c-objc-method-arg-min-delta-to-bracket,
	c-objc-method-arg-unfinished-offset, c-objc-method-parameter-offset): New
	variables.
	(c-offsets-alist): Use c-lineup-ObjC-method-call-colons in entry for
	objc-method-call-cont.

	* cc-langs.el: (c-constant-kwds): New ObjC keywords "YES", "NO",
	"NS_DURING", "NS_HANDLER", "NS_ENDHANDLER".

	* cc-align.el: (c-lineup-ObjC-method-call-colons): New function.

	* cc-menus.el: (cc-imenu-objc-function): Remove calls of
	imenu-progress-message.

2009-03-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el, cc-fonts.el, cc-langs.el, cc-mode.texi, cc-vars.el:
	Amend to indent and fontify macros "which include their own semicolon"
	correctly, using the "virtual semicolon" mechanism.

	* cc-defs.el: Update "virtual semicolon" comments.

	* cc-engine.el (c-crosses-statement-barrier-p): Recoded to scan one line at
	at time rather than having \n and \r explicitly in c-stmt-delim-chars
	(for some modes, e.g. AWK).
	(c-forward-label): Amend for virtual semicolons.
	(c-at-macro-vsemi-p, c-macro-vsemi-status-unknown-p): New functions

	* cc-fonts.el (c-font-lock-declarations): Take account of the new C macros.

	* cc-langs.el (c-at-vsemi-p-fn, c-vsemi-status-unknown-p-fn): move to
	earlier in the file.
	(c-opt-cpp-symbol, c-line-comment-start-regexp): New language variables.
	(c-opt-cpp-macro-define): Make into a full language variable.
	(c-stmt-delim-chars, c-stmt-delim-chars-with-comma): Special value for
	AWK Mode (including \n, \r) removed, no longer needed.

	* cc-mode.el (c-mode, c++-mode, objc-mode): Invoke
	c-make-macro-with-semi-re.  (Erroneously committed early, in previous
	version, 5.259.)

	* cc-vars.el (c-macro-with-semi-re, c-macro-names-with-semicolon): New
	variables.
	(c-make-macro-with-semi-re): New function

	* cc-mode.texi (Indentation Commands): Mention "macros with semicolons".
	(Other Special Indentations): Add an xref to "Macros with ;".
	(Customizing Macros): Add stuff about syntax in macros.  Add an xref to
	"Macros with ;".
	(Macros with ;): New page.

2009-02-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el:
	Allow (compile time) expressions in case clauses.

	* tests/switch-16.c, tests/switch-16.res: New file.

	* tests/switch-16.c, tests/switch-16.res:
	Test files for "case <expression>:".

2009-02-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-defun-name): Widen, so it works on a narrowed region.

2009-02-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features):
	Check the working of beginning/end-of-defun-function
	more rigorously before setting argumentative-bod-function.

2009-01-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-setup-paragraph-variables):
	Ensure paragraph-\(start\|separate\) match
	blank lines.  For AWK Mode.

2008-11-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/000tests.el (cc-test-extend-faces):
	When two faces aren't distinct, display a
	`message' rather than throwing an `error', a barely understood kludge to
	allow interactive use of 000tests.el.

	(do-all-tests): reset buffer *cc-test-log* to read/write after calling
	`compilation-mode'.

	* tests/top-4.res, tests/statement-15.res, tests/macro-8.res, tests/macro-7.res, tests/macro-3.res, tests/comments-4.res, tests/bracelist-11.res, tests/access-labels-qt-1.res:
	Correct the syntactical analysis of subsequent macro continuation lines.
	They are now never 'cpp-define-intro'.

2008-11-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-label):
	Handle the new QT macros Q_SLOTS and Q_SIGNALS.

2008-10-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-recognize-<>-arglists):
	Enable this, crudely, for java.  This will
	enable certain constructs with generics to be recognized, although it
	won't correctly handle the general use of generics.

2008-10-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-defun-name):
	Make it work for "struct foo bar [] = { ...".

2008-10-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-region):
	Fix previous patch so that the function works on
	one-line macros.

2008-10-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-before-hack-hook):
	New hook function for new hook (in Emacs 23)
	(top level): Use this new hook if it's there, otherwise use
	hack-local-variables-hook.

	* cc-mode.el (c-mode-base-map):
	Don't bind C-m-[ae] to c-{beginning,end}-of-defun when
	the current Emacs version passes a parameter to
	{beginning,end}-of-defun-function.

	* cc-engine.el (c-literal-type, c-forward-decl-or-cast-1, c-at-toplevel-p):
	Amend doc
	strings.
	(c-forward-decl-or-cast-1): Add in comments like "CASE 1", "CASE 2", ...
	which will later (hopefully) be fleshed out with detailed comments.

	* cc-cmds.el (c-indent-region):
	Fix so that indenting a macro followed by blank lines
	doesn't backslash the following non-blank line into the macro.

	* cc-align.el (c-lineup-respect-col-0): New function.

	* cc-styles.el (c-style-alist "ellemtel"):
	Move arglist-cont-nonempty into
	c-hanging-braces-alist.
	Change some `mapcar's into `mapc's.

2008-10-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cvstest.txt: Initial commision.

	* cvstest.txt: New file.

2008-10-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): For "if (a<0 || b>99)", set
	c-restricted-<>-arglists to t, so that the innards aren't treated as a
	template bracket enclosure.  Also refactor the code here.

2008-08-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features):
	set `argumentative-bod-function' when the Emacs core
	passes ARG through to `beginning-of-defun-function'.

2008-06-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Improve the doc string.

	* cc-langs.el (c-defun-tactic): New language variable defining BO-defun.
	(This was already being used, although not defined.)

	* cc-cmds.el (c-where-wrt-brace-construct): Fix problem with "labels" (e.g.
	"private:") at the top level.

2008-06-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax CASE 5D.5):
	Fix an infinite loop on invalid syntax.

2008-05-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-postprocess-file-styles):
	Throw an error if c-file-style is set to a
	non-string.
	(c-neutralize-syntax-in-CPP): Optimize for speed.

2008-05-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax, CASE 5B.1):
	Fix off-by-1 error, comparing position
	of ':' with BOL.

2008-05-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (Class Symbols): Correct a typo.

	* cc-fonts.el (c-font-lock-declarations):
	In "if (Bool *b = f())", fontify "Bool" as a
	type.
	Also enhance the commenting significantly.

2008-04-17  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-langs.el (c-type-decl-prefix-key): C++ bit: move
	"\(const\|throw\|volatile\)\>" nearer the start of the regexp, so that
	these keywords aren't wrongly matched as identifiers.

	* cc-fonts.el (c-font-lock-declarators): In (match-beginning 2), "2" ->
	"3", corresponding to the change in c-type-decl-prefix-key.
	(c-font-lock-maybe-decl-faces): Rearranged the header comments.

	* cc-engine.el (c-find-decl-spots): Rearranged the header comments.
	(c-forward-decl-or-cast-1): (i) In (match-beginning 2), "2" -> "3",
	corresponding to the change in c-type-decl-prefix-key.  (ii) Remove a
	check for a semicolon at the end of a function declaration: this causes
	C++ constructor declarations to be fontified before the semicolon is
	typed.

	* cc-defs.el (c-version): increment the version number to 5.31.6.

2008-04-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-modified-constant): new language constant:  matches, e.g.
	"L'a'".

	* cc-engine.el (c-beginning-of-statement-1): modify to handle "case L'a':".

	* cc-fonts.el (c-font-lock-complex-decl-prepare):
	Remove (most) c-type properties also
	from the last token _before_ the (font-lock) region, not just those
	actually inside it.

	Enhance some of the commenting.

2008-04-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/anoncvs.php, admin/compat.php, admin/index.php, admin/lists.php, admin/release.php:
	Update to current admin state.

2008-04-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (c-offsets-alist):
	Correct typos ("c-set-offsets" -> "c-set-offset",
	twice).

2008-04-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-before-font-lock-function):
	Correct a typo in the doc string.

2008-04-05  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-engine.el, cc-mode.texi:


	* cc-cmds.el (c-defun-name, c-cpp-define-name): New commands, primarily to
	support (X)Emacs's C-x 4 a (`add-change-log-entry-other-window') and
	friends.

	* cc-langs.el (c-opt-cpp-macro-define-start): Add a regexp submatch to
	match the #define's name.

	* cc-mode.el (c-neutralize-syntax-in-CPP):
	Remove a superfluous right parenthesis.

	* cc-mode.texi, cc-engine.el:

	* cc-engine.el (c-in-knr-argdecl): In a suspected K&R region, scan at most
	20 brace/paren pairs.  This prevents a drastic slowdown in files (e.g.
	Emacs's lisp.h) where there are many consecutive declarations without a
	brace block.

	* cc-mode.texi ("Limitations and Known Bugs") Document this restriction.

	* cc-vars.el (c-constant-symbol):
	put `save-excursion' round this function.

2008-03-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-neutralize-syntax-in-CPP): Fix coding bug.

	* cc-langs.el (c-before-font-lock-function):
	Fix bug in doc-string, "c-old-LEN" ->
	"c-old-END".

2008-02-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-neutralize-syntax-in-CPP):
	Fix a bug on typing "#" at EOB.

2008-02-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Set of changes so that "obtrusive" syntactic elements in a C/C++/ObjC
	preprocessor line (e.g. an unbalanced string quote or unmatched paren) don't
	interact syntactically with stuff outside the CPP line.

	* cc-awk.el (c-awk-beyond-logical-line, c-awk-old-ByLL): Replace
	c-awk-end-of-logical-line and c-awk-old-EoLL to solve an off-by-one bug.

	(c-awk-record-region-clear-NL): Replaces c-awk-before-change, with a bit
	of refactoring.

	(c-awk-extend-and-syntax-tablify-region): Takes some of the functionality
	of c-awk-advise-fl-for-awk-region, which has been refactored away.

	* cc-defs.el (c-clear-char-property-with-value-function)
	(c-clear-char-property-with-value): New function and macro which remove
	text-properties `equal' to a supplied value.

	* cc-engine.el: Comment about text properties amended.

	* cc-fonts.el (c-cpp-matchers): Make it put regexp parens around
	"error\\|warning".

	* cc-langs.el (c-get-state-before-change-function)
	(c-before-font-lock-function, c-anchored-cpp-prefix): New language
	variables.
	(c-cpp-message-directives): Handle "#warning" in C, C++ and ObjC.

	* cc-mode.el (c-basic-common-init): C and ObjC now use
	syntax-table text properties.
	(c-common-init): Call language specific before/after-change functions at
	mode initialisation.
	(c-new-BEG, c-new-END, c-old-BOM, c-old-EOM): New variables.
	(c-extend-region-for-CPP, c-neutralize-CPP-line)
	(c-neutralize-syntax-in-CPP): New functions.
	(c-before-change, c-after-change): Call the new language specific change
	functions defined in cc-langs.el.
	(c-advise-fl-for-region): New macro.
	(awk-mode): Remove AWK specific stuff which has been refactored into
	language independent stuff.

2008-02-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-specifier-key):
	Exclude "template" from this regexp; to anchor the "{" of a
	template function correctly on "template", not the following "<".

	* cc-engine.el (c-guess-basic-syntax, CASE 5A.5):
	Anchor the "{" of a template function
	correctly on "template", not the following "<".

	(c-guess-basic-syntax, CASE 5H): prevent a macro call inside a struct
	being recognised as a K&R argument.

	* cc-align.el, cc-awk.el, cc-cmds.el, cc-defs.el, cc-styles.el:
	Correct typos, remove WS, rephrase doc-strings/comments a little.

2008-01-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-save-buffer-state):
	Bind buffer-file-name and buffer-file-truename to
	nil, to prevent primitives generating "buffer is read only" messages.

2008-01-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el (defcustom-c-stylevar):
	New version by Thien-Thi Nguyen which gets rid of
	ugly nested backquotes.

	* tests/000tests.el (do-all-tests, do-one-test):
	bind 'enable-local-variables so as to get
	round GNU Emacs's tighter restrictions on file local variables.

	* cc-awk.el:
	awk-escaped-nls*: Use eval-and-compile to avoid compilation error.

2007-11-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/release.php: Explain about version 5.31.4.

2007-09-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/links.h:
	At an extra link to directory "manual".  Rename "Documentation" to
	"Manual", clarifying with "(html)" and "(info/PS/DVI)".

2007-08-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	With two "namespace"s on the same line, the next line's syntactic context
	(i) gets 2 "innamespace" elements, not 1 defun-block-intro + 1
	innamespace;
	(ii) the anchor points are now those of the namespace constructs, not
	just the line's indentation.

	* cc-langs.el (c-other-decl-block-key-in-symbols-alist): a new language
	variable, an alist with elements like ("namespace" . innamespace).

	* cc-engine.el (c-brace-anchor-point): New function.  (c-add-stmt-syntax):
	Give accurate anchor points for "namespace", "extern" etc., rather than
	BOI.  Fix addition of spurious syntactic-symbol 'defun-block-intro,
	replacing it with 'innamespace, etc.

2007-08-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Mailing Lists and Bug Reports": correct "-no-site-file" to
	"--no-site-file".

2007-07-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-mode.el:
	Move macro call `c-make-emacs-variables-local' from
	c-init-language-vars-for to c-make-init-lang-vars-fun, so that it works
	for derived modes.

2007-07-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Makefile:
	Rename target "html" to "html-raw".  New "html" fixes up links to the
	Emacs/Elisp manuals, pointing them into http://www.gnu.org.

	* 2www.gnu.org.sh: Add a #! line, and a directory parameter.

2007-07-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* 2www.gnu.org.sh:
	The manual has cross references to the Emacs and Elisp manuals.  In the
	HTML manual, these became broken links.  This script directs those links
	to the right places in http://www.gnu.org.  (It also removes a link to a
	manual which doesn't seem to exist online.)

2007-07-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/access-labels-qt-1.face, tests/class-1.face, tests/class-23.face, tests/class-4.face, tests/class-9.face, tests/interface-1.face, tests/switch-1.face, tests/switch-10.face, tests/switch-12.face, tests/switch-14.face, tests/switch-15.face, tests/switch-3.face, tests/templates-1.face, tests/templates-2.face, tests/templates-3.face, tests/templates-4.face, tests/templates-6.face, tests/union-2.face:
	Update 18 files.face to reflect the change in cc-fonts.el
	V5.205.2.4/5.209: Keywords which are terminated by a colon (e.g.
	default:, public:) and the analogous Objective-C keywords are now
	fontified with font-lock-keyword-face.

2007-07-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-version):
	Increase to 5.31.5.  (5.31.4 was the version in Emacs 22.1.)

2007-07-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el:
	Repair the customization routines which handle alists so that it is
	possible to insert entries for those keys which are valid, yet aren't
	currently in the alist.

	(c-constant-symbol): New defun which supersedes c-const-symbol.
	(c-indent-comment-alist, c-hanging-braces-alist, c-hanging-colons-alist,
	c-offsets-alist): Replace c-const-symbol by c-constant-symbol.

	Make the syntactic symbol arglist-cont-nonempty a legitimate key in
	c-hanging-braces-alist.

	* cc-cmds (c-brace-newlines): Amend.

	* cc-styles.el (c-style-alist): Extend all standard styles to include the
	new element.

	* cc-vars.el (c-hanging-braces-alist): Amend the default value, and the
	customization form.

	* cc-mode.el: c-before-change: Replace a "1" with "(point-min)".

	* cc-cmds.el, cc-mode.el: cc-cmds.el (c-electric-slash):

	* cc-mode.el (c-remove-any-local-eval-or-mode-variables):
	Replace wrong uses of `kill-...' (which added spurious entries to the
	kill ring) by `delete-....'.

	* cc-cmds.el (c-in-function-trailer-p):
	Fix this: when a function return type contains
	"struct", "union", etc.  c-end-of-defun goes too far forward.

	* cc-subword.el (c-capitalize-subword):
	More closely mimic the behavior of `capitalize-word'.
	Do not move point with a negative argument.  Based on tiny change by Paul
	Curry.

	* cc-subword.el (c-downcase-subword, c-upcase-subword):
	Don't move point if ARG is
	negative.  Patch by Paul Curry.

	Changes to make `narrow-to-defun' and `mark-defun' work properly
	in CC Mode:

	* cc-defs.el (c-beginning-of-defun-1):

	* cc-cmds.el (c-beginning-of-defun, c-end-of-defun):
	Bind beginning/end-of-defun-function to nil around calls to
	beginning/end-of-defun.

	* cc-langs.el (beginning-of-defun-function,
	end-of-defun-function): New c-lang-setvar's.

	* cc-awk.el (c-awk-beginning-of-defun): Add "(or arg
	(setq arg 1))" to enable non-interactive call.

	* cc-cmds.el (c-end-of-defun):
	Tidy up, to eliminate byte-compiler warning "value
	unused" in Emacs 22.

2007-07-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-paren):
	Fix space-before-funcall clean-up: only insert space
	when on identifier, etc.  Patch by David Hansen.

	Fix fontification of labels, and other things with ":".

	* cc-engine.el (c-forward-label): The function now
	returns 'goto-target, 'qt-2kwds-colon, 'qt-1kwd-colon, as well as the
	former t.

	* cc-fonts.el (c-font-lock-declarations): Interpret the
	new return code from c-forward-label, fontifying tokens properly.  Add
	some general comments throughout the file.

	* cc-vars.el (c-special-indent-hook): Amend doc-string to mention
	c-syntactic-indentation.

	* cc-cmds.el (c-forward-to-nth-EOF-}): Fix EOB bug.

	* cc-mode.el (c-make-emacs-variables-local):
	Use `mapcar' rather than `mapcan' to
	silence compiler warning in GNU Emacs 22.

	Remove stale tokens from `c-found-types' cache.

	* cc-engine.el: (c-partial-ws-p, c-unfind-type, c-trim-found-types): New
	functions.

	* cc-mode.el:  (c-unfind-enclosing-token, c-unfind-coalesced-tokens,
	c-before-change): New functions.  (c-maybe-stale-found-type): New
	variable.

2007-06-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/lists.php: Update the address of the cc-mode-help mailing list.

2007-03-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:

	* cc-styles.el: cc-align.el, cc-styles.el: New line-up function,
	c-lineup-gnu-DEFUN-intro-cont, for the DEFUN macro in the Emacs C
	sources.  Only used in "gnu" style.


	* cc-align.el: Correct a logistical error in the previous patch.

	* cc-align.el: cc-align.el, cc-styles.el: New line-up function,
	c-lineup-gnu-DEFUN-intro-cont, for the DEFUN macro in the Emacs C
	sources.  Only used in "gnu" style.

	* cc-compat.el, cc-langs.el, cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el, cc-awk.el:
	Update the copyright statements, correct some typos, remove silly WS,
	improve a few comments.

2007-02-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el, cc-awk.el, cc-compat.el, cc-langs.el:
	Update the copyright statements, correct some typos, remove silly WS,
	improve a few comments.

	* cc-mode.texi: Correct lots of typos.
	("Getting Started"): Change a sentence to the conditional.
	("Movement Commands"): Add missing (@code{c-beginning/end-of defun}).
	("Clean-ups"): Add an example for inserting a clean-up into
	c-cleanup-list.

	* cc-mode.el (c-basic-comment-init):
	Don't set open-paren-in-column-0-is-defun-start
	to nil any more.  Discussion in emacs-devel showed this was
	counter-productive.

	* cc-fonts.el: Added comments to c-font-lock-complex-decl-prepare,
	c-font-lock-<>-arglists, c-font-lock-declarations, c-font-lock-c++-new,
	explaining that they get called as font-lock "FUNCTION"s; to
	c-font-lock-declarations (a c-lang-defconst) explaining that it dumps
	these functions to c-matchers-3.

	* cc-engine.el (c-beginning-of-current-token):
	For no movement, return NIL, not 0.
	(c-in-knr-argdecl): Fixed, so that it doesn't get confused by "[]" when
	doing a C-M-a.

	* cc-defs.el (c-go-list-forward, c-go-list-backward): New macros.

	* cc-cmds.el (c-where-wrt-brace-construct):
	correct the handline of K&R regions; C-M-a
	was fouling up in them.
	(c-indent-line): Change the notion of "whitespace" used for <tab>, so
	that a ^L doesn't get swallowed.
	(c-mask-paragraph): Correct the handling of unclosed C-style comments,
	(for when auto-fill-mode is enabled).
	(c-indent-new-comment-line): With M-j in an empty C-style comment,
	correct the final position of point.

2006-11-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix clean-up space-before-funcall so that it doesn't split the identifer
	from the parentheses in "#define foo(..)".

	* cc-langs.el (c-opt-cpp-macro-define-id): new language variable.

	* cc-engine.el (c-forward-over-cpp-define-id): new function.

	* cc-cmds.el (c-electric-paren): Amend the function.

2006-11-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* README: Tell XEmacs users they need the "advice" package.

	* tests/access-labels-qt-1.res, tests/bracelist-11.res, tests/comments-4.res, tests/macro-3.res, tests/macro-7.res, tests/macro-8.res, tests/statement-15.res, tests/top-4.res:
	Correct the syntactical analysis of subsequent macro continuation lines.
	They are now never 'cpp-define-intro'.

	* tests/macro-23.c, tests/macro-23.res: New file.

	* tests/macro-23.c, tests/macro-23.res:
	New test case for plain statements as the continuation lines of a macro.

	* tests/macro-27.c, tests/macro-27.res:
	A new test case for a wierd mixture of invalid syntax with CPP, labels,
	and an escaped newline.

	* tests/macro-27.c, tests/macro-27.res: New file.

	* cc-engine.el:
	(i) (c-guess-basic-syntax, case 5N): Check the format of c-state-cache is
	valid for an optimisation before using it.
	(ii) (c-guess-basic-syntax): New case 5Q "we are at a statement within a
	macro".  Other changes so that only the first continuation line in a
	macro gets the symbol `cpp-define-intro', the others get `statement', or
	whatever.

	* cc-mode.texi ("Limitations and Known Bugs"):
	Document problems with eval-after-load
	and a workaround.

2006-07-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce macro c-lang-setvar (sister to c-lang-defvar) to set standard
	Emacs variables (like comment-start) to language dependent values, yet
	without spuriously "defvar"ing them.

	* cc-langs.el (c-emacs-variable-inits): new variable.
	(c-lang-setvar): new macro.
	(c-make-init-lang-vars-fun): Use the initialization forms in
	c-emacs-variable-inits in addition to those in c-lang-variable-inits.
	(comment-start, comment-end, comment-start-skip): Change these from
	c-lang-defvar's to c-lang-setvar's

	* cc-mode.el (c-make-emacs-variables-local): new macro, which calls
	make-local-variable on the elements of c-emacs-variable-inits.
	(c-init-language-vars-for): Call this macro.

2006-07-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-mode.texi:

	* cc-mode.texi ("Filling and Breaking"): Amend the doc for
	c-context-line-break.

	* cc-mode.texi, cc-cmds.el:

	* cc-cmds.el (c-context-line-break): When invoked within a string, preserve
	whitespace.  Add a backslash only when also in a macro.

	* cc-mode.texi ("Filling and Breaking"): Amend the doc for
	c-context-line-breaak.

2006-07-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el: cc-defs.el.  Correct typos.


	* cc-awk.el, cc-fonts.el: Move awk-font-lock-keywords from cc-fonts.el back
	to cc-awk.el to eradicate an eval-after-load, at the request of RMS.

2006-07-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-context-line-break): don't indent the new line after an
	escaped EOL in a string.

2006-07-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/label-10.c, tests/label-10.res:
	label-10.{c,res}: Recognise "foo:" as a label when it directly follows "else",
	"do", ....

	* tests/label-10.c, tests/label-10.c~, tests/label-10.res: New file.

	* tests/label-10.c, tests/label-10.c~, tests/label-10.res:
	label-10.{c,res}: Recognise "foo:" as a label when it directly follows "else",
	"do", ....

	* cc-engine.el (c-forward-label): Recognise "foo:" as a label when it
	directly follows "else", "do", ....

2006-07-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/templates-18.cc, tests/templates-18.res: New file.

	* tests/templates-18.cc, tests/templates-18.res:
	templates-18.{cc,res}: tolerate empty angle brackets (as
	seen in "explicit specialisations" of templates).


	* cc-engine.el (c-looking-at-decl-block): tolerate empty angle brackets (as
	seen in "explicit specialisations" of templates).

2006-05-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/anoncvs.php, admin/links.h:
	Update the CVS server name to "cc-mode.cvs.sourceforge.net".

	* admin/anoncvs.php, admin/links.h:
	Update the CVS server to "cc-mode.cvs.sourceforge.net".

2006-05-14  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/anoncvs.php:
	Update the CVS host (following a SourceForge upgrade).

2006-04-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-vars.el:

	* cc-vars.el (c-indentation-style): Mention c-file-style in the doc-string.

	* cc-mode.texi ("Choosing a Style"): Mention c-file-style.


	* cc-cmds.el (c-mask-paragraph): Fix for C comments, when the comment ender
	looks like "=========*/" and is alone on its line.


	* cc-langs.el, cc-engine.el: Correct the spelling of
	c-opt-op-identiTier-prefix, t -> f.  Leave an alias for the old name.

	* cc-mode.texi, cc-mode.el:

	* cc-mode.el: Bind C-M-a and C-M-e to c-\(beginning\|end\)-of-defun by
	default.

	* cc-mode.texi ("Movement Commands", "Sample .emacs File"): Document this.


	* cc-align.el, cc-styles.el: New line-up function,
	c-lineup-gnu-DEFUN-intro-cont, for the DEFUN macro in the Emacs C
	sources.  Only used in "gnu" style.

2006-04-14  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/release.php:
	Correct a link from http://download.sourceforge.net/.... to
	http://PRdownloadS.sourceforge.net/...

	* cc-cmds.el (c-electric-slash):
	Extend the handling of clean-up comment-close-slash
	also to work when there's a comment terminator on the line.
	(c-beginning-of-defun, c-end-of-defun): Refactor and optimise these for
	large arg - only take account of top level {..}, except for initial and
	final adjustments.  M-- C-M-[ae] now go to the right defuns when the
	starting point is between defuns.  They use the four new functions:
	(c-in-function-trailer-p, c-where-wrt-brace-construct,
	c-backward-to-nth-BOF-{, c-forward-to-nth-EOF-}): new functions to
	support c-\(beginning\|end\)-of-defun.

	* cc-engine.el (c-forward-label):
	Analyze ":" expressions more rigorously, to exclude
	bit-field specifiers from being classed as labels.
	(c-forward-label): When analyzing a ":" within a macro, be careful about
	using c-forward-syntactic-ws at the macro beginning.
	(c-beginning-of-decl-1): Whilst searching for "=" as evidence of a stmt
	boundary, check for "operator=", etc.

2006-04-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/access-labels-qt-1.cc, tests/access-labels-qt-1.face, tests/access-labels-qt-1.res:
	Jazz up the QT "slots:" declarations by inserting comments and macros
	into them.

	* cc-mode.texi ("Other Commands"):
	Move c-set-style (C-c .) here from "Choosing a
	Style".
	("Styles"): Add @dfn{style}.

	* Makefile (docs: target):
	Add a line to build cc-mode.XEMACS.info.tar.gz.

	* ChangeLog: Correct a typo.

2006-02-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features): Don't assume point-min==1.

	* NEWS, cc-cmds.el, cc-mode.el, cc-mode.texi:
	Rename c-hungry-backspace to c-hungry-delete-backwards, at the request of
	RMS.  Leave the old name as an alias.

	* cc-awk.el: Correct a typo.

	* admin/changes-531.php:
	Rename c-hungry-backspace to c-hungry-delete-backwards, at the request of
	RMS.  Leave the old name as an alias.

	* cc-mode.texi:
	(i) Correct the definition of c-beginning-of-defun, to include the
	function header within the defun.
	(ii) Two minor amendments from Savannah.

	* cc-fix.el:
	In the test for a broken (XEmacs) font-lock-compile-keywords, exclude GNU
	Emacs, whose CVS version would now signal an error.

	* cc-fix.el, cc-guess.el, cc-lobotomy.el, cc-styles.el, cc-subword.el, cc-vars.el, cc-align.el, cc-awk.el, cc-bytecomp.el, cc-cmds.el, cc-compat.el, cc-defs.el, cc-engine.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el:
	(i) Add 2006 to the copyright statement.
	(ii) Correct a typo in cc-mode.el.

	* cc-mode.texi: (i) Add 2006 to the copyright.
	(ii) Correct two typos.

	* cc-defs.el: Update the version string to "5.31.4".

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/index.php, admin/release.php: Update for release 5.31.3.

	* ChangeLog: Fixed last minute bug in cc-mode.el.

	* cc-mode.el (c-postprocess-file-styles):
	bind inhibit-read-only to t, around the call
	to c-remove-any-local-eval-or-mode-variables, so that it works on a RO
	file.

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* ChangeLog: Update for release 5.31.3.

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.3

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-postprocess-file-styles): bind inhibit-read-only
	to t, around the call to
	c-remove-any-local-eval-or-mode-variables, so that it works on a
	RO file.

2006-02-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features): Don't assume point-min==1.

	* cc-awk.el: Correct a typo.

2006-02-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/changes-531.php, cc-mode.texi, NEWS, cc-cmds.el,
	cc-mode.el: Rename c-hungry-backspace to
	c-hungry-delete-backwards, at the request of RMS.  Leave the old
	name as an alias.

2006-02-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	(i) Correct the definition of c-beginning-of-defun, to include the
	function header within the defun.
	(ii) Two minor amendments from Savannah.

	* cc-fix.el: In the test for a broken (XEmacs)
	font-lock-compile-keywords, exclude GNU Emacs, whose CVS version
	would now signal an error.

2006-02-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fix.el, cc-guess.el, cc-lobotomy.el, cc-styles.el,
	cc-subword.el, cc-vars.el, cc-langs.el, cc-menus.el, cc-mode.el,
	cc-fonts.el, cc-bytecomp.el, cc-cmds.el, cc-compat.el, cc-defs.el,
	cc-engine.el, cc-awk.el, cc-align.el:
	(i) Add 2006 to the copyright statement.
	(ii) Correct a typo in cc-mode.el.

	* cc-mode.texi: (i) Add 2006 to the copyright.
	(ii) Correct two typos.

2006-02-09  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el: Update the version number to 5.31.3.

2006-02-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fix clean-up brace-else-brace
	(error due to mbeg, mend being undefined).

2006-02-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: File Local variables: Solve the problem where both
	`mode' and c-file-offsets are specified: `mode' will overwrite
	c-f-o's settings:
	(c-remove-any-local-eval-or-mode-variables): new function.
	(c-postprocess-file-styles): call the above new function, within
	c-tentative-buffer-change, to splat `mode' and `eval' before the
	second hack-local-variables.

2006-01-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el:
	[Alternative patch to GNU Emacs: cc-engine.el V 1.45]
	(c-after-change): Protect the match data with save-match-data.  It
	was getting corrupted by c-after-change-check-<>-operators.

	* cc-defs.el: [3 Patches from GNU Emacs: savannah V 1.3[678]:
	(top level): Check for a buggy font-lock-compile-keywords ONLY in
	XEmacs.  GNU Emacs 22 now has a check which would throw an error
	here.
	(c-emacs-features): Use (point-min) and (point) rather than
	hard-coded 1, in case the buffer is narrowed.

	* cc-awk.el (c-awk-after-change): Protect the match data with
	save-match-data.  It was being corrupted when Font Lock was not
	enabled.

2006-01-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* ChangeLog: Update for release 5.31.2.

2006-01-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.2

2006-01-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (Comment Commands): State that C-u M-; kills any
	existing comment.
	(Electric Keys): Add a justification for electric indentation.
	(Hungry WS Deletion): Clear up the names and complications of the
	BACKSPACE and DELETE keys.

2006-01-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-basic-common-init): Concatenate the minor mode
	indicators directly onto mode-name, removing c-submode-indicators.
	Sometimes, c-s-i got separated from the mode name on the mode
	line.

	* cc-langs.el (c-mode-menu): Add menu items for Electric Mode and
	Subword Mode.

	* cc-engine.el: Concatenate the minor mode indicators directly
	onto mode-name, removing c-submode-indicators.  Sometimes, c-s-i
	got separated from the mode name on the mode line.
	(c-beginning-of-statment-1): Distinguish real labels ("case 1:" or
	"foo:") from non-labels ("public:").
	(c-forward-objc-directive): Replace c-forward-token-2 with crude
	coding; c-f-t-2 doesn't move over a token at EOB.

	* cc-defs.el (c-version): Update version number to 5.31.2

	* cc-cmds.el (c-update-modeline): Concatenate the minor mode
	indicators directly onto mode-name, removing c-submode-indicators.
	Sometimes, c-s-i got separated from the mode name on the mode
	line.
	(c-electric-brace, c-electric-semi&comma, c-electric-colon):
	Correct doc-strings: "/ln" -> "/la".

2006-01-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-make-init-lang-vars-fun): Improved the error
	message when there's an evaluation error to show whether it's
	loaded from source or not.
	(c-filter-ops): Made it available at runtime too to work when
	`c-make-init-lang-vars-fun' needs to evaluate from source.

2005-12-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.1

2005-12-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* NEWS: Correct the spelling of Masatake YAMATO's name (with
	apologies to him).

2005-12-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-version): <- 5.31.1

	* cc-defs.el: Restore the (correct) (c-external-require 'cl).

2005-11-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.

2005-11-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Spelling and minor typographical changes.

2005-11-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-awk.el:  Spelling corrections.

	* cc-cmds.el (c-electric-paren): Only call the
	`blink-paren-function' for a CLOSE parenthesis.

	* cc-defs.el: Change "(cc-external-require 'cl)" to
	"(eval-when-compile (require 'cl))".  (The change came from
	savannah - I don't understand it.)

	* cc-engine.el: Add an autoload to c-guess-basic-syntax (From
	savannah.)
	
	* cc-langs.el: Add "(cc-external-require 'cl)".

	* cc-mode.el (c-font-lock-init): "Add (font-lock-lines-before
	. 1)".
	
	* cc-subword.el: Add a dummy `c-subword-mode' for Emacsen which
	lack `define-minor-mode'.  (Currently Emacs <21.  We might do this
	function properly in the future).

2005-11-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-defs.el, cc-styles.el, cc-vars.el: New macros
	c-sentence-end and c-default-value-sentence end, to cope with
	Emacs 22's new function `sentence-end'.

2005-11-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-show-syntactic-information): Solved the compat
	issue using `c-put-overlay' and `c-delete-overlay'.

	* cc-defs.el (c-put-overlay, c-delete-overlay): New compat macros
	to handle overlays/extents.

2005-11-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fix.el: Add definitions of the macros push and pop (for GNU
	Emacs 20.4)

	* cc-defs.el:
	(i) Load cc-fix.elc for `push' and `pop' (for GNU Emacs 20.4)

	* cc-cmds.el (c-show-syntactic-information): change the
	highlighting mechanism so it will work in XEmacs too.

	Remove several unused dynamic bindings.

	* cc-defs.el: Insert c-int-to-char.

	* cc-langs.el (c-nonsymbol-token-char-list): Insert a call to the
	new macro c-int-to-char.  This solves XEmacs's regarding
	characters as different from integers.

2005-11-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-make-syntactic-matcher): New internal helper.

	(c-cpp-matchers, c-basic-matchers-before): Use the `eval'
	construct to make the indirect face lookup work in XEmacs.

	(c-cpp-matchers): Append the negation char face to the existing
	fontification, so that the cpp face doesn't disappear.  Use
	`c-make-syntactic-matcher' to avoid negation chars in comments and
	strings.

2005-11-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-negation-char-face-name): New variable to map to
	`font-lock-negation-char-face' in emacsen where it exists.

2005-11-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Bind c-subword-mode to C-c C-w.

	* cc-mode.texi:
	(i) Document the binding C-c C-w, in "Minor Modes" and in "Subword
	Movement".
	(ii) Mark c-\(forward\|backward\)-into-nomenclature as superseded
	by c-subword-mode.
	(iii) "Config Basics": change the troublesome "@itemize @w" to
	"@itemize @asis".
	(iv) Eliminate the "@defvr {LIST}" construct in "Adding Styles".
	Bring descriptions of subsidiary matters into the definition of
	the style description by shifting an "@end".

2005-11-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-subword.el, cc-cmds.el, cc-mode.el: Rename
	"c-subword-move-mode" as "c-subword-mode".

	* cc-mode.texi, cc-subword.el: cc-subword.el: In
	c-forward-subword-internal, check that the regexp doesn't match a
	null string.  This can happen, e.g., in Info Mode, where ' has the
	syntax of a word constituent.

	cc-mode.texi:
	(i) "Subword Movement": Say that subword-move-mode is available in
	non-CC Modes.
	(ii) "Config Basics": Add a recommendation to beginners to use the
	top-level setq mechanism.
	(iii) "Config Basics": Deobfuscate the description of top-level
	setq's.

	* cc-mode.texi:
	(i) Add a description of the various build commands
	(e.g. makeinfo), as supplied by Robert Chassell.
	(ii) Move description of `comment-region' from "Other Commands" to
	"Comment Commands".
	(iii) Remove C-c C-y (which used to be bound to
	c-toggle-hungry-state).
	(iv) Added a @footnote about the change of the binding C-c C-d.
	(v) Reinstated the description of `c-toggle-auto-hungry-state'.

	* cc-mode.el: Remove the binding C-c C-y for c-toggle-hungry-state

	* cc-cmds.el: Reinsert c-toggle-auto-hungry-state (but with no
	binding).

2005-11-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added tty suitable bindings for C-c <delete> and C-c
	C-<delete>.  (To the c-hungry- delete functions).

2005-11-21  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added autoload directive for `c-subword-move-mode'
	for use in older emacsen.

2005-11-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el:
	(i) Insert a binding for C-c C-backspace into
	c-bind-special-erase-keys which works in TTYs.
	(ii) Make sure that when file styles are used, any explicitly
	given style variables take priority over those in the style.  Do
	this by calling `hack-local-variables' a second time.

	* cc-vars.el: Add language specific customization widgets for AWK
	to c-doc-comment-style, c-require-final-newline and
	c-default-style.  Add a defcustom for awk-mode-hook.  Give
	c-syntactic-element and c-syntactic-context doc-strings by
	directly setting their `variable-documentation' propery.  This
	allows Emacs 22.1 to read these with C-h v.

	* cc-awk.el: Apply a tidy-up patch (from Stefan Monnier).

2005-11-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Mention gtkdoc.

	* cc-mode.texi: The concept index also contains the keys. Make
	that more obvious so that the keys are found more easily.

	* cc-mode.texi: Updated the Hungry WS Deletion section on the
	details about the C-c C-<backspace> bindings etc.

	* cc-mode.texi: Added a section about the subword minor mode.

	* cc-fonts.el, cc-vars.el (gtkdoc-font-lock-doc-comments,
	gtkdoc-font-lock-doc-protection, gtkdoc-font-lock-keywords):
	GtkDoc patterns contributed by Masatake YAMATO.

	(c-doc-comment-style): Made GtkDoc default in C mode.

2005-11-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Fixed key bindings for C-c C-<backspace> and C-c
	C-<delete>.

	(c-bind-special-erase-keys): New function for use on
	`normal-erase-is-backspace-hook' to bind C-c C-<delete> correctly.

	* cc-cmds.el (c-hungry-delete): New function to fix <delete> key
	behavior in XEmacs according to `delete-forward-p'.
	C.f. `c-electric-delete'.

2005-11-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: DVI stuff: Remove the quotes from "GNU Emacs
	Manual" and friends.  Complete several cross references with their
	fifth parameter (the name of the printed manual).

	"Indentation Commands": Tidy up `c-indent-command', putting the
	variables `c-tab-always-indent' and `c-insert-tab-function' inside
	its description.  Inserted some "printed manual names" into cross
	references where they were missing.  Move description of
	`indent-for-comment' into ...

	"Comment Command": A new @section under "Commands"; it contains
	the description of `indent-for-comment'; this was taken out of
	"Indentation Commands".  Add GNU Emacs's new name `comment-dwim'
	for this function.

	"Sample .emacs File": Change "@example" to "@verbatim" so that the
	text isn't indented.  Reorder the Lisp forms.

2005-11-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: "Configuration Basics": Add a note that ".emacs"
	means "whatever initialization file you fancy".  Also, another
	note that the mode hooks are good places to put personal
	preferences.

	"Performance Issues": Remove the recommendation to put defun
	braces at column 0, replacing it with a historical remark.

	"Limitations and Known Bugs": State that C++ templates aren't yet
	handled fully.

2005-11-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Renamed @chapter "Getting Connected" to "Getting
	Started" and @chapter "Config Strategies" to "Config Basics".

	"Getting Started": Added "quick fix" configurations for four of
	the most common requests (c-basic-offset, c-set-style,
	c-electric-mode, <RET> should indent NL).

	"FAQ": Permuted the questions a little.  Added "How can I change
	the indent level from 4 spaces to 2 spaces?".  Added several cross
	references.

2005-11-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Move c-toggle-hungry-state from "C-c C-d" to "C-c C-y".  Give
	  c-hungry-backspace and c-hungry-delete-forward permanent key bindings.

	* cc-mode.texi: Document the new state of affairs: Nodes changed: "Minor
	  Modes", "Hungry WS Deletion", "Sample .emacs File"

	* cc-mode.texi:
	"Style Variables": New @section explaining what style variables are and
	  how to set them.
	"Permanent Customization": Removed this @section, since its contents have
	  been moved elsewhere.
	"c-offsets-alist": New @section

	Removed much commented out material, including @examples in the Line-Up
	  sections.

	"Config Strategies": (i) Added a summary of style variables; (ii)
	  Corrected the priority of settings made by "File Local Variables";
	  (iii) Clarified and corrected how top-level `setq's interact with
	  styles; (iv) Added a terse but accurate description of the "user"
	  style.
	"Style Variables": Took over most of the stuff from "Styles", its
	  parent.  Added a @pxref to each item in the list of style variables.
	"Built-in Styles": Corrected the description of the "user" style.  Other
	  styles DO NOT inherit from it - they inherit from the factory defaults
	  in c-fallback-style.
	"Adding Styles": Clarification of inheritance from c-fallback-style.

	"Hanging Braces": Replace a tedious flowchart of what CC Mode does, with
	  a description of how to go about configuring the thing.
	"Custom Braces": Move description of c-syntactic-context to near the
	  top of the node, and note the other three circumstances it gets bound
	  (together with @xrefs).
	"Hanging Semicolons and Commas": Note that c-syntactic-context is bound.

	"Indentation Engine Basics": Clarify first stage of indentation process.
	"Syntactic Symbols" (and sub-nodes): Note the syntactic symbols which
	  don't have and anchor point, or have additional info in a syntactic
	  element.

	"Customizing Indentation": Stuff about c-offsets-alist has been moved to
	  its own new @section.
	"Line-Up Functions": Add a mention of the calling convention together
	  with a pointer to "Custom Line-Up".
	"Other Indentation": Clarify the whole @section.  State that File local
	  variables take precedence over all else, even settings in hooks.

2005-11-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Remove the "(if t ..." construct
	which was experimentally inserted into V 5.314 (2005-08-18) to
	minimise the patch size by not changing the indentation level.

2005-11-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-semi&comma): Bind c-syntactic-context for
	calls to "criteria functions", for consistency with other calls to
	user functions.

2005-10-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-command): expunge use of
	`current-prefix-arg', since this might be the prefix arg to a
	command which calls c-indent-command as a function.  Change the
	interactive spec from "p" to "P".

2005-10-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Minor Modes": Document the command c-toggle-syntactic-indentation.
	"Analysis": Formalise the description of
	  c-show-syntactic-information to a quasi-@defun form.  Describe the new
	  feature of highlighting anchor positions.
	Make sure there's a blank line at the top of each node.

	* cc-mode.texi: "Indentation Engine Basics":
	(i) Rearrange the paragraphs more logically;
	(ii) make @dfn's out of "syntactic symbol", "anchor position" and
	  "offset(s)".
	(iii) Make an @enumeration out of the two-step indentation process.
	(iv) Add a paragraph motivating c-syntactic-indentation, complete with a
	  reference to "Config Strategies".

2005-10-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: "Custom Line-Up":
	(i) Increase the concision of the page.
	(ii) Comment out the example.  (Maybe this should go into its own
	  @subsection.)
	(iii) Specify precisely the conventions for a line-up function, in
	  particular, that point may not be moved.
	(iv) Add in the suggestion that c-special-indent-hook may sometimes be a
	  better idea than line-up functions.
	There are minor consequential changes on other pages.

2005-09-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	(i) Partition the over-large @section "Line-Up Functions".
	(ii) Expand the description of c-special-indent-hook.
	(iii) Add cross references between "Other Indentation" and "Custom
	  Line-up", emphasizing that c-special-indent-hook functions and line-up
	  functions are alternatives.

2005-09-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el: Amend the doc-string of c-set-style, in reponse to
	a report from Joseph Kiniry <kiniry@acm.org> that it was difficult
	to understand.

2005-09-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-on-identifier): Fixed bug when at the first char
	of an identifier.

	* cc-engine.el (c-on-identifier): Handle the "operator +" syntax
	in C++.

2005-09-09  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi ("Syntactic Analysis"): Minor amendments.
	("Syntactic Symbols"): Partition this monster into a section with
	  thirteen subsections, each of which (more or less) illustrates a coherent
	  grouping of symbols.
	  Replace the spurious references to substatement-block-intro with
	  statement-block-intro.
	  Add @ssindex entries for those symbols missing them.

2005-09-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Some general tidying up and clarification.  Also:
	(Hooks):  mention c-special-indent-hook
	(FAQ): Commented out the question about M-[ae] going into blocks.

2005-08-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	55 Changes, great and small.  Most of them are minor linguistic
	improvements, clarifications, adding xrefs, bug fixes, or the like, but
	there are also several more notable changes:
	(i) "Config Strategies": State which setting takes precedence when
	  conflicting settings are made (e.g. both in a style and in a hook).
	(ii) "Config Strategies": Add a bit about "File Styles".
	(iii) "File Styles": Fleshed out this chapter quite a bit.
	(iv) "Mode Initialization": Removed this embryonic node (which was far
	  from complete or useful) and all references to it.

2005-08-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): correct, so that auto-fill
	doesn't split a c-comment's last word from a hanging "*/" when a
	space is typed between them after fill-column.

	cc-defs.el: New macro c-delete-and-extract-region.

2005-06-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-set-style, c-setup-paragraph-variables): Abort
	the command if we're not in a CC Mode buffer.

2005-06-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-C-comments): Correct indentation with
	blank comment-prefix, and a blank line as the comment's second
	line.

2005-05-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-cpp-matchers, c-basic-matchers-before):
	Incorporated the patterns added in the Emacs development branch
	for the new Emacs 22 face `font-lock-negation-char-face'.

	* cc-fonts.el (c-invalid-face-name): Use "red1" instead of "red"
	since it stands out better in xterms and DOS terminals.

	* cc-engine.el (c-literal-faces): Added
	`font-lock-comment-delimiter-face' which is new in Emacs 22.

	* cc-fonts.el (c-font-lock-declarators): Fixed bug where the point
	could go past the limit in decoration level 2, thereby causing
	errors during interactive fontification.

2005-05-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Add documention for the new electric minor mode and finish that for clean-up
	comment-close-slash.  Tidy up the structure a bit, make some minor linguistic
	improvements.  In detail:

	Change "Clean-ups" from being a section of "Custom auto-newlines) to being its
	  own section, since it documents some stuff which is independent of
	  auto-nelines.
	Change "Auto-newlines" and "Hungry WS Deletion" from being subsections of
	  "Minor Modes" to their own sections, since they're to important to hide.
	  Move "Electric Keys" alongside them, since it now bears the same
	  relationship to "Minor Modes" as "Auto-newlines" and "Hungry WS .." do.
	"Indentation Commands":  Add a convenience description of standard (X)Emacs
	  C-j.
	"Minor Modes":
	  (i) Document the new "electric minor mode" with toggle C-c C-l, and the
	    coupling between it and c-toggle-auto-newline.
	  (ii) Remove the description of the defunct `c-toggle-auto-hungry-state'.
	  (iii) Update the description of the modeline flags.
	  (iv) Recast the node considerably in the process.
	"Electric Keys and Keywords":
	  (i) Add a note that electric minor mode needs to be enabled for (most of)
	    the stuff here to work.
	  (ii) Mention the new clean-up comment-close-slash.
	  (iii) Note the electric actions which don't need electric minor mode to be
	    enabled.
	"Sample .emacs File":  Replace c-toggle-auto-hungry-state with
	  c-toggle-\(auto-newline\|hungry-state\).
	"FAQ": Add an entry "How do I stop my code jumping all over the place when I
	  type?".

2005-05-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Correct previous patch to c-toggle-auto-newline.

	* cc-mode.texi: Document the new clean-up `comment-close-slash'.

	* cc-cmds.el: Make C-c C-a (`c-toggle-auto-newline') forcibly
	enable c-electric-flag.

2005-05-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el, cc-cmds.el: New clean-up `comment-close-slash' on
	c-electric-slash: if enabled, typing `/' just after the
	comment-prefix of a C-style comment will close that comment.

2005-05-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Sync with Lute Kamstra's patch from emacs-devel to
	prevent a superfluous cc-mode.ss index file being built with
	texi2dvi.

2005-05-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-basic-matchers-before, c-complex-decl-matchers):
	Fixed the "not-arrow-prefix" regexp used in Pike.

	* cc-langs.el (c-other-op-syntax-tokens): Only C++ has digraphs.

2005-04-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Resolve some CVS conflict markers.

	* cc-mode.texi: Custom Filling and Breaking: State that
	c-comment-prefix regexp can be an association list.

2005-04-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el, cc-engine.el
	(c-cpp-message-directives, c-cpp-include-directives,
	c-opt-cpp-macro-define, c-opt-cpp-macro-define-start,
	c-cpp-expr-directives): Introduced new language constants to
	control cpp syntax in a cleaner way.

	(c-cpp-expr-functions): Renamed from c-cpp-defined-fns.

	(c-cpp-matchers, c-forward-to-cpp-define-body): Use them.

2005-04-10  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-make-inherited-keymap): Fixed cc-bytecomp bug when
	the file is evaluated interactively.

	* cc-langs.el, cc-fonts.el (c-string-escaped-newlines,
	c-multiline-string-start-char): New language constants and
	variables to specify how newlines in string literals work.

	(c-font-lock-invalid-string): Use them.

	* cc-mode.texi: Removed hint that the one-liner-defun cleanup only
	would be useful/relevant in AWK mode.

	* cc-cmds.el (c-try-one-liner): Robustness fix if an unbalanced
	close brace is entered.  Optimization by avoiding going back over
	arbitrarily large blocks.  Removed hints that this function only
	would be relevant/useful in AWK.

	(c-electric-brace): Indent syntactically after the cleanups since
	lineup functions might do it differently then.

	* cc-engine.el, cc-langs.el (c-opt-op-identifier-prefix): New
	language constant and variable.

	(c-just-after-func-arglist-p, c-after-special-operator-id,
	c-search-decl-header-end, c-inside-bracelist-p): Use it.

2005-02-14  Kevin Ryde  <user42@zip.com.au>:

	* cc-align.el (c-lineup-argcont): Ignore conses for {} pairs from
	c-parse-state, to avoid a lisp error (on bad code).

2005-04-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Handle operator
	declarations somewhat better in C++.

	* cc-align.el, cc-engine.el (c-after-special-operator-id): New
	helper to handle C++ operator identifiers.

	(c-lineup-topmost-intro-cont, c-just-after-func-arglist-p,
	c-guess-basic-syntax): Handle C++ operator identifiers in
	declarations.

	* cc-langs.el (c-assignment-operators): Added the trigraph version
	of ^= too.

	* cc-langs.el (c-assignment-operators): Added the trigraph version
	of |= in C++.

2005-04-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: "Advanced Customizations": Finally remove the
	vestiges of this chapter.  Resolve three other minor FIXMEs.

2005-04-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarators): Handle
	`c-decl-hangon-kwds' after the identifier name.

	* cc-engine.el (c-guess-basic-syntax): When deciding whether an
	arglist is "nonempty", ignore a comment after the open paren if it
	isn't followed by a non-comment token on the same line.

	* cc-engine.el (c-guess-basic-syntax): Case 4: Enable heuristics
	below the point to cope with classes inside special brace lists in
	Pike.

2005-04-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Correct a typo in the sourceforge CVS URL.

	* cc-mode.texi: Add a statement that the manual is GPL'd.  Add a
	pointer to the manual's source at sourceforge.

2005-04-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el:  Amend c-point-syntax to handle macros.

2005-03-29  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-guess.el (cc-guess-install):
	New function to install an already guessed style
	in another buffer.

2005-02-14  Kevin Ryde  <user42@zip.com.au>

	* cc-mode.texi (File Styles): Cross reference emacs file local
	variables, correction to grammatical typo.

2005-03-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-guess.el: Improvement contributed by Masatake YAMATO:
	Frequency is now taken into account to make a better guess.

	(cc-guess-region): Inverted the RESET argument to make it more
	convenient.  The guessed style is also merged into
	`c-offsets-alist' right away.

	(cc-guess, cc-guess-view-style): New functions.

2005-03-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-tentative-buffer-changes): No longer sets
	`inhibit-read-only' - `c-save-buffer-state' should be used anyway
	if the change always is undone.

2005-03-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Implement togglable electricity:

	* cc-defs.el: Enhance c-save-buffer-state's doc-string, saying
	when it should be used.

	* cc-engine.el: Add the new buffer-local variable,
	c-electric-flag.

	* cc-langs.el: Change the name of c-toggle-auto-state to
	c-toggle-auto-newline.

	* cc-mode.el: Rename c-toggle-auto-state to c-toggle-auto-newline.
	Remove the binding for c-toggle-auto-hungry-state.  Add the
	binding C-c C-l for the new c-toggle-electric-state.

	* cc-vars.el: Make c-syntactic-indentation buffer local.

	* cc-cmds.el: Add `c-bytecomp-defun's for
	c-\(forward\|backward\)-subword.
	(c-update-modeline): Add the new modeline flag `l' for
	`c-electric-flag'.  Make the auto-newline flag `a' dependent on
	`l'.
	(c-toggle-auto-state): Rename it to `c-toggle-auto-newline'.  Make
	the old name an alias of the new name.
	(c-toggle-auto-hungry-state): Removed.
	(c-toggle-electric-state): New function.
	c-electric-\(pound\|brace\|slash\|star\|semi&comma\|colon\|lt-gt\|paren\|continued-statement\):
	Adapt these functions to do electric things only when
	c-electric-flag is non-nil.
	(c-point-syntax, c-brace-newlines, c-try-oneliner): Extract these
	new functions from c-electric-brace.
	(c-point-syntax): Add a check for "virtual semicolons" in AWK
	mode, so that the tentative extra newline doesn't change the
	syntax of the following brace.
	(c-electric-brace): restructure by extracting the above functions.
	Tidy up the coding somewhat.
	(c-electric-semi&comma, c-electric-colon, c-electric-paren):
	restructure a bit.

	* cc-mode.texi:
	"Electric Keys": Amend description of `<' and `>': they are also electric when
	  they are template brackets.
	"Other Commands": Add an entry for the standard Emacs command `comment-region'
	  which has CC Mode binding C-c C-c.
	"Custom Filling and Breaking": Purge the description of
	  `c-comment-prefix-regexp' of confusing gobbledygook.

2005-03-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Filling and Breaking":  Add a cross reference to "Custom Filling and
	Breaking".
	Several minor amendments.

2005-02-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Merge the changes made on branch texi-0-1 back to HEAD.

2005-01-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Overview":  Get rid of reference to "AWK" section;
	"Sample .emacs FILE":  Put key bindings into c-initialization-hook;
	  Move the c-add-style call from out of the c-mode-hook.

2004-12-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	In the GNU/XEmacs conditional things, replace "X" by "XEMACS" for clarity.
	Rename the chapter "Indentation Engine" to "Indentation Engine Basics".
	"Indentation Commands": Add stuff about macros (taken from the old "Macro
	  Handling" chapter).
	"Other Commands":  Move the description of "c-backslash-region" into here.
	Rename "Macro Handling" to "Custom Macros", having moved the stuff other than
	  customization to other chapters.

	* cc-vars.el: Remove the erroneous (doubly inserted) patch from
	yesterday.

2004-12-18  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-show-syntactic-information): Show the anchor
	position(s) using faces.  Thanks to Masatake YAMATO for the idea.

	* cc-mode.el, cc-cmds.el, cc-defs.el, cc-engine.el
	(c-submode-indicators): Changed name from `c-auto-hungry-string'
	since it's now used to track another submode.

	(c-update-modeline): Converted to function and extended to check
	`c-subword-move-mode'.

	(c-forward-into-nomenclature, c-backward-into-nomenclature):
	Converted to compat aliases for `c-forward-subword' and
	`c-backward-subword'.

	* cc-subword.el: New functions and minor mode to handle
	SillyCapsedStyleIndentifiers, contributed by Masatake YAMATO:

	(c-forward-subword, c-backward-subword, c-mark-subword,
	c-kill-subword, c-backward-kill-subword, c-transpose-subwords,
	c-capitalize-subword, c-downcase-subword, c-upcase-subword):
	Functions corresponding to the standard word handling functions.

	(c-subword-move-mode): Minor mode that replaces all the standard
	word handling functions with their subword equivalences.

2004-12-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-cleanup-list): Insert a customization entry for
	one-liner-defun.

2004-12-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el: Give c-tentative-buffer-changes its own name in its
	def-edebug-spec.

	* cc-cmds.el (c-electric-brace): Make the one-liner-defun clean-up
	work with empty-defun-braces.  o-l-d now compacts space before a
	comment, if this will make things fit on one line.

2004-12-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"AWK Mode Defuns":  Removed this subsection, transferring its contents to
	  "Movement Commands"
	"Movement Commands":  Condensed the separate descriptions of
	  complementary -backward-* and -forward-* commands into joint
	  descriptions.

2004-12-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Introduction":  Integrated Alan more tightly into CC-Mode.  ;-)
	"Overview":  New chapter describing the structure of the manual.
	"Other Commands":  Added a description of c-macro-expand.
	"Built-in Styles":  Added a description of the new "awk" style.
	"Custom Braces" and "Hanging Semicolons and Commas":  Specify the meaning of
	  point in action functions, and that is must be preserved.
	"Clean-ups":  Document the new clean-up one-liner-defun and associated
	  variable c-max-one-liner-length.
	"Customizing Indentation" is now its own chapter rather than being a section
	  of "Indentation Engine".
	"AWK Mode:  Removed the entire chapter, moving the two remaining useful
	  sections to "Font Locking" and "Movement Commands".
	Added/Moved lots of index entries.

2004-11-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Add a fourth parameter `t' to the awk-mode autoload,
	so that it is interactive, hence can be found by M-x awk-mode
	whilst cc-mode is yet to be loaded.  Reported by Glenn Morris
	<gmorris+emacs@ast.cam.ac.uk>.

2004-11-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce an "awk" style, mainly for auto-newline and clean-ups.

	* cc-align.el: new function c-snug-1line-defun-close

	* cc-cmds.el: In c-electric-brace, add code for new clean-up
	one-liner-defun.
	
	* cc-styles.el: Add the new "awk" style.

	* cc-vars.el: Add description of one-liner-defun to
	c-cleanup-list's doc-string.  New user options,
	c-max-one-liner-length.  In c-default-style, set the default style
	for AWK to "awk".

2004-11-28  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-styles.el (c-run-mode-hooks): New helper macro to
	make use of `run-mode-hooks' which has been added in Emacs 21.1.

	(c-mode, c++-mode, objc-mode, java-mode, idl-mode, pike-mode,
	awk-mode): Use it.

	(make-local-hook): Suppress warning about obsoleteness which has
	been added in Emacs 21.1.

2004-11-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-label): Fixed fontification of macros
	inside labels.

2004-11-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	(i) Some general tidying up, remove @ignore sections, etc.
	(ii) Firm up the mechanism for generating @xrefs to the Emacs/Xemacs
	  manual and the Elisp/Lispref manual.  There are now four macros,
	  @emacsman{}, @lispref{}, @emacsmantitle{}, @lispreftitle{} which
	  generate the filenames and titles (for the printed versions) of the
	  manuals pertinent to Emacs or XEmacs, depending on whether the makeinfo
	  variable `X' is defined or not.  The titles were taken from the
	  @settitle lines in the source files of the four manuals.  In the
	  process, the title "The Emacs Editor" has been amended to "GNU Emacs
	  Manual".

2004-10-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Much general tidying up of the wording.
	"Auto-newlines"
	  (i) Add a note that c-electric-* only do their stuff when last on
	    line.
	  (ii) State that a `before' auto-newline is never added if the `{'
	    etc. is "already on a newline".
	  (iii) Replace the statement of where auto-newlines go by default (it
	    was wrong and oversimplified) by a statement that the style system
	    does the configuration most of the time.
	"Custom Auto-newlines"
	  (i) Make the page what it says it is, removing the stuff which is now
	    in "Commands".
	  (ii) Add a @dfn{} for "hang", and "hanging on the left/right".
	  (iii)
	"Hanging Braces"
	  (i) Insert an @enumerated section describing the algorithm.
	  (ii) Insert a more robust description of c-hanging-braces-alist.
	  (iii)
	"Hanging Colons"
	  (i) Update this page to mirror "Hanging Braces".
	  (ii) State that the default action (if no alist entry) is to add no
	    newlines.
	"Custom Semis and Commas"
	  (i) Add clarification that criteria functions don't themselves add
	    newlines.
	  (ii) State that NLs never get added _before_ a `;' or `,'.
	  (iii)
	"Clean-ups"
	  (i) Give an actual definition of "Clean-up" for the @dfn{}. ;-)

	Moved the @section "Custom Brace and Colon Hanging" away from "Advanced
	  Customizations" to underneath "Hanging Braces", removing the spurious
	  "and Colons" from its name.
	Moved the contents of the @section "Customizing Semicolons and Commas"
	  away from "Advanced Customizations" and inserted them into "Hanging
	  Semicolons and Commas" (which previously had only a pointer into the
	  CSaC node).
	"Advanced Customization" is now almost content free.

	Add Experimental macros for "Emacs"/"XEmacs" and "Elisp"/"Lispref", in
	  the hope they might enable a better XEmacs version of the manual.

2004-10-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el, cc-align.el
	(c-append-backslashes-forward, c-delete-backslashes-forward,
	c-find-decl-spots, c-semi&comma-no-newlines-before-nonblanks):
	Compensate for return value from `forward-line' when it has moved
	but not to a different line due to eob.

2004-10-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-bos): Obsoleted in favor of
	`c-at-statement-start-p' and `c-at-expression-start-p'.

	* cc-defs.el (c-tnt-chng-record-state): Don't signal an error if
	the mark isn't set.

	* cc-engine.el (c-guess-basic-syntax): Fixed anchoring in
	`objc-method-intro' and `objc-method-args-cont'.

	* cc-engine.el (c-guess-continued-construct,
	c-guess-basic-syntax): Use `c-forward-decl-or-cast-1' to more
	accurately detect functions inside functions.

2004-09-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Reorder the chapters a bit on the principle "Most basic earliest":
	  Move "Font locking" with contents to just after "Commands".
	  Move "Indentation Engine" with contents to just after "Custom Filling and
	    Breaking".
	  Move "Custom Filling and Line Breaking" to before "Custom Auto-Newlines".

2004-09-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Add a "Mode Initialization" section (as yet, content free) to
	    "Configuration Strategies".
	  Move "Minor Modes" into the "Commands" chapter.  Remove the
	    configuration instructions from its submode "Auto-newlines".  Outline
	    the default configuration for auto-newlines here.
	  Rename the old "Auto-newline insertion" to "Customizing Auto-newline
	    Mode" and make it a @chapter in its own right, containing four
	    sections.  The content of this @chapter is yet to be adapted.
	  Amend the descriptions in "Minor Modes" of the key sequences, using
	    @table rather than an unbroken textual paragraph.
	  Amend "Electric Keys", so that there is explicit reference to
	    "Clean-ups" in the right places.  All electric actions are now
	    collected together in this section.
	  Condense the description of '*' and '/' in Electric keys.
	  In "Clean-ups" insert "@tie{}" where a critical space was getting lost
	    in line wrap.
	  Tidy up a lot of wording.
	  Introduce an experimental facility which will build either a GNU Emacs
	    or an XEmacs specific info file.

2004-09-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-at-expression-start-p): New function like
	`c-at-statement-start-p' that additionally recognizes commas and
	expression parentheses as delimiters.

2004-09-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el: Add character classes (e.g. "[:alpha:]") into AWK
	Mode's regexps.

2004-09-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Move the page "Hungry WS Deletion" into the
	"Commands" chapter, and revise this node for (hopefull) increased
	clarity.

2004-09-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Reduce the length of many node names, (following
	suggestion on emacs-devel).  Tidy up some of the wording.

2004-09-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:   Added ACM to the list of authors.
	  Renamed "Other Electric Commands" to "Electric Keys and Keywords"
	  In "Electric Keys and Keywords", added descriptions of {, }, :, ;, ,,,
	    and tidied up the wording a bit.
	  Tidied up the wording and presentation of "Configuration Strategies".
	  In "Customizing Filling and Line Breaking", expanded the description of
	    c-comment-prefix-regexp.

2004-08-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Moved the "Commands" chapter to near the start of the file.
	  Moved "Other Electric Commands" into the "Commands" chapter.
	  Split "Text Filling and Line Breaking" into the "Filling and Line
	Breaking Commands" (a section under "Commands"), and "Customizing Filling
	and Line Breaking".

2004-08-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Update the master menu for the file.

	* cc-mode.texi:
	  This change is the first stage in the restructuring of cc-mode.texi.
	  Added new chapter, "Configuration Strategies", and converted "Hooks" and
	"Styles" (together with the latter's sub-nodes) into sections of this new
	chapter.
	  Converted "Syntactic Symbols" and "Customizing Indentation" (together with
	the latter's sub-nodes "Interactive C.." and "Permanent C..") into sections of
	"Indentation Engine".  "Customizing Indentation" has acquired "Line-Up
	Functions", "Custom Line-up Functions" and "Other Special Indentations" as
	sub-nodes, but has lost "Hooks" and "Styles").
	  "Advanced Customization", formerly a sub-node of "Customizing Indentation"
	is now a chapter in its own right.  It has lost "Custom Line-Up Functions" and
	"Other Indentations".

2004-06-29  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block): Added flag to avoid
	heuristics that doesn't work for unclosed blocks.

	(c-at-statement-start-p): New function.

2004-06-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Added an FAQ item about the
	open-paren-in-column-zero issue.

2004-05-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-vars.el (c-emacs-features): Moved from cc-vars to
	cc-defs for dependency reasons.  Fixed the POSIX char class test
	to check that it works in `skip-chars-(forward|backward)' too.

	* cc-align.el (c-lineup-arglist): Fixed bug when the first
	argument starts with a special brace list.

2004-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-type): Fixed promotion bug when
	`c-opt-type-concat-key' is used
	(i.e. in Pike).

	* cc-engine.el (c-looking-at-special-brace-list): Fixed bug when
	the inner char pair doesn't have paren syntax, i.e. "(< >)".

2004-04-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Amend doc(-strings) to say that <TAB> doesn't insert WS into a CPP
	line.

	* cc-cmds.el, cc-vars.el (c-indent-command, c-tab-always-indent):
	Amend doc strings.

	* cc-mode.texi (@node Indentation Commands): Amend documentation
	of c-tab-always-indent.

2004-04-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-multi-inher): Made it syntactic whitespace
	safe.

2004-04-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el: Fixes in handling of Objective-C
	directives, e.g. directives spanning lines should work reasonably
	well now.

	(c-put-c-type-property, c-clear-c-type-property): New helpers.

	(c-forward-objc-directive): New function to move over any ObjC
	directive.

	(c-just-after-func-arglist-p, c-guess-basic-syntax,
	c-basic-matchers-before): Use it.

	(c-font-lock-objc-iip-decl): Removed.

	* cc-engine.el (c-guess-basic-syntax): Some improvement in the
	template arglist recognition.

2004-04-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist): Fixed several inconsistencies in
	the Whitesmith style.

	* cc-mode.texi: Documented c-lineup-after-whitesmith-blocks.  Some
	other fixes.

	* cc-align.el (c-lineup-after-whitesmith-blocks): New lineup
	function to get lines after Whitesmith style blocks correctly
	indented.

	(c-lineup-whitesmith-in-block): Backed out the compensation for
	opening parens since it's done using `add' lists in the style
	definition instead.  Don't use the anchor position since it varies
	too much between the syntactic symbols. :P

	* cc-vars.el (c-valid-offset): Updated.

	* cc-mode.texi: Updated the doc for offset specifications on
	`c-offsets-alist'.

	* cc-engine.el (c-evaluate-offset): Extended to handle lists where
	the offsets are combined according to several different methods:
	`first', `min', `max', and `add'.  Report offset evaluation errors
	with `c-benign-error' so that some kind of reindentation still is
	done.

	* cc-engine.el (c-guess-basic-syntax): Anchor `arglist-intro' the
	same way as `arglist-cont-nonempty' and `arglist-close'.

	* cc-engine.el (c-guess-basic-syntax): Fixed similar situations
	for `arglist-cont-nonempty' and `arglist-close'.

2004-04-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed anchor position for
	`arglist-intro' when there are two arglist open parens on the same
	line and there's nothing in front of the first.

	* cc-mode.texi: Updated the parts dealing with line-up functions.
	Fixed some terminology to use the same words everywhere.

	* cc-langs.el (c-opt-identifier-concat-key-depth): New constant.

	* cc-fonts.el (c-basic-matchers-before): Fixed font locking of
	qualified names in Java, which previously could fontify common
	indexing expressions in many cases.  The standard Java naming
	conventions are used to tell them apart.

2004-04-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el: Use `cc-bytecomp-fboundp' and cc-bytecomp-boundp' in
	a number of places.

2004-04-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-whitesmith-in-block): Fixed inconsistency
	wrt opening parens on the first line inside a paren block.

	* cc-defs.el (c-langs-are-parametric): Made it known at compile
	time to avoid warnings.

	* cc-defs.el (c-langs-are-parametric): Must be known at compile
	time for the sake of `c-major-mode-is'.

	(c-mode-is-new-awk-p): Made it a macro to delay expansion of
	`c-major-mode-is' in the event that this is used inside a
	`c-lang-defconst'.

2004-04-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Fixed a macro related
	issue.

2004-04-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-cmds.el, cc-awk.el: Remove (nearly all of) the
	cruft associated with AWK Mode's former concept of "virtual
	semicolons".

	* cc-styles.el, cc-vars.el, cc-engine.el, cc-cmds.el, cc-awk.el:
	1. Add character classes (e.g. "[:alpha:]") into AWK Mode's regexps.
	2. Adapt c-beginning-of-statement, c-end-of-statement (together with
	   subfunctions) to use the new notion of "virtual semicolon" in place of the
	   old awkward special handling for AWK.  There remains much cruft in
	   cc-awk.el, cc-cmds.el and cc-engine.el to clear out.

	* cc-awk.el: Change the terminology of regexps:  A char list is now [asdf],
	  a char class [:alpha:].  Include code for char classes.
	  Set c-awk-NL-prop on lines ending in open strings.  (Bug fix.)

	* cc-cmds.el:
	(c-ascertain-adjacent-literal): In the backwards direction, now
	recognises AWK regexp delimiters as string delimiters.
	(c-after-statement-terminator-p): Adapt for virtual semicolons;
	check more rigorously for "end of macro".
	(c-back-over-illiterals, c-forward-over-illiterals): Adapt for
	virtual semicolons;
	(c-beginning-of-statement): Adapt for virtual semicolons; Separate
	out the code for forward movement into ...
	(c-end-of-statement): Now contains the code for forward movement,
	adapted for virtual semicolons.

	* cc-engine.el:
	(c-ws*-string-limit-regexp): new regexp.
	(c-forward-single-comment, c-backward-single-comment): Comment out
	the (now redundant) "special" AWK stuff.

	* cc-styles.el, cc-vars.el: Change the settings of
	c-string-par-start, c-string-par-separate to be more like Text
	Mode than Fundamental Mode.

2004-03-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-styles.el:
	Add in two checks for user errors, thus eliminating cryptic and unhelpful
	  Emacs error messages. (1) Check the arg to `c-set-style' is a string.
	  (2) Check that settings to `c-offsets-alist' are not spuriously quoted.

2004-03-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Synchronise with the 5.31 latest version, 5.197,
	in particular enhancing the documentation of `c-add-style'.

2004-03-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Enhanced the style doc somewhat more.

2004-03-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-major-mode-is): Fixed expansion inside
	`c-lang-defconst' so that it works better with fallback languages.

	* cc-defs.el (c-add-language): Fixed a typo that caused it to fail
	to record the base mode.

2004-03-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Always narrow to the
	fontified region so that fontification doesn't occur outside it
	(could happen e.g. when fontifying a line with an unfinished
	declaration).

2004-03-18  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-re-search-forward): Fixed bug so that
	it doesn't go past the closing paren when PAREN-LEVEL is used.
	Reordered the syntax checks to get more efficient skipping in some
	situations.

2004-03-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el, cc-defs.el, cc-engine.el, cc-langs.el, cc-mode.el:
	Amend the concept of "virtual semicolons" (in the indentation engine) for
	languages like AWK, such that they are now conceptually attached to end of the
	last token of a statement, not the end of the line.  (In AWK Mode, however,
	the pertinent text property is still physically set on the EOL.)  Remove the
	specific tests for awk-mode, thus facilitating the introduction of other
	language modes where EOLs can end statements.  (Note: The funtionality in
	cc-cmds.el, specifically c-beginning/end-of-statement has yet to be amended.)

	* cc-awk.el:  Regexps for analysing AWK code have been moved to near the start
	  of the file.  ^L now separate sections of the file.
	  New defconsts: c-awk-non-eol-esc-pair-re,
	  c-awk-blank-or-comment-line-re, c-awk-one-line-possibly-open-string-re,
	  c-awk-regexp-one-line-possibly-open-char-class-re,
	  c-awk-one-line-possibly-open-regexp-re, c-awk-one-line-non-syn-ws*-re.
	  New functions: c-awk-at-vsemi-p, c-awk-vsemi-status-unknown-p.
	* cc-defs.el:  New macros c-at-vsemi-p, c-vsemi-status-unknown-p.

	* cc-langs.el:  Added `#' into AWK Mode's value of c-stmt-delim-chars.  New
	  c-lang-defvars: c-at-vsemi-p-fn, c-vsemi-status-unknown-p-fn (in a new
	  page).

	* cc-engine.el:  In c-beginning-of-statement-1, c-crosses-statement-barrier-p,
	  c-guess-basic-syntax, replace numerous awkward forms like
	  (if (c-major-mode-is 'awk-mode) (c-awk-prev-line-incomplete-p)) with
	  (c-at-vsemi-p).  Fix a few typos.  In c-guess-basic-syntax, new variable
	  before-ws-ip, the place just after char-before-ip appears.

	* cc-mode.el:  Fix what's almost a semantic ambiguity in a comment.

2004-03-02  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Cleaned up using
	`c-tentative-buffer-changes'.

	* cc-defs.el (c-region-is-active-p): Simplified and converted to
	macro to choose between Emacs and XEmacs at compile time.

	(c-set-region-active): New set counterpart to
	`c-region-is-active-p'.

	(c-tentative-buffer-changes): New macro to handle temporary buffer
	changes in a convenient way.

	(c-tnt-chng-record-state, c-tnt-chng-cleanup): Internal helpers
	for `c-tentative-buffer-changes'.

	* cc-cmds.el (c-electric-brace): Don't trip up on a line
	continuation which might precede the newly inserted '{'.

2004-03-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-re-search-forward): Fixed cases where
	it could loop indefinitely.

2004-02-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block): Tightened up the
	checks for paren sexps between the point and the keyword, to avoid
	some false alarms.

	* cc-engine.el, cc-langs.el (c-looking-at-inexpr-block): Fixed a
	situation where an error could be thrown for unbalanced parens.
	Changed to make use of c-keyword-member' to avoid some repeated
	regexp matches.

	(c-opt-lambda-key, c-opt-inexpr-block-key,
	c-opt-inexpr-class-key): These language variable are no longer
	necessary.

	(c-block-stmt-kwds): New language constant used by
	c-looking-at-inexpr-block'.

	(c-guess-basic-syntax): Removed an optional check that looked at
	the existence of the now removed language variables.

	* cc-engine.el (c-fdoc-shift-type-backward,
	c-forward-decl-or-cast-1): Fixed invalid recognition of C++ style
	object instantiation expressions as declarations in some contexts.
	This bug only affected languages where the declarator can't be
	enclosed in parentheses.

2004-02-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (c-block-comment-prefix): State that it's default
	setting, "* " gets overridden by the default style, gnu.

2004-02-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist): Fixed the GNU style to insert
	newlines before and after substatement braces.

2004-02-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el: Improved the heuristics for recognizing function
	declaration headers and the handling of C++ style member init
	lists.

	(c-just-after-func-arglist-p): Rewritten to use
	`c-forward-decl-or-cast-1'.  Now behaves a bit differently too.

	(c-beginning-of-member-init-list): Removed since it isn't used
	anymore.

	(c-guess-basic-syntax): Case 5B adapted for the new
	`c-just-after-func-arglist-p'.  Cases 5B.1 and 5B.3 merged.  Cases
	5D.1 and 5D.2 removed since they aren't trigged anymore (case 5B.1
	covers all cases now).

	* cc-defs.el (c-point): Added 'bosws and 'eosws.

2004-02-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el, cc-vars.el: Correct silly bug in previous commit.

	* cc-cmds.el, cc-styles.el, cc-vars.el:
	New variables c-string-par-start/separate c-sentence-end-with-esc-eol,
	  initialised in c-setup-paragraph-variables, used in string scanning
	  subroutines of c-beginning-of-statement.

2004-02-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): don't delete a comment which
	precedes the newly inserted `{'.

2003-12-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarators): Handle array size specs
	correctly.  Only fontify identifiers in front of '(' with as
	functions - don't accept any paren char.  Tightened up initializer
	skipping to stop before function and class blocks.

2003-12-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el: Rewrote the recognition function for
	declaration level blocks.  It should now cope with templates
	better and also be a lot more comprehensible.

	(c-looking-at-decl-block): The new function.

	(c-search-uplist-for-classkey): The old one.  It's now a wrapper
	for compatibility.

	(c-add-class-syntax, c-guess-continued-construct,
	c-guess-basic-syntax): Adapted for `c-looking-at-decl-block'.

	(c-decl-block-key): Changed to tell apart ambiguous and
	unambiguous keywords.  Pike specials are now handled directly in
	the code instead.

	(c-block-prefix-disallowed-chars, c-block-prefix-charset): New
	language constants and variables to make the backward skip in
	`c-looking-at-decl-block' as tight as possible.

	(c-nonsymbol-token-char-list): New language constant.

	* cc-engine.el (c-backward-<>-arglist): New function to find
	balanced template arglists backwards.

	* cc-defs.el (c-make-bare-char-alt): New helper for making char
	classes for `c-syntactic-skip-backward'.

	* cc-engine.el (c-guess-basic-syntax): Simplified case 16D - can't
	be a class-close at that point.

	* cc-engine.el (c-guess-basic-syntax, c-add-class-syntax): Don't
	narrow out the enclosing declaration level.  This makes everything
	a lot easier, and it was actually only four small places that
	needed it to work.  Some places that previously did `widen' are
	removed now, which has the effect that `c-guess-basic-syntax'
	never will look at things outside the current narrowment now.  The
	anchor position for `topmost-intro' is affected by this, but it
	was so bogus it was basically useless before, and now it's equally
	bogus but in a slightly different way.

	(c-narrow-out-enclosing-class): Gone.

	(c-most-enclosing-brace, c-least-enclosing-brace): Don't filter to
	the narrowed region.

	(c-least-enclosing-brace): Removed silly optional argument.

	* cc-engine.el (c-beginning-of-decl-1): Fixed bug where the point
	could be left directly after an open paren when finding the
	beginning of the first decl in the block.

	* cc-engine.el (c-parse-state): Don't use the syntax table when
	filtering out legitimate open parens to be recorded.  This could
	cause cache inconsistencies when e.g. `c++-template-syntax-table'
	was temporarily in use.

	* cc-engine.el (c-beginning-of-decl-1): Fixed bug where the point
	could be left directly after an open paren when finding the
	beginning of the first decl in the block.

2003-12-06  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el (c-forward-keyword-clause): Specify
	which submatch to use.

	* cc-langs.el (c-symbol-start): Include '@' in ObjC.

	(c-decl-start-re): No no longer any need for special treatment of
	ObjC due to the above.

	(c-other-block-decl-kwds): Handle "extern" in ObjC too since it
	presumably follows C in that regard.

	* cc-langs.el (c-identifier-ops, c-after-id-concat-ops): New
	language constants to specify operator tokens inside identifiers
	in a more high level way.

	(c-opt-identifier-prefix-key): New internal language constant.

	(c-opt-identifier-concat-key, c-opt-after-id-concat-key,
	c-identifier-start, c-identifier-key): Now completely calculated
	from other constants.

	(c-identifier-last-sym-match): Decommissioned since it's no longer
	used.

	(c-operators): Use `c-identifier-ops'.  Documented
	`postfix-if-paren'.

	* cc-engine.el (c-forward-name): Removed the optimization when
	c-identifier-key is equal to c-symbol-key since it doesn't work in
	byte compiled files.  Don't record empty regions as identifiers.

	* cc-langs.el (c-filter-ops): New helper function to simplify
	access to `c-operators' and its likes.

	(c-operator-list, c-all-op-syntax-tokens,
	c-nonsymbol-token-regexp, c-<>-multichar-token-regexp,
	c-<-op-cont-regexp, c->-op-cont-regexp, c-expr-kwds,
	c-primary-expr-regexp, c-cast-parens): Use it.

	* cc-defs.el (c-lang-const): Fixes to allow use without an
	explicit language in functions.

	* cc-defs.el (c-make-keywords-re): Added an appendable variant of
	adornment.

2003-12-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-any-class-key): Removed unused language variable.

	(c-type-decl-prefix-key): Removed some now unnecessary cruft from
	the Pike value.

	* cc-engine.el (c-on-identifier, c-simple-skip-symbol-backward):
	Small fix for handling "-" correctly in `skip-chars-backward'.
	Affected the operator lfun syntax in Pike.

	(c-forward-label): Small fix for handling "-" correctly in
	`c-syntactic-skip-backward'.

	* cc-engine.el (c-on-identifier, c-simple-skip-symbol-backward):
	Small fix for handling "-" correctly in `skip-chars-backward'.
	Affected the operator lfun syntax in Pike.

2003-12-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-make-init-lang-vars-fun): Disabled the diagnostic
	message about precompiled language vars not being used.

	* cc-langs.el (c-paren-nontype-kwds): The GCC keyword
	"__attribute__" is followed by a parenthesis.

	(c-type-start-kwds, c-prefix-spec-kwds, c-prefix-spec-kwds-re,
	c-specifier-key, c-not-decl-init-keywords): Some cleanup using new
	language constants `c-type-start-kwds' and `c-prefix-spec-kwds'.

2003-11-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-invalidate-sws-region-after): Fixed bug that
	could cause an error from `after-change-functions' when the
	changed region is at bob.

	* cc-fonts.el, cc-langs.el, cc-engine.el: Internal cleanups to
	properly detect the declared identifiers in various declarations.

	(c-decl-start-kwds): New language constant to recognize
	declarations that can start anywhere.  Used for class declarations
	in Pike.

	(c-specifier-key, c-not-decl-init-keywords,
	c-decl-prefix-or-start-re, c-find-decl-prefix-search,
	c-find-decl-spots): Implement `c-decl-start-kwds'.

	(c-other-decl-kwds, c-postfix-decl-spec-kwds, c-decl-hangon-kwds,
	c-decl-hangon-key, c-forward-decl-or-cast-1): Separated the
	handling of the compiler specific extension keywords into a new
	language constant `c-decl-hangon-kwds' that defines keyword
	clauses to be ignored in declarations.

	(c-forward-id-comma-list, c-forward-keyword-clause): Don't skip
	past unrecognized tokens when handling `c-colon-type-list-kwds'.
	Necessary to stop at the declared identifier in e.g. IDL valuetype
	declarations.

	(c-typedef-decl-kwds, c-typeless-decl-kwds, c-type-list-kwds,
	c-prefix-spec-kwds-re, c-postfix-spec-kwds,
	c-after-suffixed-type-decl-key, c-opt-postfix-decl-spec-key,
	c-forward-decl-or-cast-1): Recognize the declared identifier in
	class and enum declarations as such and not as part of the type.

	(c-forward-decl-or-cast-1, c-forward-label): Relaxed the
	interpretation of PRECEDING-TOKEN-END when there's no preceding
	token.

	(c-forward-decl-or-cast-1): Don't disregard sure signs of
	declarations when there's some syntax error later on.

	(c-complex-decl-matchers): Did away with a reference to
	`c-specifier-key'.

2003-11-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-maybe-labelp): Provide no default value - this
	variable is always dynamically bound.

2003-11-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el,
	cc-styles.el, cc-vars.el, cc-align.el, cc-awk.el, cc-cmds.el,
	cc-defs.el: Changed the policy for marking up functions that might
	do hidden buffer changes: All such internal functions are now
	marked instead of those that don't.

	(c-beginning-of-macro, c-end-of-macro, c-(forward|backward)-comments,
	c-(forward|backward)-single-comment, c-parse-state, c-on-identifier,
	c-(fast-|slow-|)in-literal, c-literal-limits, c-collect-line-comments,
	c-literal-type): Allow these functions to make hidden buffer changes,
	so that they are free to use text property caching later on.

	(c-electric-backspace, c-electric-delete-forward, c-electric-pound,
	c-electric-brace, c-electric-slash, c-electric-star,
	c-electric-semi&comma, c-electric-colon, c-electric-lt-gt,
	c-electric-paren, c-electric-continued-statement, c-indent-command,
	c-indent-region, c-mask-paragraph, c-indent-new-comment-line,
	c-context-line-break): Added `c-save-buffer-state' calls to comply
	with the changed semantics of the functions above.

	* cc-engine.el (c-beginning-of-statement-1):
	Fixed a bug when macros occur in obscure
	places.  Optimized the sexp movement a bit.

2003-11-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el, cc-cmds.el, cc-engine.el, cc-mode.el, cc-mode.texi:
	Enhancements for c-beginning-of-statement to work in AWK Mode:
	cc-awk.el:
	  Supersede c-awk-NL-prop value `;' (completed statement) with `}' (statement
	    completed by closing brace or semicolon) and `$' (statement completed by
	    EOL).
	  New functions: c-awk-virtual-semicolon-ends-prev-line-p,
	    c-awk-virtual-semicolon-ends-line-p, c-awk-skip-semantic-ws-forward,
	    c-awk-skip-semantic-ws-backward, c-awk-at-statement-end-p.
	cc-cmds.el:
	  Simplify the structure of functions c-forward-over-illiterals,
	    c-back-over-illiterals.
	  Enhance these two functions and c-beginning-of-statement to handle AWK Mode.
	cc-engine.el:
	  Enhance c-forward-single-comment, c-backward-single-comment for AWK mode.
	    Attempt to clarify their doc-strings.
	cc-mode.el:
	  Put M-a and M-e into awk-mode-map.
	cc-mode.texi:
	  Document that M-a and M-e now work in AWK mode.  Fix minor typos.

2003-11-21  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el: Cleaned up the label
	handling.  Labels are now recognized in a uniform and more robust
	way, regardless of context.  Text properties are put on all labels
	to recognize the following declarations better.  Multiword labels
	are handled both in indentation and fontification for the benefit
	of language extensions like Qt.  For consistency, keywords in
	labels are now fontified with the label face instead.  That also
	applies to "case" and "default".

	(c-beginning-of-statement-1): Fixed some bugs in the label
	handling.  Disregard `c-nonlabel-token-key' in labels that begin
	with `c-label-kwds'.

	(c-find-decl-spots): Support that the callback adds more
	`c-decl-end' spots to find.

	(c-forward-decl-or-cast-1): Don't treat a list of plain
	identifiers followed by a colon as a declaration.

	(c-forward-label): New function to recognize labels.

	(c-guess-basic-syntax): Replaced uses of `c-label-key' with
	`c-forward-label'.  Moved the label recognition cases (14 and 15)
	earlier since they aren't so context sensitive now.  Handle labels
	on the top level gracefully.  Moved access label recognition to
	the generic label case (CASE 15) - removed CASE 5E.

	(c-font-lock-declarations): Added recognition of labels in the
	same round since we need to handle labels in parallell with other
	declarations to recognize both accurately.  It should also improve
	speed.

	(c-simple-decl-matchers, c-basic-matchers-after): Moved
	`c-font-lock-labels' so that it only is used on decoration level 2
	since `c-font-lock-declarations' handles it otherwise.

	(c-complex-decl-matchers): Removed the simplistic recognition of
	access labels.

	(c-decl-prefix-re): Removed the kludges that was necessary to cope
	with labels earlier.

	(c-decl-start-re): New language variable to make
	`c-font-lock-declarations' stop for the special protection labels
	in Objective-C that start with '@'.

	(c-label-key): Removed since it's no longer used.

	(c-recognize-colon-labels, c-label-prefix-re): New language
	constants to support recognition of generic colon-terminated
	labels.

	(c-type-decl-end-used): `c-decl-end' is now used whenever there
	are colon terminated labels.

	* cc-align.el (c-lineup-arglist): Fixed bug when the first
	argument starts with a special brace list.

2003-11-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el (c-forward-decl-or-cast-1,
	c-font-lock-declarations): Broke out the declaration and cast
	recognition from `c-font-lock-declarations' to a new function, so
	that it can be used in the indentation engine.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-continued-construct,
	c-guess-basic-syntax): Check a little more carefully if it's an
	function declaration when an unknown construct followed by a block
	is found inside a statement context.  This avoids macros followed
	by blocks to be taken as function declarations.

	(c-guess-continued-construct): Changed the analysis of a statement
	continuation with a brace open to `substatement-block', for
	consistency with recognized statements.

	(c-add-stmt-syntax): Don't continue to the surrounding sexp if the
	start is in a position so that `c-beginning-of-statement-1' jumped
	to the beginning of the same statement.

	* cc-engine.el (c-guess-continued-construct,
	c-guess-basic-syntax): Check a little more carefully if it's an
	function declaration when an unknown construct followed by a block
	is found inside a statement context.  This avoids macros followed
	by blocks to be taken as function declarations.

	(c-guess-continued-construct): Changed the analysis of a statement
	continuation with a brace open to `substatement-block', for
	consistency with recognized statements.

2003-11-15  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-cmds.el, cc-engine.el
	(c-forward-<>-arglist-recur): Don't accept binary operators in the
	arglist if we're in a function call context, i.e. if
	`c-restricted-<>-arglists' is set.  That avoids template
	recognition in cases like "if (a < b || c > d)".

	(c-restricted-<>-arglists): New more appropriate name for
	`c-disallow-comma-in-<>-arglists'.

	Accessing functions updated for the variable name change.

2003-11-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-find-decl-spots): Fixed bug in backing up to the
	start of the literal.  Fixed bug with the point on the wrong side
	of the search limit that could happen when the start position is
	inside a literal.

	* cc-engine.el (c-parse-state, c-invalidate-state-cache): Modified
	the use of `c-state-cache-end' so that it's kept a little bit back
	to increase the hit rate.

	(c-parse-state): Changed the macro handling and fixed some
	glitches.  Macro context is checked more often than necessary now,
	but otoh less garbage conses are generated.

	* cc-engine.el (c-parse-state, c-invalidate-state-cache): Cache
	the last position where `c-state-cache' applies.  This can speed
	up refontification quite a bit in blocks where there are many
	non-brace parens before the point.

	(c-state-cache-end): New variable for this.

	(c-guess-basic-syntax, c-debug-parse-state): Adapted for the new
	cache variable.

2003-11-06  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-find-decl-spots): Take more care to get close
	initial continue positions when the start position is inside a
	literal or macro.  Do not call the callback for spots before the
	start position (which can happen e.g. for `c-decl-end' spots
	inside comments).  Optimize better in special cases when the
	region is a single line inside a literal or macro (typically when
	the current line is refontified).

2003-11-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-re-search-forward): Fix bug where the
	match data could get clobbered if NOT-INSIDE-TOKEN is used.

2003-11-02  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Simplified calls to
	`c-add-stmt-syntax' - there's no need to explicitly whack off
	entries from the paren state.

	* cc-engine.el (c-add-stmt-syntax): Narrowed down the special case
	for "else if" clauses.

2003-11-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block, c-add-stmt-syntax): Use
	`c-recognize-paren-inexpr-blocks'.

	* cc-langs.el (c-recognize-paren-inexpr-blocks): New language
	variable to recognize the gcc extension with statement blocks
	inside expressions.

	* cc-engine.el (c-add-stmt-syntax): Restructured to make it
	somewhat more comprehensible.  The argument AT-BLOCK-START is no
	longer used and hence removed.

	(c-guess-continued-construct, c-guess-basic-syntax): Updated calls
	to `c-add-stmt-syntax'.

	* cc-engine.el (c-beginning-of-statement-1): Don't allow parens in
	labels.

	(c-backward-to-decl-anchor): Use `c-beginning-of-statement-1'
	instead of duplicating parts of it.  This fixes bogus label
	recognition.

	* cc-engine.el (c-backward-to-decl-anchor): Use
	`c-beginning-of-statement-1' instead of duplicating parts of it.
	This fixes bogus label recognition.

	* cc-mode.texi: Extended the doc on c-label-minimum-indentation a
	little.

	* cc-align.el (c-gnu-impose-minimum): Reverted to the old method
	of checking the context in which to apply the minimum indentation,
	so that it isn't enforced in e.g.  namespace blocks.

	* cc-vars.el (c-inside-block-syms): New constant used by
	`c-gnu-impose-minimum'.  It's defined close to `c-offsets-alist'
	to somewhat reduce the risk of becoming stale.

	* cc-cmds.el, cc-engine.el (c-shift-line-indentation): Moved from
	cc-cmds to cc-engine to allow use from cc-align.

2003-10-29  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-inheritance-list): Cope with fully
	qualified identifiers containing "::".
q
2003-10-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-add-type, c-check-type, c-forward-name,
	c-forward-type): Improved storage of template types in
	`c-found-types' so that they can be recognized better.

	(c-syntactic-content): Added option to skip past nested parens.

	* cc-engine.el (c-forward-name): Set `c-last-identifier-range' all
	the time.  It's less work that way.  Handle that there might not
	be an identifier to store in `c-last-identifier-range'.

	(c-forward-type): Handle that `c-last-identifier-range' might be
	nil from `c-forward-name'.

	* cc-defs.el: (c-safe-scan-lists,
	c-(go-)?(up|down)-list-(forward|backward)): Added limit arguments.

	* cc-defs.el (c-save-buffer-state): Use `unwind-protect' to work
	even if the form fails.

	* cc-defs.el (c-make-keywords-re): Added kludge for bug in
	`regexp-opt' in Emacs 20 and XEmacs when strings contain newlines.

	* cc-engine.el (c-parse-state): Speedup when moving far down in a
	large file in one go.

	(c-get-fallback-start-pos): New helper function for
	`c-parse-state'.

2003-10-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-emacs-features): Use a space in front of the name
	of the temporary buffer.  That also avoids dumping problems in
	XEmacs due to undo info being left around after the buffer is
	killed.

	* cc-mode.texi: Document c-lineup-assignments and c-lineup-math.

	* cc-align.el (c-lineup-assignments): New lineup function which is
	like `c-lineup-math' but returns nil instead of `c-basic-offset'
	when it doesn't match.

	(c-lineup-math): Changed to use `c-lineup-assignments'.

2003-10-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Fix some bugs in subfunctions of
	c-beginning-of-statement.  New subfunctions
	c-in-comment-line-prefix-p, c-narrow-to-comment-innards.

2003-10-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el: Use `c-simple-ws' instead of hardcoded
	char classes whereever possible.  Changed a couple of places to
	use skip by syntax instead of skip by char class.

	* cc-langs.el (c-unterminated-block-comment-regexp): Fixed a bug
	in the regexp that caused extreme backtracking.

2003-10-13  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-in-knr-argdecl): Look closer at the function
	arglist to see if it's a K&R style declaration.

	(c-guess-basic-syntax): CASE 5B.2: Check with `c-in-knr-argdecl'
	before returning knr-argdecl-intro.

2003-10-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-block-comment-starter, c-block-comment-ender):
	New language constants to specify in a single place how block
	comments look.

	(c-comment-start-regexp, c-block-comment-start-regexp,
	comment-start, comment-end, comment-start-skip,
	c-syntactic-ws-start, c-syntactic-ws-end, c-nonwhite-syntactic-ws,
	c-syntactic-ws, c-nonempty-syntactic-ws,
	c-single-line-syntactic-ws, c-syntactic-eol): Now built from
	`c-line-comment-starter', `c-block-comment-starter' and
	`c-block-comment-ender'.

	(c-block-comment-regexp, c-unterminated-block-comment-regexp): New
	language constants to break up things a bit.

	(c-simple-ws): New language constant for simple whitespace.

	* cc-defs.el (c-concat-separated): New convenience function.

	* cc-defs.el (c-make-keywords-re): Added kludge for bug in
	`regexp-opt' in Emacs 20 and XEmacs when strings contain newlines.
	Allow and ignore nil elements in the list.

2003-10-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Comment out a (n almost certainly superfluous)
	check, (eq here (point-max)) in c-beginning-of-statement.

2003-10-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Tidy up the comments in c-beginning-of-statement and
	subfunctions.

2003-10-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el: Replace calls to put-text-property to the more
	flexible c-put-char-property and c-clear-char-properties.  Add the
	author's email address.

2003-09-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el: New variable, c-block-comment-start-regexp.

2003-09-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: 1. Fix stupid error in previous commit.  2. Fix bug
	with M-e, when point is inside the closing "*/" of a block
	comment.

	* cc-cmds.el: Tidy c-beginning-of-sentence (and subfunctions) so
	that it works at BOB and EOB.

	* cc-cmds.el: Correct small inaccuracy in previous check-in.

	* cc-cmds.el, cc-vars.el: More updating of
	c-beginning-of-statement, including new variable
	c-block-comment-start-regexp.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state): Fixed bug that could cause errors
	when the state cache contains info on parts that have been
	narrowed out.

2003-09-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-vars.el (c-comment-prefix-regexp): Document
	that `c-setup-paragraph-variables' has to be used when this
	variable is changed; it doesn't work to reinitialize the mode
	since that typically clobbers the variable.

	* cc-styles.el (c-setup-paragraph-variables): Made it interactive.

2003-09-21  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-known-type-key): Optimize simple symbols from
	`*-font-lock-extra-types' so that there's no need to use
	`regexp-opt' on those lists.

	* cc-fonts.el (c-font-lock-declarations): Fixed recognition of
	constructors and destructors for classes whose names are matched
	by `*-font-lock-extra-types'.

	* cc-langs.el (c-type-list-kwds): If "operator" is followed by an
	identifier in C++ then it's a type.

	* cc-langs.el (c-type-decl-suffix-key): Fix when
	`c-type-modifier-kwds' is empty.

2003-09-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-invalid-string): Fix when there are
	several strings on the same line.

	* cc-engine.el (c-literal-limits): Removed the compatibility
	function for older emacsen.  `c-literal-limits-fast' has now taken
	the place of this function.

	* cc-vars.el (c-emacs-features): Removed compatibility with older
	emacsen: We now require 'pps-extended-state.

2003-09-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-invalid-string): Fixed eob problem that
	primarily affected XEmacs.  Don't use faces to find unterminated
	strings since Emacs and XEmacs fontify strings differently - this
	function should now work better in XEmacs.

2003-09-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: New function c-beginning-of-sentence, which obviates
	the need to hack sentence-end.  This now handles escaped newlines
	in strings correctly.  Correct minor bugs in c-move-over-sentence
	and in c-beginning-of-statement.

2003-09-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-statement (and subfunctions)): Adapt
	c-\(back\|forward\)-over-illiterals such that movement over macros
	and code are rigorously separated from eachother.  Correct a few
	incidental bugs.

2003-09-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fixed a bug in the
	`expand-abbrev' workaround which caused braces to disbehave inside
	macros.

	* cc-engine.el (c-forward-keyword-clause): Fixed error handling.
	This bug could cause interactive font locking to bail out.

2003-08-31  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-just-after-func-arglist-p): Handle paren-style
	types in Pike.  Also fixed some cases of insufficient handling of
	unbalanced parens.

2003-08-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Restructure c-beginning-of-statement: Improve its
	doc-string.  Improve the handling of certain specific cases.

2003-08-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Work around for a misfeature in
	`expand-abbrev' which caused electric keywords like "else" to
	disappear if an open brace was typed directly afterwards.

2003-08-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el (c-guess-basic-syntax):
	Changed the way class-level labels are recognized; they can now
	contain essentially any symbols.

	(c-opt-extra-label-key): New language variable to cope with the
	special protection label syntax in Objective-C.

	(c-opt-access-key): Removed; this is now handled better by
	`c-nonlabel-token-key' and `c-opt-extra-label-key'.

	(c-complex-decl-matchers): Update to handle that
	`c-opt-access-key' no longer exists.

	* cc-engine.el (c-guess-basic-syntax): Make use of the improved
	label recognition in `c-beginning-of-statement-1'.

	* cc-engine.el (c-beginning-of-member-init-list): Recognize
	bitfields better.

	* cc-engine.el (c-beginning-of-inheritance-list): Removed some
	cruft and fixed a bug that could cause it to go to a position
	further down.

	* cc-langs.el, cc-engine.el (c-beginning-of-statement-1): Improved
	detection of labels in declaration contexts.

	(c-beginning-of-decl-1): Use it.

	(c-nonlabel-token-key): New language constant and variable needed
	by `c-beginning-of-statement-1'.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug that manifested
	itself due to the correction in `c-forward-sexp'.

	* cc-defs.el (c-forward-sexp, c-backward-sexp): Made these behave
	as documented when used at the buffer limits.

	* cc-mode.el, cc-engine.el, cc-langs.el (c-type-decl-end-used):
	Made this a language variable.

	* cc-mode.el (c-after-change): Widen the buffer to work correctly
	when `combine-after-change-calls' is used together with temporary
	narrowings.

2003-08-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Report labels
	correctly when the start point is immediately after the colon.

2003-08-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-extra-types-widget): The doc string is mandatory
	in `define-widget'.

	* cc-align.el, cc-langs.el (c-lineup-math): Don't align the
	operators "!=", "<=" and ">=" as assignment operators.

	(c-assignment-operators): New language constant that only contains
	the assignment operators.

	(c-assignment-op-regexp): New language variable used by
	`c-lineup-math'.

2003-08-21  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-parse-sexp-lookup-properties): Removed since it
	isn't used anymore.

	* cc-cmds.el (c-electric-lt-gt): Detect and mark angle bracket
	arglists such as template parens in C++.

	* cc-engine.el (c-syntactic-skip-backward): Fixed a bug in the
	last check-in.  Some optimization.

	* cc-engine.el (c-syntactic-skip-backward): Fixed bug where it
	could stop at the same level in a preceding sexp when PAREN-LEVEL
	is set.

	* cc-mode.el (c-basic-common-init): Turn on syntax-table text
	property lookup only when it's needed.

	* cc-langs.el, cc-engine.el, cc-fonts.el, cc-mode.el: Changed the
	policy for paren marked angle brackets to be more persistent; once
	marked they remain marked even when they're found to be unbalanced
	in the searched region.  This should keep the paren syntax around
	even when individual lines are refontified in multiline template
	arglists.

	(c-parse-and-markup-<>-arglists): New dynamically bound variable
	to control markup so that incorrect angle bracket arglists aren't
	marked in contexts where the correct value for
	`c-disallow-comma-in-<>-arglists' isn't known.

	(c-forward-<>-arglist, c-forward-<>-arglist-recur): The reparse
	argument has become `c-parse-and-markup-<>-arglists'.

	(c-remove-<>-arglist-properties): Removed - no longer used.

	(c-after-change-check-<>-operators): New function used on
	`after-change-functions' to avoid that "<" and ">" characters that
	are part of longer operators have paren syntax.

	(c-<>-multichar-token-regexp): New language variable used by
	`c-after-change-check-<>-operators'.

	(c-after-change): Call `c-after-change-check-<>-operators'.

	(c-font-lock-<>-arglists): Use the context properties set by
	`c-font-lock-declarations' to set
	`c-disallow-comma-in-<>-arglists' correctly to avoid doing invalid
	markup.

	(c-font-lock-declarations): Removed code that undoes the invalid
	markup done by `c-font-lock-<>-arglists'.

	(c-complex-decl-matchers): `c-font-lock-<>-arglists' now runs
	after `c-font-lock-declarations'.

2003-08-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-skip-backward): Added paren-level
	feature.

	(c-guess-basic-syntax): Improved the anchor position for
	`template-args-cont' in nested template arglists.  There's still
	much to be desired in this area, though.

2003-08-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-just-after-func-arglist-p): Safeguard against
	unbalanced sexps.

2003-08-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-init-language-vars-for): Add argument MODE.
	Renamed from c-init-c-language-vars'.
	(c-initialize-cc-mode): Change accordingly.
	(c-common-init): Ditto.
	(c-mode): Ditto.
	(c++-mode): Use function.
	(objc-mode): Ditto.
	(java-mode): Ditto.
	(idl-mode): Ditto.
	(pike-mode): Ditto.
	(awk-mode): Ditto.

2003-08-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-end-of-current-token): Return whether or not the
	point moved.

	(c-search-decl-header-end): Don't trip up on operator identifiers
	in C++ and operators like == in all languages.

	* cc-engine.el (c-backward-to-decl-anchor): Detect leading labels
	correctly.

2003-07-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el, cc-langs.el, cc-mode.texi, cc-vars.el:
	Make the "Text Filling and Line Breaking" commands work for AWK
	buffers.

2003-07-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Some updates due to the dropping of the support
	for older emacsen.

	* cc-defs.el, cc-engine.el (c-mode-is-new-awk-p): Removed;
	(c-major-mode-is 'awk-mode) can be used instead now.

	* cc-mode.el: Always set up AWK mode since emacsen where it
	doesn't work no longer are supported.

	* cc-mode.el, cc-styles.el, cc-vars.el, cc-defs.el, cc-engine.el,
	cc-fonts.el, cc-langs.el, cc-cmds.el: CC Mode now requires support
	for the syntax-table' text property, which rules out Emacs 19 and
	XEmacs < 21.4.  Removed various compatibility cruft associated
	with those versions.

	* cc-defs.el, cc-fix.el: CC Mode now requires support for the
	`syntax-table' text property, which rules out Emacs 19 and XEmacs
	< 21.4.  Removed various compatibility cruft associated with those
	versions.

	* cc-vars.el (c-emacs-features): CC Mode now requires support for
	the `syntax-table' text property.

2003-07-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-nonbreakable-space-face): Remove the variable and
	use an extra quoted face name instead.  All the emacsen flavors
	handle that correctly.

	* cc-defs.el (c-langelem-sym, c-langelem-pos, c-langelem-2nd-pos):
	Added accessor functions for syntactic elements.

2003-07-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-literal-faces): Declare as a variable since it
	might be modified.

	* cc-langs.el: (c++-make-template-syntax-table,
	c-syntactic-ws-start, c-syntactic-ws-end): Gave more consistent
	names to these language constants.

2003-07-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Do not do hidden buffer
	changes; there's third party code that calls this function
	directly.

2003-07-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (javadoc-font-lock-keywords,
	autodoc-font-lock-keywords): Don't byte compile on font lock
	initialization when running from byte compiled files.

2003-07-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: Fix AWK mode indentation when previous statement
	ends with auto-increment "++".

2003-07-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-styles.el (c-style-alist, c-lang-variable-inits,
	c-lang-variable-inits-tail): The values of these are changed, so
	declare them as variables and not constants.

2003-07-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-styles.el (c-style-alist, c-lang-variable-inits,
	c-lang-variable-inits-tail): The values of these are changed, so
	declare them as variables and not constants.

	* cc-mode.el: Fixed some autoload problems: Try to ensure that the
	entry for ".c" extension comes before the one for ".C" on
	`auto-mode-alist', to behave better on case insensitive OS:es.
	Fixed incorrect entries that were added to
	`interpreter-mode-alist'.  Moved the autoload directives for AWK
	to the top level since they aren't recognized anywhere else.  Do
	not use the new AWK mode doc in the autoload form for the old AWK
	mode.

2003-07-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-complex-decl-prepare,
	c-font-lock-declarators, c-font-lock-declarations,
	c-complex-decl-matchers, c-basic-matchers-after): Use a text
	property to mark the items in in declarator lists to handle
	refontification inside multiline declarations better.

2003-07-02  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Recognize a construct
	like "a * b = c;" as a declaration.

	* cc-menus.el (cc-imenu-init): Do not set
	`imenu-create-index-function' if the second argument is left out.
	This bug broke the imenu support in C, C++ and Java modes.

2003-06-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release 5.30.

	* cc-engine.el, cc-align.el (c-add-stmt-syntax, c-lineup-arglist,
	c-lineup-arglist-close-under-paren): Fixes to cope with special
	brace lists in Pike.

2003-06-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: awk-mode: Call c-awk-after-change to ensure
	syntax-table props at loading.

	* cc-fonts.el: Put (cc-require-when-compile 'cc-awk) to eliminate
	compile-time errors.

2003-06-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el, cc-engine.el: Added code to analyze AWK top-level
	forms properly (c-guess-basic-syntax CASE 5P),
	c-awk-backward-syntactic-ws.

2003-06-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fix.el: cc-mode-19.el has been renamed to cc-fix.el since it
	now contains compatibility stuff for later versions than (X)Emacs
	19.

2003-06-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-paren-nontype-kwds): New language constant.

	(c-other-decl-kwds, c-postfix-decl-spec-kwds): Added compiler
	specific declspec keywords: __attribute__ for gcc and __declspec
	for msvc.

	* cc-fonts.el (c-font-lock-declarations, c-complex-decl-matchers):
	Support specifiers in a couple more contexts to cope with msvc
	'__declspec'.

	* cc-engine.el (c-forward-keyword-clause): Support
	`c-paren-nontype-kwds'.

2003-06-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-primary-expr-regexp): Don't match a bare period
	as a float.

2003-06-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-bytecomp.el (cc-bytecomp-setup-environment): Do not cover
	functions that have been bound.

	(cc-external-require): New macro to use for requiring external
	packages, to handle the environment correctly.

	* cc-defs.el, cc-fix.el, cc-fonts.el, cc-mode.el: Replaced
	external require's with `cc-external-require'.

2003-06-15  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-member-init-list,
	c-guess-basic-syntax): Fixes in handling of bitfields.

2003-06-13  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (comment-end): Put a space in front of the comment
	ender in C, as it was before the move from cc-mode.el.

2003-06-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el: Do not load cc-awk.elc or awk-font-lock-keywords
	unless there is an AWK Mode buffer.

2003-06-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el: New file that implements AWK support, superseding the
	old separate derived mode in awk-mode.el.

	* cc-vars.el, cc-mode-19.el, cc-langs.el, cc-mode.el, cc-defs.el,
	cc-engine.el, cc-fonts.el: Changes for the new AWK support.

2003-06-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el (c-decl-block-key,
	c-search-uplist-for-classkey): Check that the modifier is followed
	by "{" in Pike before considering it to start a class-like block.

2003-05-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-initialize-cc-mode): Added some compatibility to
	make this function behave somewhat more as documented for derived
	modes.  It's still not enough to make the old AWK mode behave
	reasonably, but it's been like this a long time now so fixing it
	more might cause trouble elsewhere. :P

2003-05-29  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-remove-font-lock-face): New macro to remove a
	font lock face properly (especially in XEmacs).

	* cc-bytecomp.el (cc-bytecomp-obsolete-fun): Added the same kludge
	as in `cc-bytecomp-obsolete-var' to avoid a confused compiler
	warning.

	* cc-engine.el (c-forward-type): Fixed a bug in the handling of
	concatenated types when the component types are known.

	* cc-fonts.el (c-constant-face-name): Added face name variable to
	avoid the use of `font-lock-constant-face' for constants in
	emacsen that doesn't have it.

2003-05-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el, cc-vars.el, cc-cmds.el: Fixes for the syntactic
	symbols for module and composition blocks.

2003-05-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-basic-common-init): Use
	`open-paren-in-column-0-is-defun-start' if it exists and works.

	* cc-vars.el (c-emacs-features): Added `col-0-paren' to detect
	when `open-paren-in-column-0-is-defun-start' exists and actually
	works.

2003-05-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-argcont, c-lineup-gcc-asm-reg): Don't
	quote nil in docstrings.

2003-04-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el, cc-langs.el (c-primitive-type-kwds,
	c-font-lock-extra-types): "complex" and "imaginary" aren't
	keywords in C99, only macros that expand to the keywords
	"_Complex" and "_Imaginary", so make the former a bit less
	hardcoded by putting it on `c-font-lock-extra-types' instead.
	There are also "bool" and "_Bool" that work the same way.

	(c-constant-kwds): "false" and "true" are standard constant macros
	in C99.

2003-04-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-menus.el, cc-langs.el, cc-engine.el, cc-fonts.el, cc-cmds.el:
	Fixed various regexps to use POSIX char classes when that is
	supported.

	* cc-defs.el (c-alpha, c-alnum, c-digit, c-upper, c-lower): New
	constants to make it easier to create regexps that use POSIX char
	classes in emacsen that support them.

2003-04-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-emacs-features): Detect in the regexp engine
	understands POSIX char classes.

2003-04-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-after-change): Added kludge for bug where this
	function sometimes gets positions outside the buffer range.

2003-03-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-member-init-list): Better handling
	of paretheses in unexpected places.

	* cc-engine.el (c-forward-<>-arglist-recur): Fixed a regexp match
	order problem that could cause empty template args on the form
	"<>" to be missed.

2003-03-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state): Added kludge to avoid an infinite
	loop when Emacs' open-paren-in-column-zero rule kicks in and
	causes the sexp functions to misbehave.

2003-03-06  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-member-init-list): Fixed bug when
	C++-like code is encountered in non-C++ mode.

2003-03-02  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-make-keywords-re): Added option to specify the
	language to look up `c-nonsymbol-key' in.

2003-02-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el (c-auto-newline-analysis): New
	dynamically bound variable to turn off the
	topmost-intro-cont/statement-cont kludge for brace lists during
	the analysis for the auto newline feature.  This fixes some cases
	where the setting for `brace-list-open' on
	`c-hanging-braces-alist' didn't have any effect.

2003-02-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-literal-start-regexp): Yet another language
	variable.

	* cc-fonts.el (c-font-lock-doc-comments,
	c-find-invalid-doc-markup, javadoc-font-lock-keywords): Fixed
	fontification of the markup in Javadoc comments.

        * cc-engine.el: Fixes in face handling to cope with doc comments.

	(c-find-decl-spots): More failsafe skipping of comments and
	strings that only have been partially fontified.

	* cc-defs.el (c-got-face-at): New subst to test faces at positions
	easier.

	* cc-defs.el (c-safe-scan-lists): New wrapper macro to avoid the
	warnings with too many args to `scan-lists' in Emacs.

2003-02-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-skip-backward): New function to make
	syntactic searches in the backward direction easier.

	(c-beginning-of-statement-1): Optimized skipping over large paren
	sexps somewhat.

	(c-safe-position): Removed the odd macro handling which was
	centered around the point instead of the passed position.

2003-02-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-in-knr-argdecl): Do not trip up on
	initialization expressions.

	* cc-align.el (c-lineup-arglist, c-lineup-close-paren,
	c-lineup-arglist-close-under-paren): Tuned the "macro block"
	heuristics to work better in nested arglist situations.

2003-02-10  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-set-offset): Don't find a default syntactic
	element through syntactic analysis if called outside a CC Mode
	buffer.

2003-02-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-basic-common-init): Install `c-fill-paragraph' on
	`fill-paragraph-function'.  Although it's not the normal way to
	call it in a CC Mode buffer it makes a direct call to
	`fill-paragraph' work better.

2003-01-28  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el, cc-mode.el (c-require-final-newline): Made this
	variable an alist to specify a value for each language.  The
	default value causes `require-final-newline' to be set to t only
	in languages where the standard requires a final newline.

2003-01-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-vars.el (c-require-final-newline): Added a
	variable to make the initialization of `require-final-newline'
	more configurable.

	* cc-vars.el (c-mode-common-hook): Do not change the format string
	to "CC Mode Common Hook" since that causes confusion (although it
	is a more accurate name).

2003-01-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (javadoc-font-lock-keywords,
	autodoc-font-lock-keywords): Support for Javadoc and Pike Autodoc
	doc comments.

	* cc-vars.el (c-doc-comment-style): New variable to control the
	fontification of documentation comments on top of the normal mode
	font lock.

2003-01-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-fonts.el (c-primary-expr-regexp,
	c-font-lock-declarations): Avoid false recognition of parens as
	casts when they are followed by an operator that is both prefix
	and infix.

2003-01-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-guess-fill-prefix): Tuned the heuristics of when
	to use `c-block-comment-prefix' for an unclosed block comment.

2002-12-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el (c-nonsymbol-sexp-kwds,
	c-forward-keyword-clause): Handle keywords like "extern" that can
	be followed by e.g. a string literal.

	* cc-defs.el (c-make-keywords-re): Make a regexp correctly with
	one submatch when adorn is set and the list is empty.

2002-12-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Fixed a search that
	could go far past the relevant region and cause slowness.  Do not
	limit the declaration detection to the fontified region since that
	can cause misfontification in multiline declarations.

	* cc-engine.el (c-find-decl-spots): Added limit argument to handle
	declarations spanning the fontification limit better.

2002-12-10  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-in-literal, c-literal-limits,
	c-literal-limits-fast, c-beginning-of-inheritance-list): Use the
	paren cache instead of the impaired ad hoc in
	`beginning-of-defun', so that these functions doesn't trip up on
	"{" in the first column inside strings or comments.

2002-12-06  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-hanging-braces-alist): Added `statement-cont' and
	made it auto newline free by default.

	* cc-cmds.el (c-electric-brace): Added `statement-cont' to the
	list of syntactic symbols to consider for auto newlines since it
	can be used for in-statement brace lists.

	* cc-vars.el (c-emacs-features): There's no need to have this
	constant autoloaded.

2002-12-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Use
	`c-recognize-typeless-decls' to avoid fontifying some macro
	constructs as declarations in languages where a preceding type is
	mandatory.

        * cc-langs.el (c-recognize-typeless-decls): New language variable.

2002-11-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-close-paren): Use `c-syntactic-eol' when
	checking if the open paren ends its line.

	* cc-langs.el (c-syntactic-eol): Handle a line continuation
	backslash.

2002-11-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-snug-do-while): Compatibility fix for changed
	structure in `c-syntactic-context'.

2002-11-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state): Filter angle bracket arglist
	parens in a better way than disabling the syntax table properties
	completely.

	* cc-fonts.el (c-cpp-matchers): Handle line continuations in cpp
	expressions. Do not fontify symbols after #ifdef etc as variables
	since that isn't consistent with how the face is used elsewhere
	(i.e. only for the definition of the symbol).

2002-11-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added autoload directives for the interface
	functions in cc-langs.

2002-11-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Added a property to
	handle refontication in multiline declaration arglists better.

	(c-font-lock-<>-arglists): Fix to handle recursive template
	arglists better.  (As a side effect this will make fontification
	work better in older emacsen too.)

	* cc-engine.el (c-forward-<>-arglist,
	c-remove-<>-arglist-properties): Use a common text property
	`c-type' for all sorts of CC Mode char classification, to avoid
	cases when then same char is given conflicting types.

	(c-forward-<>-arglist): New reparse argument to control that
	aspect explicitly.

	(c-forward-name, c-forward-type): Changes in the handling of
	recursive template arglists.  Fixes to cope with the new 'known
	type classification.

2002-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-basic-common-init): Added the new char property
	`c-type' to `text-property-default-nonsticky'.

	* cc-defs.el (c-put-char-property, c-get-char-property,
	c-clear-char-property, c-clear-char-properties): Generalized
	`c-put-char-syntax' and `c-get-char-syntax' to handle any
	property.

	* cc-bytecomp.el (cc-bytecomp-defun): Fixed bug that caused
	existing function definitions to be overridden by phonies when the
	bytecomp environment is restored.

2002-11-15  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Masking is necessary in normal
	code too to avoid getting a fill prefix from a nearby comment.
	Changed the name from `c-mask-comment' to a more accurate one.

	* cc-defs.el, cc-mode.el: Changed the auto-load-alist strategy to
	not add entries on package load, to be defensive in the case that
	autoloads are updated in older emacsen.  The bug that would occur
	in that case would probably be rather nasty for the average user.

2002-11-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Fine tuning of the
	decision tree that tells declarations from expressions to produce
	better results in some ambiguous cases.

	* cc-fonts.el (c-font-lock-syntactic-face-function): Removed since
	it doesn't give the control we want.

	(c-font-lock-invalid-string): Replacement for
	`c-font-lock-syntactic-face-function' that puts the error face on
	the string opener only, to avoid the annoying excessive use of the
	error face while a string literal is being written.

        (c-basic-matchers-before): Use `c-font-lock-invalid-string'.

	* cc-engine.el (c-string-syntax, c-string-limit-regexp): Added
	constants to use when handling string limits, since not all old
	emacsen react well to the "|" syntax class.

	(c-literal-limits, c-literal-limits-fast, c-literal-type): Use
	`c-string-syntax' and `c-string-limit-regexp'.  Replaced some
	hardcoded comment start regexps with `c-comment-start-regexp'.

2002-11-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added an association for pike-mode on
	`intepreter-mode-alist'.

2002-11-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Add the `auto-mode-alist' entries to the end instead
	of the start of the list, to avoid overriding user additions that
	are made before this file is loaded when the entries don't
	correspond to any already on `auto-mode-alist'.

	This is done through the third append argument to
	`auto-mode-alist'.  That doesn't exist in older (X)Emacsen, so the
	function is adviced in cc-defs.  However, that advice doesn't help
	if the autoloads are updated in an old (X)Emacs with this version
	of CC Mode, but I believe it's unlikely that anyone does that when
	CC Mode isn't distributed with with it.

	* cc-defs.el (add-to-list): Added advice to get the optional third
	append argument in older (X)Emacsen.

	* cc-langs.el (c-keywords-obarray): Kludge for strange bug in
	Emacs that gives so odd errors that I frankly don't even muster to
	begin trying to narrow it down.  If someone is so inclined,
	restore the commented code, byte compile, and try to open a C++
	file or something in font lock mode.

2002-11-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el: Updated the IDL support from the specs.  This also
	adds the keywords for the variants PSDL and CIDL.  (This is mostly
	done from reading the grammars only; very lightly tested.)

        * cc-langs.el (c-type-list-kwds): Added "new" in Java.

	* cc-fonts.el: Made sure that `parse-sexp-lookup-properties' is
	properly insulated from clobbering by the font-lock package at all
	relevant entry points.

2002-11-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-opt-after-id-concat-key): New language constant
	to make the recognition of identifier qualifiers more flexible.
	Recognize the identifier before ".*" as a qualifier in Java.

	(c-identifier-key): Recognize "::*" inside identifiers in C++.
	Recognize identifiers ending with ".*" in Java for the sake of
	import directives.

	(c-type-list-kwds, c-ref-list-kwds): Recognize "import" and
	"package" declarations in Java.

	* cc-vars.el (c-doc-face, c-doc-marker-face, c-doc-markup-face):
	Removed since they aren't used (and probably won't be).

	* cc-langs.el (c-ref-list-kwds): New language constant to specify
	keywords followed by references.

	(c-last-identifier-range): New variable to avoid going back to
	search for the identifier to font lock after a call to
	`c-forward-name'.

	(c-type-prefix-kwds, c-type-list-kwds): Fixed classification of
	"@interface" etc in Objective-C.

	* cc-engine.el (c-forward-keyword-clause): Fixed handling of
	keyword prefixes in `c-type-list-kwds' and
	`c-colon-type-list-kwds' clauses.

	(c-keyword-sym, c-keyword-member): New functions to lookup and
	categorize keywords.

	(c-forward-keyword-clause): New function to move over a keyword
	and its associated clause according to `c-<>-arglist-kwds' etc.

	* cc-langs.el (c-typeless-decl-kwds, c-type-list-kwds,
	c-colon-type-list-kwds, c-colon-type-list-re, c-paren-type-kwds):
	New language constants and variables to generalize the recognition
	of various language constructs.

	(c-keywords): Did away with the list of `*-kwds' constants.  It's
	now built through macro expansion.

	(c-keywords-obarray): New language variable which contains each
	keyword as a symbol, to make fast reverse lookup of keywords to
	the `*-kwds' lists they come from.

2002-10-31  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-lang-defconst-eval-immediately): Added macro to be
	able to do direct evaluation in `c-lang-defconst' forms.

	* cc-engine.el (c-syntactic-re-search-forward): Fixed a bug which
	could cause the point to end up outside the containing sexp if
	PAREN-LEVEL was used.

	* cc-engine.el, cc-fonts.el, cc-langs.el: Generalized the C++
	template arglist support to handle angle bracket arglists in any
	language.

	(c-recognize-<>-arglists, c-<>-arglist-kwds,
	c-opt-<>-arglist-start): New language variables to control angle
	bracket arglists.

	(c-opt-type-suffix-key): Use `c-recognize-<>-arglists' in
	Objective-C instead of matching a protocol reference list as a
	type suffix.

2002-10-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-gnu-impose-minimum): Fixed a missing
	`save-excursion' that caused the point to jump around.

2002-10-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

        * cc-mode.el, cc-menus.el (objc-mode, cc-imenu-init): Fixed
	initialization bug that has made the Objective-C support
	inoperational since 5.26.

	(cc-imenu-objc-generic-expression): Updated submatch indices due
	to changes in `cc-imenu-c++-generic-expression'.

	(cc-imenu-objc-function): Don't add an empty "C" menu since imenu
	doesn't like that.

2002-10-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-arglist,
	c-lineup-arglist-close-under-paren, c-lineup-close-paren): Added
	DWIM to the functions that line up at or after the arglist open
	paren to avoid that if there are brace blocks inside, e.g. when a
	macro contains a code block.

2002-10-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (objc-font-lock-extra-types): Changed default to
	treat identifiers starting with capital letters as types,
	according to Objective-C naming conventions.  The types previously
	on the list is part of the language and therefore on
	`c-primitive-type-kwds' instead.

	* cc-fonts.el: Fixed font locking in Objective-C.  Be more careful
	about returning nil from functions used directly as font-lock
	matchers.

	* cc-mode.el (c-font-lock-init): Made the syntax table
	modification element of `font-lock-defaults' parameterized over
	the languages.

	* cc-langs.el: Updated the Objective-C constants according to the
	language spec.  The "@" chars that start directives are now
	considered part of the keywords to make things easier.

2002-10-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el:
	(c-(up|down)-list-(forward|backward)): Made the position optional
	and added docstrings.

	(c-go-(up|down)-list-(forward|backward)): Added variants of the
	above that move point and return successfulness instead.

2002-10-21  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-<>-arglists): New function to fontify
	all occurrences of template arglists in C++.

	* cc-engine.el (c-disallow-comma-in-<>-arglists): New variable to
	be able to avoid false recognition of template arglists in some
	cases.

2002-10-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el (c-decl-prefix-re,
	c-font-lock-declarations): Match template open brackets to get a
	declaration in the first template argument.

	(c-complex-decl-matchers): Fontify the second type in a "class X =
	Y" expression in C++.

2002-10-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-<>-arglist): Broke out the recursive
	part to a new function to improve efficiency when a nested
	template arglist search turns out to be futile.

2002-10-13  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-menus.el (cc-imenu-java-generic-expression): Improved to
	avoid false matches on e.g. "else if (foo)".

2002-10-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-token-2, c-backward-token-2): New
        functions that work like the -1 variants but that handles
        multicharacter operator tokens.

	* cc-engine.el (c-inside-bracelist-p, c-guess-basic-syntax): Did
	away with the hardcoded regexps to recognize "typedef" declaration
	prefixes, "extern" and "namespace" blocks, "enum"-style brace list
	declarations and Java-style array initializers with "new".

	* cc-langs.el (c-brace-list-decl-kwds, c-brace-list-key,
	c-inexpr-brace-list-kwds, c-opt-inexpr-brace-list-key): New
	language constants and variables to parameterize some more of the
	hardcoded regexps in cc-engine.

2002-10-10  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-cascaded-calls): Do not allow cascaded
	call lists containing both "->" and ".".

2002-10-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

        * cc-align.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fonts.el,
	cc-langs.el, cc-mode.el, cc-styles.el: New language variable
	system to make it easier to set up optimized language variables
	and to extend them in third party derived modes.  cc-langs is no
	longer required at runtime.

	* cc-mode.el (c-basic-common-init): No longer initializes the
	language variables.  It's necessary that the caller does that
	directly since the evaluated values for them now get compiled in
	directly.

	(c-font-lock-init, c-common-init): Separated the font-lock
	initialization from `c-common-init'.

	* cc-mode.el (c-define-abbrev-table): Do not override an existing
	abbrev table.

	(c-Java-defun-prompt-regexp): Moved here from cc-langs since
	cc-langs isn't always loaded at runtime.

	* cc-langs.el (c-make-init-lang-vars-fun, c-init-language-vars):
	Changed to allow language variable initialization from derived
	modes.

        (c-mode-menu): New language variable for the mode menu.

	(c-make-mode-syntax-table, c-mode-syntax-table,
	make-c++-template-syntax-table): New language variables for syntax
	tables.  The code that initializes them has been moved to cc-mode
	to make it possible to avoid loading cc-langs at runtime.

	* cc-engine.el, cc-langs.el (c-hungry-delete-key, c-auto-newline,
	c-auto-hungry-string): Moved these state variables from cc-langs
	to cc-engine to make it possible to avoid loading cc-langs at
	runtime.

	* cc-defs.el (c-lang-defconst, c-lang-const): Moved from cc-langs
	and rewritten to make the language constant system usable from
	derived modes.

	(c-add-language): New function intended for use from derived modes
	that add new C-like languages.

	* cc-defs.el, cc-vars.el (c-buffer-is-cc-mode): Moved from cc-vars
	to cc-defs to define it during compilation.

	* cc-bytecomp.el (cc-require-when-compile): New support macro for
	compile time `require's.

2002-10-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

        * cc-defs.el, cc-mode.el (c-version): Moved from cc-mode to
        cc-defs to make it accessible to the other components.

	* cc-engine.el (c-forward-token-1, c-backward-token-1):
	Compatibility fix for emacsen that doesn't understand generic
	string delimiters.

	* cc-vars.el (c-emacs-features): Added detection of generic string
	and comment delimiters.

	* cc-defs.el, cc-langs.el (c-make-keywords-re): Changed interface
	to make it more extensible.

	* cc-langs.el, cc-defs.el (c-regexp-opt, c-regexp-opt-depth,
	c-make-keywords-re): Moved from cc-langs to cc-defs since they are
	generally useful.

	* cc-bytecomp.el, cc-defs.el (cc-eval-when-compile): Moved from
	cc-bytecomp to cc-defs to allow use at runtime.

2002-10-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-bytecomp.el (cc-eval-when-compile): Workaround for a bug with
	nested `eval-when-compile' in XEmacs 21.

2002-09-27  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added autoloaded forms to install the appropriate
	file suffixes on `auto-mode-alist'.  Necessary in XEmacs 21.5, and
	it can be useful elsewhere too.

2002-09-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-cascaded-calls): Handle "." too, for use
	in Java.

	* cc-engine.el (c-forward-sws, c-backward-sws): Do not handle cpp
	directives in languages that doesn't have any.

2002-09-22  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-operators): Added a high level description of all
	operators, along with their precedence and associativity.

	* cc-align.el (c-lineup-multi-inher): Fixed bug where the position
	of the point and not the beginning of the line was used to
	calculate the indentation.

2002-09-18  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el (c-backward-single-comment,
	c-backward-comments): Added kludge for the bug in
	`forward-comment' in most (X)Emacs versions where it moves back
	over the "*/" of a block comment if there's no matching "/*".
	This has become more important now since it can cause incorrect
	caching by `c-backward-sws'.

2002-09-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-hungry-backspace, c-hungry-delete-forward): New
	functions to do hungry deletion regardless of hungry-delete mode.
	Contributed by Kevin Ryde.

	* cc-engine.el (c-forward-sws, c-backward-sws,
	c-invalidate-sws-region): Use text properties to cache regions
	with complex syntactic whitespace.  This helps a lot in improving
	responsiveness when there are lots of comments and cpp directives
	before point.

2002-09-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-guess.el, cc-langs.el, cc-menus.el, cc-mode.el, cc-styles.el,
	cc-vars.el, cc-engine.el, cc-fonts.el, cc-cmds.el, cc-defs.el:
	Introduced a classification of functions into those that make
	"hidden buffer changes" and those who don't.  This is prompted by
	the increasing use of text properties for various things, to
	correctly cover the silly buffer modifications that is caused by
	text property changes.

	(c-save-buffer-state): New macro that's put around any code that
	can manipulate text properties.

2002-09-13  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-basic-common-init): Setup
	`text-property-default-nonsticky' to avoid messing with the
	rear-nonsticky property on each character in Emacs 21.

	* cc-defs.el (c-clear-char-syntax, c-put-char-syntax): Macros that
	sets and removes the syntax-table property on a single character
	and makes the property nonsticky in both directions in a suitable
	way for each (X)Emacs flavor.

	* cc-vars.el, cc-defs.el, cc-engine.el, cc-mode.el: Use
	`lookup-syntax-properties' in XEmacs to control whether the
	syntax-table property has any effect or not.

	(c-parse-sexp-lookup-properties): New macro that expands to either
	`parse-sexp-lookup-properties' or `lookup-syntax-properties'.

2002-09-12  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el, cc-fonts.el: Put the faces into the
	buffer in the same way as the font-lock package does.  This fixes
	a compatibility problem with XEmacs which sets an extra font-lock
	property.

	* cc-fonts.el (c-put-font-lock-face): A macro that finds out the
	right way to put font lock faces at compile time.  We're
	definitely not byte code portable between Emacs and XEmacs now.

	* cc-engine.el (c-forward-sws, c-backward-sws): Implemented a
	cache for the last large skipped over syntactic whitespace.  This
	also has most effect after many macros.

	* cc-engine.el, cc-defs.el (c-forward-syntactic-ws,
	c-backward-syntactic-ws): Utilize the limit better when one is
	passed.  These are now macros to avoid a little overhead when no
	limit is given.

	(c-forward-sws, c-backward-sws): New functions called by the
	macros above to do the unbounded search.

	* cc-fonts.el (c-font-lock-declarations): Implemented a cache for
	the first backward search for a preceding `c-decl-prefix-re'
	match.  This typically speeds up interactive refontification a lot
	on the top level of macro heavy header files.

2002-09-10  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-emacs-features): Added check for syntax text
	properties.

	* cc-mode.el (c-basic-common-init): Turn on
	`parse-sexp-lookup-properties' if it's supported.  Define the
	variable in any case since it's used at runtime to check on this.

        * cc-langs.el (c-identifier-key): Support C++ destructor names.

	(c-identifier-start, c-op-token-regexp, c-type-modifier-kwds,
	c-opt-type-modifier-key, c-opt-type-component-key,
	c-typedef-specifier-kwds, c-typedef-specifier-key,
	c-paren-stmt-kwds, c-paren-stmt-key, c-syntactic-ws-start): A
	bunch of new language constants and variables to support the
	improved handling of names and types.

	* cc-fonts.el (c-font-lock-declarators, c-font-lock-declarations):
	Handle C++ template declarations and template references.  Fontify
	complex types and names more accurately by delegating it to
	`c-forward-type' and `c-forward-name'.  Fontify the identifiers in
	typedef declarations as types.

	* cc-engine.el (c-forward-<>-arglist): New function to move
	forward over a C++ template arglist.  It also marks the '<' and
	'>' chars with paren syntax using the syntax-table property, to
	speed up later calls in emacsen that support syntax text
	properties (Emacs >= 20 and (undocumented) XEmacs 21).

	This also has the very interesting effect that if font locking is
	used with decoration level 3 or higher in these emacsen then
	template arglists will behave just like paren sexps with the
	various sexp movement commands.

	(c-forward-name): New function to move over a name.  Simple in
	most languages except C++ where a name can contain template
	arglists and therefore almost arbitrary expressions.

        (c-on-identifier): Fix for Pike operator identifiers.

	(c-simple-skip-symbol-backward, c-syntactic-content,
	c-remove-<>-paren-properties): New helper functions.

	* cc-defs.el: (c-clear-char-syntax, c-mark-paren-open,
	c-mark-paren-close): New support functions to handle syntactic
	properties on C++ template arglist brackets.

        (c-put-type-face, c-put-reference-face): Helpers to put faces on
	regions, since there are a bit of that inside `c-forward-name' etc
	in cc-engine.el.

	* cc-engine.el, cc-fonts.el, cc-langs.el: Fixed the names on a
	number of regexp language variables to conform to the nomenclature
	and shortened some names.

	* cc-align.el, cc-cmds.el, cc-fonts.el, cc-engine.el
	(c-syntactic-re-search-forward): Removed the COUNT argument since
	it's never used.  Added an argument to tell which subexpression
	whose end should be tested for syntactic relevance.  Using this
	also removes some optimizations, so that it's possible to use a
	look behind subexpression that matches the end of a literal or a
	close paren when PAREN-LEVEL is used.

	(c-guess-continued-construct): Don't match <<= or >>= for the
	stream-op syntactic element.

	* cc-defs.el (c-paren-re, c-identifier-re): Removed these helper
	macros since better and more correct tools are now available in
	cc-langs.el.

2002-09-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-string-cont): New lineup function to line
	up string literals that will be concatenated.

2002-09-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-populate-syntax-table): XEmacs classifies the
	hard space character as a symbol character but it's better to let
	it be in the punctuation class so that it's always highlighted
	with the inverted invalid face.  It can perhaps be argued that
	that character is allowed in identifiers in some languages
	(haven't checked), but using it would still be extremely
	confusing.

2002-09-04  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Fixed a case when a
	labeled substatement caused incorrect association of the following
	continuation clause.

	* cc-engine.el (c-syntactic-re-search-forward): Handle the case
	when the syntactic match position is in the middle of a comment
	starter.

	(c-guess-continued-construct): Analyze the "K&R region" of a
	function nested inside a function as func-decl-cont and not
	statement-cont.  New case E.  Also cleaned up case C (stream-op
	recognition) a bit.

	* cc-engine.el (c-parse-state, c-check-state-cache): Moved the
	check on `c-state-cache-start' from `c-check-state-cache' to
	`c-parse-state' so that the state cache isn't zapped if
	`c-check-state-cache' but not `c-parse-state' is called during a
	temporary narrowing.  This fixes a performance problem that could
	occur when `fill-paragraph' is used in font lock mode on a comment
	at the end of a large class or function.

        (c-state-cache-start): Fixed buffer localness.

2002-09-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el: Updates from the C99 standard (or actually from the
	latest web accessible draft of it).

2002-09-02  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el: Updated the keywords and operator tokens from the
	latest C++ and Java standards.  Some other multichar token
	corrections.

2002-09-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el, cc-vars.el (c-syntactic-context,
	c-syntactic-element): Do not bind any values to these variables
	globally since they should always be dynamically bound.  This
	makes it much easier to debug cases when they've gotten global
	values somehow.

2002-08-31  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-regexp-opt): Fix to work around the non-greedy
	behavior that the regexp engine sometimes exposes.  This bug only
	shows in (X)Emacs 19 where there's no regexp-opt package.

	* cc-engine.el (c-syntactic-re-search-forward): Added a feature to
	filter out matches in the middle of tokens.  Changed the comment
	to a docstring since I consider this function generally useful.

        * cc-defs.el (c-mode-symbol): Broke out a part of `c-mode-var'.

	* cc-align.el (c-lineup-cascaded-calls, c-lineup-gcc-asm-reg):
	Cope with that `c-most-enclosing-brace' might return nil.

2002-08-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-found-types, c-clear-found-types, c-add-type,
	c-check-type, c-add-complex-type, c-list-found-types,
	c-forward-type): Added a sort of symbol table for types: If a name
	is recognized as a type in a declaration it's added in an obarray
	to be able to recognize it in other ambiguous declarations.

	(c-remove-ws): New helper function to canonicalize fully qualified
	identifiers for `c-found-types'.

	* cc-defs.el (c-mode-var): New defsubst to access mode prefixed
	variables uniformly.

2002-08-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-arglist-close-under-paren): Work correctly
	with nested arglist-cont-nonempty symbols.

	(c-lineup-arglist-operators): New lineup function to line up infix
	operators under the open paren of the surrounding sexp.

2002-08-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-syntactic-ws): Fixed a bug that could
	cause an infinite loop if something that looks like a macro begins
	in the middle of a line.

	(c-parse-state): Fixed a bug that could cause `c-state-cache' to
	contain two conses in sequence when there's an unbalanced open
	paren in a macro.

2002-08-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-face-name-p): A defsubst to recognize the name of
	a face in a way that works also in XEmacs.

	* cc-engine.el (c-forward-type): New function to move past a type
	spec.

	* cc-engine.el (c-syntactic-re-search-forward): Fixed behavior
	when the limit is reached inside a comment, string, or a macro.

	* cc-align.el, cc-cmds.el, cc-engine.el (c-forward-single-comment,
	c-forward-comments, c-backward-single-comment,
	c-backward-comments): New replacements for `c-forward-comment'
	that wraps `forward-comment' more efficiently in each of the four
	different cases it's actually used.  These replacements also
	treats line continuations as whitespace.

	(c-forward-comment): Removed.  The four different cases above are
	basically different, so it's better to make them into separate
	functions than choose between them at runtime using the argument.

2002-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-gnu-impose-minimum): Fixed bug due to the new
	placement of cpp-macro and comment-intro in the syntactic context,
	as pointed out by Kevin Ryde.  Changed the method that decides
	whether point is inside a top-level construct to one that doesn't
	depend on the set of syntactic elements so much.

	* cc-defs.el (c-point): Use the functions
	`line-beginning-position' and `line-end-position' in emacsen that
        have them (currently Emacs 20 and later).

2002-07-27  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-comment): Fixed a bug that sometimes caused
	code after a closed block comment to be taken into account when
	the fill prefix is calculated.

2002-07-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-arglist, c-lineup-argcont, c-lineup-math,
	c-lineup-cascaded-calls, c-lineup-gcc-asm-reg): Fixes to cope
	correctly with nested arglists for the lineups that can be used
	with arglist-cont-nonempty.

2002-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-add-stmt-syntax, c-guess-basic-syntax): Changed
	the anchor position of arglist-cont-nonempty and arglist-close so
	that a relative indentation like + can be used with consistent
	results.  Prior to this, the indentation engine more or less
	assumed that arglist-cont-nonempty always used `c-lineup-arglist'.
	Those two syntax symbols also get the opening paren as an extra
	position, to make it possible for `c-lineup-arglist' to continue
	to do a proper job.

	* cc-engine.el (c-get-syntactic-indentation): A vector with an
	absolute indentation column now only overrides the indentation for
	surrounding structures, i.e. those whose syntactic elements are
	earlier in the `c-syntactic-context' list, but not nested ones.
	This so that e.g. `c-lineup-arglist' can reliably line up with the
	first argument but still allow relative indentation changes for
	nested things, e.g. the arglist-close of a nested argument list.
	This change means that the order in `c-syntactic-context' has
	become more essential.

	(c-guess-basic-syntax): Changes to make the nesting order of the
	returned syntax list correct.

	Compatibility note: This change means that `c-lineup-dont-change'
        now (again) isn't absolutely sure to keep the current indentation.
	However, I believe that most people use it for comments, macros
	and string literals, and since those are nested innermost it won't
	matter.

2002-06-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-defs.el, cc-engine.el, cc-vars.el
	(c-guess-basic-syntax, c-calc-offset, c-get-syntactic-indentation,
	c-syntactic-context): Extended the representation of the syntactic
	context: Previously it was a list containing cons cells of the
	found syntactic symbols and their relpos values.  Now each element
	is instead a list containing the syntactic symbol in the first
	element and the relpos (if any) in the second.  After that there
	might be more elements, depending on the syntactic symbol.  The
	line-up functions get these additional elements as extra
	arguments.

	This change is slightly incompatible.  Although the calling
	convention for line-up functions is strictly extended, the format
	of the `c-syntactic-context' variable has changed slightly.  It's
	believed that this incompatibility is minor, though; not a single
	line-up function distributed with CC Mode needed to be changed,
	for instance.

2002-06-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-set-style, c-set-style-1): Added another state
	for the `dont-override' flag where it only keeps globally set
	variables.

2002-06-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-postprocess-file-styles): Do nothing except in CC
	Mode modes.

2002-06-02  Martin Stjernholm  <bug-cc-mode@gnu.org>

        * cc-vars.el, cc-fonts.el, cc-langs.el, cc-mode.el: Added font
        lock support.

	* cc-engine.el (c-beginning-of-syntax): New function to be used
	for font-lock-beginning-of-syntax-function.  It uses the state
	cache to quickly find a good position.

	* cc-defs.el (c-major-mode-is): Allow a list of modes.  Made it a
	macro ensure that it's optimized to either eq or memq for constant
	arguments.

	* cc-mode.el (c-common-init): Did away with the hardcoded setting
	of `comment-column'; it's a user variable that we have no business
	meddling with.  Since the default value for it is 32 in all
	supported (X)Emacs versions, it's also safe from a compatibility
	perspective.

	* cc-mode.el (c-basic-common-init): New function that contains
	only the syntax and line breaking/filling initialization.  It's
        intended for use by other modes that embed CC Mode.

2002-05-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-add-stmt-syntax): Fixed some cases of wrong
	anchoring, e.g. for else-if compounds.

2002-05-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed anchor position for
	defun-open in K&R style functions.

        * cc-engine.el (c-in-knr-argdecl): Don't trip up on macros.

	(c-search-decl-header-end): Handle C++ template arguments more
	correctly.

	(c-beginning-of-decl-1): Fix when the declaration is first in a
	macro.

2002-04-30  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-decl-1): Better way to handle
	protection labels, one which doesn't get confused by inherit
	colons.

	(c-end-of-decl-1): Don't treat functions that have "class" or
	"struct" in the return type as classes or structs.

2002-04-27  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-make-keywords-re): Fixed the keyword adornment so
	that it works when a keyword ends with "_".

2002-04-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-comment): More fixes when used from
	`c-do-auto-fill' and point is at or near the limit of the comment.
	Fixed bug when the prefix from `c-guess-fill-prefix' is longer
	than the text on the first line of the comment when it's masked.

2002-04-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-comment): Fixed bug where point was moved to
	the following line when it was at the first line of a block
	comment where comment-start-skip matched to eol.

Mon Apr 22 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release 5.29 (Test version; this is not a real release.)

	* cc-engine.el: Incorporated change made in Emacs: Don't
	assume point-min == 1 when counting lines.

	* cc-mode.el: Incorporated changes made in Emacs:

	(c-define-abbrev-table): New function to pass the SYSTEM-FLAG
	to `define-abbrev' in a way that works in emacsen that doesn't
	support it.

	(c-mode-abbrev-table, c++-mode-abbrev-table,
	objc-mode-abbrev-table, java-mode-abbrev-table,
	pike-mode-abbrev-table): Mark all the predefined abbrevs as
	"system" abbrevs.

	(c-submit-bug-report): Make sure that the arguments to
	`insert' are strings.

Sun Apr 21 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-engine.el, cc-styles.el, cc-vars.el
	(c-guess-basic-syntax, c-lineup-topmost-intro-cont): Find
	correct anchor for statement-cont in top level constructs.
	Analyze variable initializations in top level constructs as
	topmost-intro-cont instead of statement-cont.  That is an
	incompatible change but it gives better consistency.  The new
	lineup function c-lineup-topmost-intro-cont' compensates for
	it and is now put on topmost-intro-cont by default.

	* cc-align.el, cc-engine.el, cc-langs.el (c-lineup-argcont):
	Lineup function contributed by Kevin Ryde.

	(c-in-gcc-asm-p): Function to recognize asm statements.
	Contributed by Kevin Ryde.

	(c-opt-asm-stmt-key): New language variable to recognize the
	beginning of asm statements.

Sat Apr 20 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Detect variable
	declarations after class and struct declarations correctly.
	Fixed limit error when finding the anchor for
	template-args-cont and topmost-intro-cont.

Fri Apr 05 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-defun, c-declaration-limits):
	Find the "line oriented" declaration start too, just like the
	"line oriented" end is found.

Thu Apr 04 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-offsets-alist): A more sane default for
	`inexpr-statement'.  This is not compatible, though.  I think
	the benefit of a good default style outweights that in this
	case.  Besides, `inexpr-statement' is not very common.

Mon Apr 01 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-delete-forward): Fixed silly bug that
	caused it to delete backwards in hungry delete mode.  (It's
	amazing that this bug hasn't been reported.)

	* cc-cmds.el (c-declaration-limits, c-mark-function):
	Extracted the code to get the declaration limits from
	`c-mark-function' to a new `c-declaration-limits'.

	(c-indent-defun): Use the same method to get the limits of the
	declaration or macro as `c-mark-function'.

	* cc-engine.el (c-beginning-of-decl-1): Handle brace list
	initializers correctly (but costly; it ought to be integrated
	into `c-beginning-of-statement-1').

Sun Mar 31 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el (c-beginning-of-defun,
	c-end-of-defun, c-mark-function): Rewritten to detect the
	declaration limits better.  Now handles K&R argdecls, class
	definitions followed by variables etc.

	(c-in-knr-argdecl): Broke out the K&R argdecl test in
	`c-beginning-of-decl-1' to this new function.

	(c-end-of-statement-1, c-end-of-decl-1): Replaced
	`c-end-of-statement-1' with `c-end-of-decl-1', which correctly
	handles declarations that continue after the block.

	* cc-engine.el (c-syntactic-re-search-forward): Added an
	option to restrict matching to the top level of the current
	paren sexp.

	* cc-langs.el (c-opt-block-decls-with-vars-key): New regexp to
	recognize declarations that continue after the block.

	(c-syntactic-eol): New regexp to match a "syntactic" eol.

Sat Mar 30 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed a bug that often
	caused the backward limit to be lost at the top level.  This
	improves performance a bit.

	* cc-engine.el (c-syntactic-re-search-forward): New function
	that works like `re-search-forward' but only returns matches
	in syntactically significant text.

	* cc-engine.el: Fixed a faster and more accurate way to
	recognize K&R argdecls.

	(c-beginning-of-decl-1): New function that put point at the
	beginning of the declaration.  It handles K&R argdecl blocks.

	(c-guess-basic-syntax): Replaced the `knr-argdecl' recognition
	code with one that doesn't depend on the current indentation.
	The anchor position for `knr-argdecl' has also changed, but in
	a way that is unlikely to cause compatibility problems.

Mon Mar 25 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el (c-forward-comment):
	`forward-comment' in XEmacs skips over line continuations in
	the backward direction.  Correct for that.  Also made this a
	defun since it has grown too large now to be a defsubst.

	* cc-langs.el: More convenient and decentralized setup of the
	language specific variables.  The regexp-opt mangling is also
	done at compile time now.

Tue Mar 19 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-line-or-region): Call `c-indent-line'
	directly instead of through `indent-according-to-mode' so that
	this function always indents syntactically.

	* cc-engine.el (c-guess-basic-syntax): Fixed a bug where a
	class beginning with a nested class could cause an infinite
	loop (the state outside the narrowed out class is never used
	now).

Sun Mar 17 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-cmds.el, cc-engine.el, cc-vars.el: Fixes so
	that the context sensitive analysis inside macros is
	restricted to the bodies of #define's; other things, like #if
	expressions, never have anything in common with their
	surroundings.  The old `cpp-macro-cont' syntax is now used in
	situations where the syntactic analysis isn't applicable, and
	a new syntactic element `cpp-define-intro' is used to add
	indentation in #define bodies.

	(c-lineup-cpp-define): New name for `c-lineup-macro-cont' to
	better reflect its use.

	* cc-engine.el (c-guess-basic-syntax): Ignore line
	continuation backslashes in the detection of
	`arglist-cont-nonempty'.

	* cc-align.el: Use the vector form in the return value in all
	cases where lineup functions return absolute columns.

Sat Mar 16 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-add-stmt-syntax, c-guess-basic-syntax):
	Anchor `brace-list-intro' and `brace-list-close' better for
	brace lists nested inside expressions.

	* cc-engine.el, cc-langs.el, cc-mode.el, cc-styles.el: Cleaned
	up the various language specific variables and their
	initialization.  The keyword regexps are now lists that are
	combined with regexp-opt.  Some variables have changed names
	to fit better with the naming convention.

	* cc-defs.el, cc-vars.el (c-buffer-is-cc-mode): The value is
	the mode symbol of the original CC Mode mode.

	(c-major-mode-is): Compare against the buffer local variable
	`c-buffer-is-cc-mode', which is faster than using
	`derived-mode-class'.

Sun Mar 10 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-syntactic-ws,
	c-backward-syntactic-ws, c-forward-token-1,
	c-backward-token-1, c-in-literal, c-literal-limits,
	c-collect-line-comments, c-literal-type, c-on-identifier,
	c-guess-basic-syntax): These functions are now considered part
	of the "CC Mode API" and may be used by other code.  That's
	signified by making their documentation into docstrings.

	(c-whack-state, c-hack-state, c-skip-case-statement-forward):
	Removed these internal functions since they aren't used.

	(c-forward-to-cpp-expression): Classified this function as
	internal.

Thu Mar 07 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-ObjC-class-key, c-Java-class-key): Simplified
	these regexps; the class keywords they contain ought to be
	enough to avoid false matches, so checking for following
	identifiers etc is just unnecessary (and might also fail for
	oddly formatted code).

Fri Feb 08 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-cmds.el (c-forward-comment-lc): New
	function that behaves like `c-forward-comment', with the
	exception that line continuations are treated as whitespace.

	(c-beginning-of-statement): Use `c-forward-comment-lc', to
	work correctly in macros and other places where line
	continuations should be treated as whitespace.

	* cc-engine.el (c-guess-basic-syntax): Analyze a normal label
	in a switch block as a case label, to get consistent lineup
	with the case labels.

	* cc-engine.el (c-backward-syntactic-ws): Fixed bug in
	skipping over a macro that ends with an empty line.

	* cc-styles.el: Require cc-align since styles added with
	`c-add-style' often contains references to functions defined
	there, and so the `c-valid-offset' check might otherwise
	complain on them.

Sun Jan 20 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-mode.texi, cc-vars.el: Added two new lineup
	functions:

	(c-lineup-knr-region-comment): A new lineup function to get
	(what most people think is) better indentation of comments in
	the "K&R region" between the function header and its body.

	(c-lineup-gcc-asm-reg): New lineup function for better
	indentation inside gcc asm blocks.  Contributed by Kevin Ryde.

	(c-offsets-alist): Use `c-lineup-gcc-asm-reg' and
	`c-lineup-knr-region-comment' in the default offset
	configuration, since these two functions have little impact
	outside their intended use, and they generally do the right
	thing when they kick in.

	* cc-engine.el (c-guess-continued-construct,
	c-guess-basic-syntax): Handle nested functions in all
	languages, not just Pike.  In C and C++ there's a gcc
	extension for this, and it also gives better treatment of
	macros that are followed by blocks.

	* cc-langs.el (c-symbol-key): Made this variable mode
	specific, to handle Pike special symbols like `== better.

Sat Jan 19 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el, cc-vars.el
	(c-report-syntactic-errors): A new variable to control the
	syntactic error messages.  It defaults to off; since CC Mode
	ignores most syntactic errors it might as well ignore them all
	for the sake of consistency.

Sat Jan 05 2002  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Updated the Limitations and Known Bugs
	section.  Various small fixes.

Thu Nov 29 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block): Optimization.  Can
	give a noticeable speedup if there's a large preceding
	function or class body.

Sun Nov 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-cmds.el: Use more efficient and correct
	insertion functions in many places.  Always inherit text
	properties correctly if the text is permanent.  Also do it for
	speed in temporary insertions, since I figure it's less work
	to continue the surrounding text properties than to break
	them.

	* cc-styles.el (c-read-offset): Unbind SPC in the completion
	to make it easier to enter lists.

Wed Nov 21 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-defun): Fixed bug where
	c-state-cache was clobbered.

	* cc-cmds.el, cc-engine.el (c-calculate-state): Moved from
	cc-cmds.el to cc-engine.el due to dependency.

Mon Oct 22 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state): Ignore unbalanced open parens
	in macros (if point isn't in the same one).

Sat Oct 13 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-context-open-line): New function that is the
	`open-line' equivalent to `c-context-line-break'.

	* cc-mode.el (c-mode-base-map): Compatibility fix for Emacs 21
	since `indent-new-comment-line' has been changed to
	`comment-indent-new-line' there.

Sun Oct 07 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el (c-stmt-delim-chars,
	c-stmt-delim-chars-with-comma): New variables containing the
	character sets used to recognize statement/declaration
	boundaries.  These variables might help to support languages
	like javascript and awk, where newlines sometimes delimits
	statements.

	(c-crosses-statement-barrier-p): Use `c-stmt-delim-chars' as
	the set of statement delimiting characters, to allow it to be
	changed dynamically and per-mode.

Sat Oct 06 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-bos, c-looking-at-inexpr-block,
	c-add-stmt-syntax, c-guess-basic-syntax): Treat blocks
	directly inside function calls like "bare" statements inside
	function calls, and not like in-expression statements.  This
	to make indentation of such blocks consistent with other
	statements inside macro calls.

	* cc-engine.el (c-guess-basic-syntax): Made arglist-cont
	anchor correctly in arglists that contain statements.

	* cc-engine.el (c-guess-basic-syntax): Fixed consistent
	anchoring of defun-block-intro in defuns in code blocks (can
	only occur in Pike).

	* cc-engine.el (c-looking-at-inexpr-block,
	c-looking-at-inexpr-block-backward): Changed the arguments to
	require containing sexps and paren state, for better
	efficiency.

Fri Oct 05 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el, cc-vars.el: Improved anchoring of
	statement and handling of labels in front of substatements.

	(c-guess-continued-construct, c-guess-basic-syntax): Improved
	and unified anchoring at statements.  Statements beginning
	with comments or labels are now avoided, by going out of
	blocks and containing statements if necessary.  This nesting
	handling also fixes the case when there's a statement after a
	block open brace.  Added the syntactic symbol
	`substatement-label'.

	(c-electric-colon): Map the new `substatement-label' to
	`label' when consulting `c-hanging-colons-alist'.

	(c-offsets-alist): Added substatement-label.  Updated the
	comments for the new anchoring positions at statements.

	* cc-engine.el (c-guess-basic-syntax): Use more sane anchor
	points for knr-argdecl-intro and access-label.  They used to
	refer to some point on the same line, a bug which was
	neutralized by a kludge in `c-get-syntactic-indentation' which
	ignored such anchor points.

	(c-get-syntactic-indentation): Removed the kludge that was
	necessary due to buggy anchor points.

	* cc-engine.el (c-guess-basic-syntax): Do not check the
	absence of a comma before arglist-close (case 7A) in any
	language, since there's nothing better to do that case anyway.
	Added special case to make in-expression statements be
	recognized as normal arglist-cont if we're directly in a macro
	arglist, for consistency with other "bare" statements.

	* cc-engine.el (c-looking-at-bos): Added optional limit arg
	for backward searches.

	* cc-engine.el (c-looking-at-inexpr-block): Anchor gcc
	in-expression statements at the surrounding open parenthesis.
	Treat a class body as an in-expression class if it's used in
	an object clone expression in Pike.

	* cc-engine.el (c-get-offset, c-get-syntactic-indentation):
	Allow several anchor positions in the list of syntactic
	symbols.  Only the first is used as the base for the offset
	calculation.

Tue Oct 02 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-defun): Indent the current macro if
	inside one at the top level.  Do not throw an error if used at
	the top level outside a macro.

	* cc-cmds.el (c-backslash-region): Do tab width alignment only
	if the backslashes can't be aligned with surrounding
	backslashes.

	* cc-engine.el (c-end-of-macro): New function.

	* cc-engine.el (c-least-enclosing-brace): Rewritten to not be
	destructive.

Sat Sep 29 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-context-line-break): Only do a macro line
	break when point is inside the content of it; if it's in the
	cpp keyword a normal line break is done.

	* cc-engine.el (c-guess-basic-syntax): Do not add
	cpp-macro-cont inside the argument list to a #define.

Thu Sep 27 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-forward-comment): Implemented a kludge to
	avoid the problem most forward-comment incarnations have with
	`\' together with comment parsing.

Wed Sep 26 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-check-state-cache): Fixed bug which could
	cause the state returned by `c-parse-state' to lack a closed
	paren element.  That in turn could result in very long
	searches, since it's common that they start from the last
	preceding close brace.

Tue Sep 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Do not treat
	else-if as a single continuation, since that'd make it hard to
	get the right anchor point when there's a line break between
	the two keywords.  This change causes else-clause to be
	anchored on the closest preceding else-if and not always on
	the starting if, but that doesn't affect the indentation for
	any reasonably sane style.  Also introduced a noerror flag.

	(c-beginning-of-closest-statement): Removed;
	c-beginning-of-statement-1 now avoids the problem this one
	solved.

	* cc-engine.el (c-guess-continued-construct,
	c-guess-basic-syntax): Better and more uniform anchor points
	for 'statement-cont and 'substatement.  The effect is
	noticeable mostly when there's a label on the same line as the
	beginning of the statement, or when there are more stuff
	before the start of the statement.

	* cc-engine.el (c-looking-at-inexpr-block): Added flag to
	disable looking at the type of the surrounding paren since
	that confuses c-beginning-of-statement-1 and a couple of other
	places.

	* cc-engine.el (c-guess-basic-syntax): Avoid stepping to the
	previous statement in case 18.  Improvements in recognition of
	statement blocks on the top level.

Sun Sep 23 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1,
	c-crosses-statement-barrier-p): Rewritten to get a well
	defined and documented behavior.  This fixes some tricky cases
	in recognition of do-while constructs.

	(c-backward-to-start-of-do, c-backward-to-start-of-if):
	Removed; use c-beginning-of-statement-1 instead.

	(c-guess-continued-construct, c-guess-basic-syntax): Various
	fixes to not depend on the bugs previously in
	c-beginning-of-statement-1.  Cleanups in cases 18 and 17 to
	use the new behavior of c-beginning-of-statement-1 better.
	Fixed recognition of catch blocks inside macros.

	* cc-engine.el (c-backward-syntactic-ws): Fixed bug in
	skipping over a macro.

	* cc-langs.el (c-label-kwds): New variable to contain the
	appropriate c-*-label-kwds value.

	* cc-vars.el (defcustom-c-stylevar): Fixed value evaluation
	bug that caused the widget for c-block-comment-prefix to bug
	out.

Fri Sep 21 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Improved recognition of
	statements: They are now recognized in contexts where they
	normally can't occur, e.g. on the top level or in function
	call arguments.  This is mainly useful to recognize statements
	in macros at the top level, and in arguments to macros.  The
	cases has been moved around quite a bit, and case 10 has been
	copied to case 18.  (The cases has not been renumbered because
	of this.)

	(c-guess-continued-construct): New function which has the
	rules which are common between cases 10 and 18.

	* cc-engine.el (c-beginning-of-statement-1,
	c-backward-to-start-of-do, c-backward-to-start-of-if): Fixes
	so that they really obey the passed limits.

	(c-safe-position): Return nil if the state doesn't contain a
	suitable position.

	(c-guess-basic-syntax): Fixes some too short limits in calls
	to c-beginning-of-statement-1.  Some fixes for top level
	analysis in ObjC mode.

	* cc-engine.el (c-beginning-of-statement-1): Fixed bug in
	do-while statements where the body is not a block.

	* cc-styles.el (c-set-style): Reset c-special-indent-hook to
	its global value if in override mode.  Fixes problem where
	functions on that hook remained after style switch.

	* cc-engine.el (c-evaluate-offset, c-get-offset): Use
	c-benign-error to report the c-strict-syntax-p error.

Thu Sep 20 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-defs.el, cc-cmds.el, cc-engine.el,
	cc-vars.el: Several fixes to treat macros as code and not
	literals and to handle line continuations transparently.

	(c-skip-ws-forward, c-skip-ws-backward): New macros to skip
	through whitespace and line continuations, but not comments
	and macros.

	(c-in-literal): No longer recognizes macros as literals by
	default. An extra flag argument is required to do that.

	(c-macro-start, c-query-macro-start,
	c-query-and-set-macro-start): Added a cache for the macro
	start position.

	(c-forward-syntactic-ws, c-backward-syntactic-ws): Fixes for
	more speed when limits are given.  Workaround for bad behavior
	in forward-comment in some emacsen when it hits a buffer limit
	with a large repeat count.

	(c-lineup-macro-cont): Improved behavior when
	c-syntactic-indentation-in-macros is nil.

	(c-syntactic-indentation-in-macros, c-backslash-max-column,
	c-auto-align-backslashes): New customization variables to
	control macro handling.

	* cc-menus.el (cc-imenu-c++-generic-expression): Fixes to
	handle line continuations.

	* cc-defs.el, cc-styles.el (c-get-style-variables,
	c-set-offset): Report style errors with message and ding
	instead of error signal.  This to avoid interrupted mode init
	if there's some style problem.

	(c-benign-error): New macro to report errors that doesn't need
	to interrupt the operation.

	* cc-defs.el (c-point): Added eonl and eopl positions.

Tue Sep 18 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace, c-indent-region): Removed most
	of the c-state-cache fiddling, since the global state cache
	now handles this.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug when there's
	an open paren at the very first char of the visible buffer
	region.

	* cc-engine.el (c-parse-state, c-check-state-cache): Cache the
	state globally and invalidate it below every buffer change
	with the new after change function `c-check-state-cache'.
	This gives a considerable performance boost when editing large
	functions or classes.

	* cc-engine.el (c-whack-state-after): Slight optimization.

Sun Sep 16 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el, cc-align.el: Improvements to
	syntactic analysis inside macros:

	(c-block-stmt-1-kwds, c-block-stmt-2-kwds): New variables used
	by `c-guess-basic-syntax'.

	(c-parse-state): Fixed bug with braces inside macros when
	using cached state info.

	(c-forward-to-cpp-expression): New function to aid in
	syntactic analysis inside macros.

	(c-beginning-of-statement-1, c-backward-syntactic-ws): Fixes
	to work better inside macros.

	(c-forward-syntactic-ws): Whitespace between the # and the
	command should be allowed in preprocessor directives.

	(c-lineup-macro-cont): New lineup function to get context
	sensitive indentation inside macros.

	(c-offsets-alist): Made `c-lineup-macro-cont' the default for
	cpp-macro-cont.

Sat Sep 15 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1,
	c-forward-syntactic-ws): Fixes to handle continued lines.

	(c-backward-to-start-of-if, c-guess-basic-syntax): Do
	syntactic analysis inside macros.

Sat Sep 08 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-region): Did a speedup made possible by
	the more flexible state cache.

	* cc-engine.el (c-parse-state, c-whack-state-before,
	c-whack-state-after, c-hack-state,
	c-narrow-out-enclosing-class, c-guess-basic-syntax): Improved
	the state cache system.  It now can use partial info from an
	old cached state to calculate a new one at a different
	position.  Removed some kludges to avoid the state cache.  The
	new functions `c-whack-state-before' and `c-whack-state-after'
	replace the now obsolete `c-whack-state'.

	* cc-engine.el (c-beginning-of-statement-1): Optimized backing
	through a macro.  This can speed things up quite a bit when
	there are long macros before point.

	(c-beginning-of-macro): Do not ignore the limit.

Sun Sep 02 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-continued-statement): Fixed a bug
	where the keyword wasn't reindented correctly if followed by
	another keyword or identifier.

	* cc-engine.el (c-parse-state): Ignore closed brace pairs that
	are in macros.  Fixes some cases where e.g. the second of two
	"do { } while (0)" macros after each other indented
	differently.

Fri Aug 31 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-macro, c-forward-syntactic-ws):
	Recognize "#!" as a preprocessor directive when it begins a
	line, to allow for script interpreter lines like
	"#!/usr/bin/pike" at the beginning of the file.

Thu Aug 30 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block): Recognize brace
	blocks inside a parenthesis expression as inexpr-statement.
	Useful when writing statements as macro arguments.

Sat Aug 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph, c-do-auto-fill,
	c-mask-comment): Broke out the comment masking code from
	`c-fill-paragraph' to a new function `c-mask-comment', to be
	able to do the same thing in `c-do-auto-fill'.  This should
	make auto-fill-mode behave better.

Mon Aug 20 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace, c-electric-paren): Check
	`executing-macro' to avoid blinking parens when macros are
	executed.

	* cc-mode.el, cc-styles.el (c-setup-filladapt): Moved from
	cc-mode.el to cc-styles.el for consistency with
	`c-setup-paragraph-variables' (which was placed there due to
	the dependency from `c-set-style').

	* cc-styles.el, cc-vars.el: Fixed bug with incomplete
	initialization from the style variable fallbacks if there
	already is a style called "user" defined when CC Mode starts
	up for the first time.

Fri Aug 17 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-vars.el (c-comment-indent,
	c-indent-comment-alist): Added new variable
	`c-indent-comment-alist' to allow better control over
	`c-comment-indent'.

Tue Aug 14 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-C-comments): Try to match both
	`comment-start-skip' and the comment prefix on the current
	line with the comment starter, so that we line up comments
	which matches `c-comment-prefix-regexp' on the first line
	(after the `/') without the need to make `comment-start-skip'
	match whatever `c-comment-prefix-regexp' matches.

	* cc-mode.el, cc-styles.el (c-common-init, c-set-style-1,
	c-setup-paragraph-variables): Moved the variable
	initialization based on `c-comment-prefix-regexp' to a new
	function `c-setup-paragraph-variables', which is now used both
	at mode init and when a style that sets
	`c-comment-prefix-regexp' is activated.

Sat Aug 11 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-member-init-list): Better
	handling of C++ template args to avoid confusion with `<' and
	`>' used as operators in member init expressions.

Wed Jul 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-most-enclosing-brace,
	c-least-enclosing-brace): Added optional second arg to limit
	the search to before a certain point.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug which could
	cause incorrect analysis if a cached state is used (usually
	only happens when an electric key reindents a line).

Tue Jul 24 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-forward-comment): More idiosyncrasy
	insulation.  This time for XEmacs 21.

	* cc-engine.el, cc-langs.el: Improved handling of inheritance
	lists:

	(c-beginning-of-inheritance-list): Rewritten to use a more
	syntactically correct method that doesn't get confused by
	badly placed linebreaks and comments.

	(c-guess-basic-syntax): Several fixes to the handling of
	inheritance lists in combination with templates.  'inher-intro
	is now anchored on the start of the class declaration and not
	the indentation of the current line.  Switched places on cases
	5D.3 and 5D.4 and made them use more syntactically correct
	methods.

	(c-inher-key): Removed since the code in
	`c-guess-basic-syntax' now uses token-based search.

	* cc-cmds.el, cc-mode.el (c-mode-menu): Added a submenu to
	access some toggles.

	(c-toggle-syntactic-indentation): New function to toggle the
	variable `c-syntactic-indentation'.

	* cc-styles.el (c-set-style): Improved the error message for
	incorrect offsets a bit.

Mon Jul 23 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-exp): Don't require that the sexp
	follows point immediately, instead find the closest following
	open paren that ends on another line.

Sat Jul 21 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-cascaded-calls): New indentation function.

	* cc-engine.el (c-beginning-of-macro): Bugfix for directives
	with whitespace between the '#' and the name.

	* cc-mode.texi: Rearranged the indentation functions in
	alphabetic order.  Documented c-lineup-cascaded-calls.

Fri Jul 20 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-syntactic-ws,
	c-backward-syntactic-ws): Handle line continuations as
	whitespace.  Don't move past a macro if that'd take us past
	the limit.

Wed Jul 11 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-macro, c-forward-syntactic-ws):
	Multiline strings begin with `#"' in Pike, and that shouldn't
	be confused with a preprocessor directive.

Mon Jul 09 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Extended the kludge to interoperate with the
	delsel and pending-del packages wrt to the new function
	`c-electric-delete-forward'.

Fri Jul 06 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-exp): Keep the indentation of the block
	itself, i.e. only indent the contents in it.

	* cc-styles.el (c-set-style): Use the default argument to
	completing-read instead of initial-contents, if the function
	is recent enough to support it.

Mon Jun 11 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-mode-help-address): Removed
	bug-gnu-emacs@gnu.org from the receiver list for bug reports.
	I've almost never seen a bug reported this way that should go
	to that list, but it's rather common that the reports concern
	the combination CC Mode and XEmacs instead.

Sun Jun 10 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-paren): Fixed bug when both
	brace-elseif-brace and brace-catch-brace are active and
	there's a "else if"-block before the catch block.

	* cc-menus.el (cc-imenu-c++-generic-expression): Detect
	function headers that span lines.

Sat May 12 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace, c-electric-semi&comma,
	c-electric-colon, c-electric-paren): Check for last on line
	only for doing the auto-newline-mode stuff, not for the
	reindentation.

	* cc-cmds.el (c-electric-brace): Fixed bugs in the handling of
	c-syntactic-indentation: When it's nil, indent the new lines
	but don't reindent the current one.  Reindent the line only
	when the inserted brace comes first on it, instead of last.

	* cc-cmds.el (c-electric-brace, c-electric-semi&comma): Fixed
	two places where c-syntactic-indentation wasn't heeded.

	* cc-cmds.el (c-electric-pound): Don't be electric inside a
	macro.

	* cc-engine.el (c-backward-to-start-of-if): Try a little
	harder to find a fallback position when an orphan else is
	found.  Fixed case where an else following a do-while
	statement could be associated with an if inside the do-while.

Fri May 11 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-guess-fill-prefix): Tuned the dwim for the
	fallback to add a single space after the comment prefix.

	* cc-cmds.el (c-indent-new-comment-line): Somewhat better
	behavior in some special cases, especially for single-line
	comments.  Avoid breaking up a comment starter or ender.

Sat May 05 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-outline-level): Applied patch from the Emacs
	sources to make this work in invisible text.

	* cc-langs.el (c-switch-label-key): Fixed regexp to not be
	confused by a later ':' on the same line as the label.

Wed May 02 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-mode.el (c-electric-delete,
	c-electric-delete-forward): Split `c-electric-delete' into two
	functions where `c-electric-delete-forward' always deletes
	forward and `c-electric-delete' only contains the code
	necessary for XEmacs to choose between backward and forward
	deletion.  `c-electric-delete-forward' is now bound to C-d to
	get the electric behavior on that key too.

	* cc-mode.texi: Updated the doc for hungry-delete mode wrt the
	Backspace/Delete key handling.  Also incorporated a small
	clarification from the Emacs people.

Wed Mar 14 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph): Fixed bogus direct use of
	c-comment-prefix-regexp, which caused an error when it's a
	list.

Sun Feb 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release 5.28

Sun Feb 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-vars.el (c-common-init, c-default-style):
	Removed the hardcoded switch to "java" style in Java mode.
	It's instead taken care of by the default value for
	c-default-style.

	* cc-mode.texi: Documented the electric keyword feature.
	Updated the mentions of the "java" style special case for Java
	mode.

Sat Feb 24 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-math): Fix bug where lineup was
	triggered by equal signs in string literals.

Sun Feb 25 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-vars.el (c-common-init, c-default-style):
	Removed the hardcoded switch to "java" style in Java mode.
	It's instead taken care of by the default value for
	c-default-style.

	* cc-mode.texi: Updated the mentions of the "java" style
	special case for Java mode.

Sat Feb 24 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-math): Fix bug where lineup was
	triggered by equal signs in string literals.

Wed Feb 21 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph): Fixed bug in the paragraph
	limit detection when at the ends of the buffer.

	* cc-engine.el (c-guess-basic-syntax): Removed bogus check for
	"for" statement clause in case 7F; a better one is done
	earlier in case 7D anyway.

Tue Feb 20 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-guess-fill-prefix): Improved the heuristics
	somewhat more and did a small optimization.

Mon Feb 19 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-statement, c-end-of-statement):
	Use the limit argument only to limit the syntactic context
	search, not to limit the actual movement.

	* cc-cmds.el (c-beginning-of-statement): Move by sentence
	inside multiline strings, just like in comments.  Also various
	fixes to the paragraph and comment prefix recognition, block
	comment ender handling etc.

Sun Feb 18 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph): Take more care to preserve
	the relative position of the point.

	* cc-cmds.el (c-electric-continued-statement): New function to
	use as abbrev hook to reindent for keywords such as "else"
	that continues an earlier statement.

	* cc-menus.el (cc-imenu-c++-generic-expression): Treat structs
	like classes.

	* cc-mode.el (c-mode, c++-mode, java-mode, objc-mode,
	pike-mode): Populate the default abbrev tables to reindent for
	keywords such as "else" that can continue earlier statements.
	Abbrev mode is therefore turned on by default now.  (Note that
	this doesn't apply to idl-mode, since IDL afaik doesn't have
	statements at all.)

Wed Feb 14 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-inside-bracelist-p): Fix for handling
	bracelists where the declaration contains template arguments.

Fri Feb 09 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-indent): Use
	`c-get-syntactic-indentation' to correctly calculate the
	syntactic indentation.  Fixes bug with lineup functions that
	return vectors.

	* cc-engine.el (c-get-syntactic-indentation): Split the
	indentation sum calculation from `c-indent-line' to a separate
	function.

Mon Feb 05 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-statement, c-comment-indent):
	Fixed places where it was assumed that preprocessor directives
	have to start in column zero.

	* cc-engine.el (c-beginning-of-member-init-list): Handle C++
	template arguments after a class identifier properly.

	* cc-engine.el (c-guess-basic-syntax): Treat initializer brace
	lists for `new Foo[]' constructs in Java as expressions and
	not top level definition brace lists on the top level, so that
	they'll get indented consistently with the same type of
	expression in a normal block.

Sat Feb 03 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph): The kludge that checks
	whether the adaptive filling package fails to keep the comment
	prefix is now kludged further to check for filladapt-mode
	which doesn't have that problem. This is really icky, but it's
	the only way that works with the current misfeatures/bugs in
	both adaptive-fill-mode and filladapt-mode.

	* cc-cmds.el (c-fill-paragraph): Made the way the paragraph
	around point is recognized more robust.

Sun Jan 21 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-engine.el, cc-lobotomy.el (c-state-cache,
	c-in-literal-cache, c-auto-fill-prefix, c-lit-limits,
	c-lit-type): Fixed all internal variables used dynamically so
	that they are always bound.

	* cc-cmds.el, cc-engine.el: Improved recovery of syntactic
	errors:

	(c-indent-region): Fixed reporting of syntactic errors so that
	the region is fully reindented even when an error occurs.  The
	last syntactic error is printed afterwards.  Also cleanup up a
	whole lot of code that tried to optimize indentation of whole
	sexps but in reality accomplishes nothing.

	(c-indent-sexp): Use c-indent-region.

	(c-parsing-error): Changed this variable to hold the message
	for any syntactic error that is discovered.

	(c-parse-state): Search backward from point instead of the bod
	position when the latter is invalid.  This makes CC Mode
	recover faster when there are unbalanced close braces.

	(c-backward-to-start-of-if): Use c-parsing-error to report
	dangling "else" clauses instead of throwing an error, and fall
	back to a reasonable position.

	(c-indent-line): Added argument to avoid reporting syntactic
	errors.

	(c-show-syntactic-information): Don't report any syntactic
	errors.

Wed Jan 17 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-statement): Fixed bugs with
	paragraph recognition when moving by sentence in literals.

	* cc-langs.el (c-Java-javadoc-paragraph-start): Modified
	paragraph start regexp for javadoc to recognize javadoc markup
	in general instead of a specific set of keywords, to be more
	future-safe.

	(c-Pike-pikedoc-paragraph-start,
	c-Pike-pikedoc-paragraph-separate): New regexps to recognize
	pikedoc markup.

	* cc-mode.el: Fixed initialization and use of
	c-current-comment-prefix.

	(pike-mode): Initialize paragraph settings pikedoc
	recognition.

	* cc-vars.el (c-default-style): Made a nicer Customize widget.

	(c-comment-prefix-regexp): Made it possible to use an
	association list on this to specify mode specific regexps.
	The default value now use a special regexp in Pike mode to
	recognize pikedoc markup.

	(c-current-comment-prefix): New variable containing the actual
	regexp from c-comment-prefix-regexp for the current buffer.

Sun Jan 14 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fixed check for special brace
	lists: We can't look at the syntax, since a brace list can get
	recognized as a plain statement-cont.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug where a
	special brace list opener broken over two lines got recognized
	as a statement on the second line.  Case 9A changed.

Mon Jan 08 2001  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fixed bug in c-state-cache
	adjustment after line is reindented.

Wed Dec 27 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-point): Added optional argument for position
	to use instead of the current point.

	* cc-defs.el, cc-engine.el (c-add-class-syntax): Do not add
	the in-expression block symbols when the construct starts at
	boi, to avoid the extra level of indentation in that case.
	Cases 4, 16A and 17E affected.

Sun Nov 26 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Use `indent-according-to-mode' instead of direct
	calls to `c-indent-line', to adhere better to Emacs
	conventions.

	* cc-engine.el (c-indent-line): Use the syntax already bound
	to `c-syntactic-context', if there is any.

Sun Nov 19 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-get-offset): Fixed bug where the indentation
	wasn't added up correctly when a lineup function returned nil.

Fri Nov 17 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-collect-line-comments): Fixed bug where
	empty lines were ignored when collecting line comments
	backwards.

Sun Oct 08 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-dont-change): Return an absolute
	indentation column to work correctly in the case when several
	syntactic elements are processed for the same line.

	* cc-engine.el, cc-styles.el, cc-vars.el (c-evaluate-offset,
	c-get-offset, c-indent-line, c-valid-offset, c-read-offset,
	c-set-offset): Added absolute indentation column settings by
	using the vector type.

	* cc-mode.texi: Documented the new vector setting for offsets.

Mon Oct 02 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-vars.el (c-electric-paren, c-cleanup-list):
	Implemented two new cleanups `space-before-funcall' and
	`compact-empty-funcall'.

	* cc-mode.texi: Documented the two new cleanups
	space-before-funcall and compact-empty-funcall on
	c-cleanup-list.

Sun Oct 01 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-paren-re, c-identifier-re): Two new macros for
	helping building regexps.

	* cc-engine.el (c-on-identifier): New function for detecting
	identifiers.  It takes keywords into account.

	* cc-langs.el, cc-mode.el: Added regexps for complete keyword
	lists.  `c-keywords' is set to a regexp matching all keywords
	in the current language.

Tue Sep 26 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Added '#' to the
	list of characters to skip backwards over at the beginning of
	a statement, since it can precede string literals in Pike.

Thu Aug 31 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-guess-fill-prefix): Fixed bug with prefix
	recognition when standing on the last line in a C++ comment
	with nothing but whitespace after the prefix.

	* cc-engine.el (c-backward-to-start-of-if): Fixed bug when
	given no limit argument.

Wed Aug 30 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-inside-bracelist-p): Fixed brace list
	recognition for the `[]= operator symbol in Pike.

Sat Aug 26 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-bytecomp.el (cc-eval-when-compile): New macro that works
	around a bug in `eval-when-compile' in the byte compiler.

	* cc-engine.el (c-forward-token-1): Fixed bug with return
	value when count is zero and there's no token start within the
	limit.

	(c-guess-basic-syntax): Don't add 'comment-intro to lines with
	"prefix comments", i.e. comments which are followed by code on
	the same line.

	* cc-mode-19.el: Fixes so that checks that must be done at
	compile time also are done then.

Fri Aug 25 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el: Make sure cc-mode-19 is loaded both at compile
	time and at runtime, and only when it's needed.

Sun Aug 20 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Major cleanup for less error prone and more warning free
	compilation, including some fixes for bugs due to different
	compilation orders. Thanks to Martin Buchholz for providing
	the basis for all this.

	cc-bytecomp.el: New file that provides some byte compilation
	features: It ensures that files always are loaded from the
	current source directory during compilation, and it provides a
	set of macros to turn off specific compiler warnings for
	specific symbols.  (It's not CC Mode specific in any way.)

	Fixed a nearly acyclic dependency tree (both runtime and
	compile-time) between all files.

	cc-defs.el: Separated all macros before the inline functions,
	to ensure correct compilation.

	cc-defs.el, cc-engine.el: Moved c-beginning-of-macro to from
	cc-defs.el to cc-engine.el and made it a function instead.

	cc-mode-19.el: Patch the byte compiler in Emacs 19 not to warn
	about char-after.

	cc-vars.el: Cope even when there isn't a custom package
	containing defcustom available.

	cc-make.el: Removed since it's no longer necessary.

	README: Updated installation instructions.

Mon Aug 14 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-langs.el, cc-mode.el: Moved around things to
	improve the modularity: Moved all mode init stuff from
	cc-langs.el to cc-mode.el, including the keymap
	initialization; cc-langs now only contains the various
	variables for configuring the language syntax.

	* cc-engine.el, cc-styles.el (c-evaluate-offset,
	c-get-offset): Moved from cc-styles to cc-engine since file
	dependency analysis suggests they belong there (which also
	makes more sense).  Thanks to Martin Buchholz for doing the
	analysis.

Sat Aug 12 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fn-region-is-active-p): New function that
	wraps the corresponding macro, for use in places that aren't
	compiled.  Thanks to Martin Buchholz for pointing out this.

	* cc-langs.el (c-mode-menu): Use c-fn-region-is-active-p.

	* cc-mode.el (c-prepare-bug-report-hooks): Hook variable to
	add things to the bug report.

Mon Aug 07 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-guess-fill-prefix): Fixed bug where the
	returned prefix could contain a newline when the search for a
	good prefix line failed.

Sun Aug 06 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-toggle-auto-state, c-toggle-hungry-state,
	c-toggle-auto-hungry-state): Made the argument optional, as
	the documentation says it is.

Sat Aug 05 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Don't treat the Pike
	multiline string syntax, #"...", as a cpp macro.

Mon Jul 10 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release 5.27

Sun Jul 09 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block): Replaced a call to
	c-beginning-of-statement-1 that caused a bad case of recursion
	which could consume a lot of CPU in large classes in languages
	that have in-expression classes (i.e. Java and Pike).

	* cc-engine.el (c-guess-basic-syntax): Check for in-expression
	statements before top level constructs (i.e. case 6 is moved
	before case 5 and is now case 4) to catch in-expression
	classes in top level expressions correctly.

Sun Jul 02 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Less naive handling of
	objc-method-intro. Case 4 removed and case 5I added.

	* cc-langs.el (c-append-paragraph-start): New variable used by
	c-common-init to get paragraph-start correct.
	* cc-langs.el (c-common-init): Use c-append-paragraph-start to
	initialize paragraph-start to make it correct both with and
	without the javadoc special case.

	* cc-mode.el (java-mode): Use c-append-paragraph-start to
	initialize paragraph-start for javadoc markup.

	* cc-vars.el (c-style-variables-are-local-p): Incompatible
	change by defaulting this to t.  It's motivated by the
	confusing behavior that otherwise arise from the style system
	when editing both java and non-java files at the same time
	(see the comments about style setting in c-common-init).

Tue Jun 20 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-new-comment-line): Added a kludge
	similar to the one in c-fill-paragraph to check the fill
	prefix from the adaptive fill function for sanity.

Mon May 01 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-end-of-defun-1): Fixed forward scanning into
	defun block.

Sun Mar 19 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi Documented the change of cpp-macro.

Tue Mar 14 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-multi-inher): Handle lines with
	leading comma nicely. Extended to handle member initializers
	too.

	* cc-engine.el (c-beginning-of-inheritance-list,
	c-guess-basic-syntax): Fixed recognition of inheritance lists
	when the lines begins with a comma.

	* cc-mode.texi Updated doc for c-lineup-multi-inher.

	* cc-vars.el (c-offsets-alist): Changed default for
	member-init-cont to c-lineup-multi-inher since it now handles
	member initializers and indents better for leading commas.

Sun Mar 12 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fixed some bugs in the state
	handling that caused class open lines to be recognized as
	statement-conts in some cases.

	* cc-cmds.el (c-indent-new-comment-line): Keep the fill prefix
	guessed by the adaptive fill function unless point is on the
	first line of a block comment.

	* cc-engine.el (c-forward-syntactic-ws): Fixed an infloop bug
	when the buffer ends with a macro continuation char.

	* cc-engine.el (c-guess-basic-syntax): Added support for
	function definitions as statements in Pike.  The first
	statement in a lambda block is now labeled defun-block-intro
	instead of statement-block-intro.

	* cc-engine.el (c-narrow-out-enclosing-class): Whack the state
	so that the class surrounding point is selected, not the one
	innermost in the state.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug in
	recognition of switch labels having hanging multiline
	statements.

	* cc-engine.el (c-beginning-of-member-init-list): Broke out
	some code in c-guess-basic-syntax to a separate function.
	* cc-engine.el (c-just-after-func-arglist-p): Fixed
	recognition of member inits with multiple line arglists.
	* cc-engine.el (c-guess-basic-syntax): New case 5B.3 to detect
	member-init-cont when the commas are in funny places.

Thu Mar 09 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-auto-newline): Removed this macro since it's
	not used anymore.

	* cc-engine.el (c-looking-at-bos): New helper function.
	* cc-engine.el (c-looking-at-inexpr-block): More tests to tell
	inexpr and toplevel classes apart in Pike.

	* cc-engine.el (c-guess-basic-syntax): Fixed bogus recognition
	of case 9A.

	* cc-langs.el, cc-mode.el (c-Pike-inexpr-class-key): New
	constant, since "class" can introduce an in-expression class
	in Pike nowadays.

Sun Feb 06 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-gnu-impose-minimum): Don't impose minimum
	indentation on cpp-macro lines.

	* cc-engine.el (c-guess-basic-syntax): Made the cpp-macro
	a syntax modifier like comment-intro, to make it possible to
	get syntactic indentation for preprocessor directives.  It's
	incompatible wrt to lineup functions on cpp-macro, but it has
	no observable effect in the 99.9% common case where cpp-macro
	is set to -1000.

Sat Feb 05 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed bug with missed
	member-init-cont when the preceding arglist is several lines.

Sat Jan 29 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist): The basic offset for the BSD
	style corrected to 8.

Sun Jan 16 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist): Adjusted the indentation of
	brace list openers in the gnu style.

Sun Jan 09 2000  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-command): Obey c-syntactic-indentation.

	* cc-cmds.el (c-electric-brace, c-electric-slash,
	c-electric-star, c-electric-semi&comma, c-electric-colon,
	c-electric-lt-gt, c-electric-paren): Don't reindent old lines
	when c-syntactic-indentation is nil.

	* cc-engine.el (c-beginning-of-statement-1): Fixed bug where
	we were left at comments preceding the first statement when
	reaching the beginning of the buffer.

	* cc-vars.el (c-syntactic-indentation): New variable to turn
	off all syntactic indentation.

Tue Dec 28 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph): Keep one or two spaces
	between the text and the block comment ender when it hangs,
	depending on how many there are before the fill.

Sun Dec 19 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-closest-statement): New helper
	function to go back to the closest preceding statement start,
	which could be inside a conditional statement.
	* cc-engine.el (c-guess-basic-syntax): Use
	c-beginning-of-closest-statement in cases 10B.2, 17B and 17C.

	* cc-engine.el (c-guess-basic-syntax): Better handling of
	arglist-intro, arglist-cont-nonempty and arglist-close when
	the arglist is nested inside parens.  Cases 7A, 7C and 7F
	changed.

	* cc-langs.el (c-Java-javadoc-paragraph-start): Brought
	up-to-date with javadoc 1.2.

Fri Dec 17 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Fixed handling of
	multiline Pike type decls.

Tue Dec 14 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-new-comment-line): Always break
	multiline comments in multiline mode, regardless of
	comment-multi-line.

Mon Dec 13 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed bug with
	fully::qualified::names in C++ member init lists.  Preamble in
	case 5D changed.

Sat Dec 04 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-common-init): Handling of obsolete variables
	moved to c-initialize-cc-mode.  More compatible style override
	when using global style variables.
	* cc-mode.el (c-initialize-cc-mode): Handling of obsolete
	variables moved here.

	* cc-mode.texi Documented the special behavior of
	c-special-indent-hook as a style variable.  Don't talk about
	doing (c-make-styles-buffer-local t) in a mode hook, since
	that's already too late to work right.

	* cc-styles.el (c-make-styles-buffer-local): Flag style
	variable localness in c-style-variables-are-local-p to make
	the compatibility measure in c-common-init work well.

	* cc-styles.el (c-set-style-1): c-special-indent-hook can no
	longer contain set-from-style.
	* cc-styles.el (c-initialize-builtin-style): Don't check for
	set-from-style on c-special-indent-hook.
	* cc-styles.el (c-copy-tree): Obsolete.  The standard function
	copy-alist is sufficient now.

	* cc-styles.el (c-set-style, c-set-style-1,
	c-get-style-variables): Fixes to variable initialization so
	that duplicate entries in styles have the same effect
	regardless of DONT-OVERRIDE.

	* cc-styles.el (c-set-style-2): Fixed bug where the
	initialization of inheriting styles failed when the
	dont-override flag is set.

	* cc-vars.el (c-special-indent-hook): Don't use set-from-style
	on this.

Mon Nov 22 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-forward-comment): Removed the workaround
	introduced in 5.38 since it had worse side-effects.  If a line
	contains the string "//\"", it regarded the // as a comment
	start since the \ temporarily doesn't have escape syntax.

Sun Nov 21 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release 5.26

Sun Nov 21 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-forward-conditional): Handle an arbitrary
	target depth.  Optionally count #else lines as clause limits,
	as suggested by don provan <provan@lucent.com>.  #elif
	handling fixed.

	* (c-up-conditional-with-else, c-down-conditional,
	c-down-conditional-with-else): New commands that uses the
	added functionality in `c-forward-conditional'.

	* cc-mode.texi: Documented the new up/down preprocessor
	conditional function varieties.

Tue Nov 09 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Updated for all the new features and
	proofread.  Major changes:
	o  All text filling and line breaking issues is collected in a
	   new top-level chapter.  The section on auto-fill mode
	   interaction have been incorporated into this.
	o  The list of the standard lineup functions is expanded with
	   better explanations and examples.  It's moved to a
	   top-level chapter since it's hard to find under Customizing
	   Indentation / Advanced Customizations / Custom Indentation
	   Functions.
	o  The sections on Permanent Customization and Styles are
	   mostly rewritten due to the changes in the style system.
	   The part about the mode hooks has gotten an own section.

Tue Oct 26 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-comment): Preserve the alignment with
	a comment on the previous line instead of preserving the
	comment-column.

Sun Sep 26 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Fixes to IDL mode after input from Eric Eide
	<eeide@cs.utah.edu>:
	* cc-engine.el (c-beginning-of-statement-1): Allow
	`c-conditional-key' to be nil, for the benefit of IDL mode.
	* cc-engine.el (c-guess-basic-syntax): Ditto.
	cc-langs.el (C-IDL-class-key): Fixed.  Don't match `class'
	but do match CORBA 2.3 `valuetype'.
	* cc-langs.el (c-IDL-access-key): New defconst.  Should be nil
	for IDL.
	* cc-langs.el (c-IDL-conditional-key): New defconst.  Should
	be nil for IDL.
	* cc-langs.el (c-IDL-comment-start-regexp): New defconst.
	Like C++.
	* cc-mode.el (idl-mode): Use new `c-IDL-*' defconsts.  Also,
	set `c-method-key' and `c-baseclass-key' to nil.

Wed Aug 25 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-menus.el (cc-imenu-c++-generic-expression): Match classes
	with nonhanging open braces.

Sun Aug 15 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el: Added docstrings to all lineup functions.

	* cc-align.el (c-lineup-java-throws): Handle a hanging throws
	keyword.

	* cc-align.el (c-lineup-C-comments): Handle free form text
	comments.  Use c-comment-prefix-regexp and comment-start-skip
	instead of hardcoded regexps.

Sat Aug 14 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-beginning-of-defun, c-end-of-defun): Fixed eob
	behavior and return value as documented.

Sat Jul 31 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Changes for new style variable init system:
	* cc-langs.el (c-common-init): Dito.
	* cc-styles.el: c-offsets-alist moved to cc-vars.el since it's
	now customizable.
	* cc-vars.el: Style variables may now take a value
	'set-from-style to make them take their value from the style
	system. This value is now the default on all these variables.
	* cc-vars.el (c-valid-offset): New function to verify a
	syntactic symbol offset setting.
	* cc-vars.el (c-offsets-alist): Variable moved from
	cc-styles.el since it's now customizable in a similar way to
	the other style variables.
	* cc-vars.el (c-old-style-variable-behavior): New variable to
	revert to the old style init behavior.

	* cc-vars.el (c-hanging-comment-starter-p,
	c-hanging-comment-ender-p): These variables are now obsolete and
	therefore removed.

	* cc-vars.el (c-file-style, c-file-offsets): Made always
	buffer local.

	* cc-menus.el (cc-imenu-c++-generic-expression): Don't match
	the throws clause that might follow the function prototype in
	C++.

Sat Jul 24 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-beginning-of-macro): Fixed bug where point
	could move forward for macros that doesn't start in column 0.

Thu Jul 08 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-indent-multi-line-block,
	c-lineup-whitesmith-in-block): Two new lineup functions for
	use in whitesmith style.

	* cc-styles.el (c-style-alist): More fixes to whitesmith
	style.  It should now handle all different braces uniformly in
	both hanging and non-hanging cases.

Wed Jul 07 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Documented the default behavior when a symbol
	doesn't exist on c-hanging-braces-alist.

Mon Jul 05 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-exp): Use a marker to save point to
	make it stay in the same position relative to the surrounding
	text.

	* cc-cmds.el (c-fill-paragraph): Force the line comment prefix
	when adaptive-fill-mode doesn't manage to get it correct.

	* cc-menus.el (cc-imenu-java-generic-expression): Handle types
	with dotted notation, e.g. foo.bar.Gnu.

	* cc-mode.el (c-initialize-cc-mode): Wrap all function calls
	within unwind-protect (previously only some were wrapped so it
	would be possible to register mode initialization when full
	initialization did not finish).

	* cc-styles.el (c-style-alist): Corrected the brace placement
	in the whitesmith style.  Thanks to Sean Luke
	<seanl@cs.umd.edu>.  Also extended the bsd and whitesmith
	styles with consistent brace placement for all constructs.

Sun Jul 04 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-context-line-break): Continue C++ comments too
	when point is in the middle of them.

	* cc-cmds.el: Line breaking and paragraph filling code
	rewritten:
	(c-guess-fill-prefix): New function that uses various
	heuristics to guess the comment prefix.
	(c-fill-paragraph): Rewritten to use `c-guess-fill-prefix'.
	It now assumes adaptive filling is active to preserve the line
	prefix inside comments.
	(c-indent-new-comment-line): Replacement for the now
	obsolete `c-comment-line-break-function' that uses
	`c-guess-fill-prefix' when appropriate.  It now observes the
	setting of `comment-multi-line', which has effect in C-style
	block comments.

	* cc-cmds.el (c-context-line-break): New function intended to
	be put on RET.  It's essentially `newline-and-indent', but
	continues C block comments with the appropriate line prefix.

	* cc-cmds.el (c-do-auto-fill): New function put on
	`normal-auto-fill-function' to implement the
	`c-ignore-auto-fill' variable.

	* cc-cmds.el (c-beginning-of-statement): Use
	`c-comment-prefix-regexp' to avoid ending up inside the
	comment prefix.  Better handling of comment starters and
	enders. Catch comments better when traversing code.  Stop at
	preprocessor directives.

	* cc-defs.el (c-forward-comment): New subst to hide platform
	dependent quirks in `forward-comment'.

	* cc-engine.el (c-literal-limits): Added NOT-IN-DELIMITER
	argument.
	(c-literal-limits-fast): Implemented NEAR and NOT-IN-DELIMITER
	arguments. Activate this function by default when
	`parse-partial-sexp' supports it (currently Emacs 20.x).

	* cc-engine.el (c-guess-basic-syntax): Anchor the `c' syntax
	on the comment opener to make constants usable as lineup
	arguments.

	* cc-align.el (c-lineup-C-comments): Fixes to handle the
	changed anchor position in the `c' syntactic symbol.  Handle
	more than stars in the comment prefix; use the new variable
	`c-comment-prefix-regexp'.  Don't indent text not preceded by
	a comment prefix to the right of the comment opener if it's
	long.

	* cc-langs.el: Fixes to mode initialization for new line
	breaking and paragraph filling method.  Adaptive fill mode is
	now activated at startup instead of deactivated.  The
	variables used for adaptive filling and paragraph movement are
	also changed to incorporate the value of
	`c-comment-prefix-regexp'.  `substitute-key-definition' is
	used to override some functions in the global map instead of
	overriding their default bindings.

	* cc-mode.el (java-mode): Modify `paragraph-start' for the
	javadoc markup at mode init.

	* cc-mode.el (c-setup-filladapt): A new convenience function
	to configure Kyle E. Jones' Filladapt mode for CC Mode.  This
	function is intended to be used explicitly by the end user
	only.

	* cc-vars.el (c-comment-prefix-regexp): New variable used to
	recognize the comment fill prefix inside comments.
	(c-block-comment-prefix): New name for
	`c-comment-contiuation-stars', which is now obsolete.  It's
	generalized to handle any character sequence.
	(c-ignore-auto-fill): New variable used to selectively disable
	Auto Fill mode in specific contexts.

Tue Jun 29 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-indent): Leave at least one space
	between the comment and the last nonblank character in the
	case where we look at the indentation of the comment on the
	previous line (case 4).

	* cc-engine.el (c-beginning-of-statement-1): Added ``' to the
	list of characters that may start a statement (it's a sort of
	prefix operator in Pike, and isn't used at all in any of the
	other languages).

Tue Jun 15 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Report brace list opens
	inside continued statements as statement-cont instead of
	brace-list-open.  The reason is that one normally adjusts
	brace-list-open for brace lists as top-level constructs, and
	brace lists inside statements is a completely different
	context.  Case 10B.2 changed.  Also changed (the somewhat
	esoteric) case 9A to cope with this.

Sat May 29 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Added electric handling of
	the open brace for brace-elseif-brace.

Thu May 27 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-with-syntax-table): New macro to easily switch
	syntax tables temporarily.

	* cc-engine.el (c-guess-basic-syntax): Handle template and
	member init argument lists split over several lines.  Case 5D
	changed.

	* cc-langs.el (c-Java-javadoc-paragraph-start): Added new tag
	@throws introduced in Javadoc 1.2.

	* cc-menus.el (cc-imenu-java-generic-expression): Applied
	patch from RMS to avoid infinite backtracking.

Sun May 16 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-arglist): Handle "arglists" surrounded
	by [ ].

Sat May 15 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-dont-change): Compensate properly for
	the column in langelem.

	* cc-engine.el (c-syntactic-information-on-region): New
	function to help debugging the syntactic analysis.

Mon May 03 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-template-args): Handle nested template
	arglists.

	* cc-langs.el (c++-template-syntax-table): New syntax table
	that makes `<' and `>' parenthesis characters, which is useful
	to switch to temporarily when analyzing template arglists.

	* cc-styles.el: Changed default alignment of labels in the
	java style to conform to the examples in the Java Language
	Specification.

	* cc-styles.el (c-offsets-alist): Use `c-lineup-template-args'
	by default.

Fri Mar 12 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Pike allows a comma
	immediately before the closing paren in an arglist, so don't
	check that in Pike mode.  Case 7A changed.

Sat Mar 06 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-region): Fixed bug where comment-only
	lines were ignored under certain conditions.

Fri Mar 05 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-template-args): New function for
	aligning continued template argument lists.

	* cc-engine.el (c-guess-basic-syntax): Fix for member init
	lists containing function arglists split over several lines.
	Case 5D.1 changed.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug where
	template-args-cont didn't get recognized when the first
	arglist opener line doesn't contain a template argument.  New
	case 5K.

Sat Feb 27 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-point): Changed from subst to macro for
	efficiency.
	(c-beginning-of-defun-1, c-end-of-defun-1): New
	beginning-of-defun/end-of-defun wrappers separated from
	c-point.

	* cc-menus.el (imenu-generic-expression,
	imenu-case-fold-search, imenu-progress-message): Dummy
	definitions to avoid compiler warnings if imenu can't be
	loaded.
	* cc-menus.el (cc-imenu-init): New function called at mode
	init.
	* cc-mode.el (c-mode, c++-mode, objc-mode, java-mode): Moved
	imenu initializations to cc-imenu-init.

Sun Feb 21 1999  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Slightly better check
	for lambda-intro-cont in Pike mode.  Case 6 changed.

	* cc-engine.el (c-looking-at-inexpr-block): Fixed bug where
	anything following "new Foo()" was considered an anonymous
	class body in Java mode.

Fri Feb 12 1999  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-line-break-function): When breaking in
	a string, don't insert a new line.

Sun Jan 31 1999  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-at-toplevel-p): New interface function which
	returns information useful to add-on authors.  It tells you
	whether you're at a toplevel statement or not.

Tue Dec 22 1998  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-line-break-function): It is possible
	that forward-line does not land us at the bol, say if we're on
	the last line in a file.  In that case, do a
	back-to-indentation instead of a forward-comment -1.

Fri Dec 11 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Don't catch
	"default:" as normal label in case 4.

Thu Dec 10 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Use c-bitfield-key to
	recognize continued bitfield declarations.  Case 5D.1 changed.
	* cc-langs.el: New variable c-bitfield-key.
	* cc-mode.el: New variable c-bitfield-key.

Wed Dec 09 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-inside-bracelist-p): Tighter test for Java
	anonymous array expressions (i.e. "new Foo[] {.. bracelist
	..}").

Sun Dec  6 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release 5.25

Mon Nov 18 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed some bugs with
	comments with tricky contents in obscure places inside
	bracelists.  Cases 5A.3 and 9C-D changed.

Mon Nov 11 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-inside-bracelist-p): Don't trip up on C++
	"operator[]".

Mon Oct 31 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Fixed bug where
	point would end up further down afterwards.  Recognize '@' as
	a prefix operator for Pike.

Mon Oct 24 1998  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-major-mode-is): New defsubst to encapsulate
	major-mode checking.

	* cc-cmds.el, cc-engine.el, cc-lang.el: All major-mode
	checking is now spelled (c-major-mode-is 'mode)

Mon Oct 23 1998  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-comment-indent): CASE 3: the looking-at should
	match against c-comment-start-regexp instead of comment-start.

	* cc-engine.el (c-inside-bracelist-p): Further
	dekludgification.  When in C++ mode and searching to see if
	we're in a template definition, don't get tripped up by
	#include <thing.h> syntax!

	* cc-mode.el (c-submit-bug-report): Add comment-column to list
	of variables reported.

Mon Oct 20 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Do not trip on
	whitespace when skipping backwards over characters that can
	start a statement.

Mon Oct 17 1998  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-inside-bracelist-p): Check for class open in
	Pike mode.

Mon Oct 16 1998  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-common-init): Make adaptive-fill-mode a
	buffer local variable and set it to nil.

Mon Oct 15 1998  Barry A. Warsaw  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-common-init): Implement the new semantics for
	c-default-style.

	* cc-mode.texi: Document the new semantics for c-default-style.

	* cc-vars.el (c-default-style): Slightly different default
	semantics when the value is an alist, and there's a new
